(function () {

  let template = createTemplate(
    `:host {
  --background-color: var(--control-background-color);
  --text-color: var(--control-text-color);
  --border-color: var(--control-border-color);
  position: relative;
  box-sizing: border-box;
  border-bottom: solid 1px var(--border-color);
  border-color: var(--border-color);
  background-color: var(--background-color);
  color: var(--text-color);
}
`,
  );

  Util.registerCustomElement(class ControlMobileProto1 extends ControlCommonProto1{

    static get properties(){
      let props=Util.merge(super.properties,{
        border_color:{
          palette:true,
        },
        height:{
          default: "32px",
        },
      });
      super.markProperiesAsDisabled(props,['dimensionsLimits','transform','rotation'],['text_height']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

  });

  ControlMobileProto1.defaultMobileHeight=Util.isMobile ? 44 : undefined;

})();

(function () {

  let template = createTemplate(
    `:host{--background-color:transparent;--text-color:var(--control-text-color);--border-color:var(--control-border-color);position:relative;box-sizing:border-box;border-bottom:solid 1px var(--border-color);border-color:var(--border-color);background-color:var(--background-color);color:var(--text-color)}`,
  );

  Util.registerCustomElement(class ControlMobileProto2 extends ControlCommonProto1{

    static get properties(){
      let props=Util.merge(super.properties,{
        border_color:{
          palette:true,
        },
        height:{
          default: "32px",
        },
      });
      super.markProperiesAsDisabled(props,['dimensionsLimits','transform','rotation'],['text_height']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

  });

  ControlMobileProto2.defaultMobileHeight=Util.isMobile ? 44 : undefined;

})();

(function () {

  if(locale("ru")){
  var $hint_hide_title="Скрыть текст заголовка";
}else{
  var $hint_hide_title="Hide title caption";
};


  let template = createTemplate(
    `:host{--background-color:var(--control-tint-color);--text-color:var(--control-contrast-color);padding:0;overflow:hidden}:host(.hide_title) #title{display:none}:host(.hide_title){padding:5px}#title{position:absolute;left:0;width:100%;bottom:0;padding:10px 10px 6px;box-sizing:border-box}`,
    `<div id="title"></div>`
  );

  Util.registerCustomElement(class ControlMobileHeader1 extends ControlMobileProto1{

    static get properties(){
      let props=Util.merge(super.properties,{
        name:{
          type:"string",
          target:'title',
          property:'innerHTML',
        },
        padding:{
          target:'title',
          style:true,
        },

        padding_left:{
          target:'title',
          style:true,
        },

        padding_top:{
          target:'title',
          style:true,
        },

        padding_right:{
          target:'title',
          style:true,
        },

        padding_bottom:{
          target:'title',
          style:true,
        },
        hide_title:{
          type:"number",
          hint:$hint_hide_title,
          css_class:true,
        },
        text_uppercase:{
          default:1,
        },
        // text_size:{
        //   default: 14,
        // },
      });
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

  });

})();
(function () {

  if(locale("ru")){
  var $name="Заголовок";
  var $hint_hide_title="Скрыть текст заголовка";
}else{
  var $name="Header";
  var $hint_hide_title="Hide title caption";
};


  let template = createTemplate(
    `:host {
  --background-color: var(--control-tint-color);
  --text-color: var(--control-contrast-color);
  padding: 0;
  overflow: hidden;
}
:host(.hide_title) #title {
  display: none;
}
:host(.hide_title) {
  padding: 5px;
}
#title {
  position: absolute;
  left: 0;
  width: 100%;
  bottom: 0;
  padding: 10px 10px 6px;
  box-sizing: border-box;
}
`,
    `<div id="title"></div>`
  );

  Util.registerCustomElement(class ControlMobileHeader2 extends ControlMobileProto1{

    static get properties(){
      let props=Util.merge(super.properties,{
        name:{
          type:"string",
          target:'title',
          property:'innerHTML',
          default:$name,
        },
        padding:{
          target:'title',
          style:true,
        },

        padding_left:{
          target:'title',
          style:true,
        },

        padding_top:{
          target:'title',
          style:true,
        },

        padding_right:{
          target:'title',
          style:true,
        },

        padding_bottom:{
          target:'title',
          style:true,
        },
        hide_title:{
          type:"number",
          hint:$hint_hide_title,
          css_class:true,
        },
        text_uppercase:{
          default:1,
        },
        height:{
          default:48,
        },
        width:{
          default:'100%',
        },

      });
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

  });

})();
(function () {

  if(locale("ru")){
  var $name='Поле ввода';
  var $hint_value="Значение поля ввода";
  var $hint_plus_minus="Кнопки +/-: 0 - нет, 1 - есть";
  var $hint_plus_minus_color="Цвет кнопок +/-";
  var $hint_plus_minus_step="Шаг изменения значения при нажатии кнопок +/-";
  var $hint_max_value="Максимально допустимое значение";
  var $hint_min_value="Минимально допустимое значение";
  var $hint_round="Округление";
  var $hint_editable="Редактируемое/нередактируемое поле ввода. Если поле ввода нередактируемое, изменение значения возможно только нажатием кнопок +/-. При этом доступно отображение префикса и единицы измерения. При редактируемом поле изменять значение можно с клавиатуры, но в этом случае невозможно отображение префикса и ед. изм. Значения: 0 - нередактируемое, 1 - редатируемое.";
  var $hint_prefix="Префикс. Отображается перед значением.";
  var $hint_suffix="Суффикс. Отображается после значения.";
}else{
  var $name='Input';
  var $hint_value="Input value";
  var $hint_plus_minus="Buttons +/-: 0 - disabled, 1 - enabled";
  var $hint_plus_minus_color="Buttons +/- color";
  var $hint_plus_minus_step="Value changing step by buttons +/-";
  var $hint_max_value="Maximum value";
  var $hint_min_value="Minimum value";
  var $hint_round="Rounding";
  var $hint_editable="Keyboard edit of value enabled/disabled. If parameter disabled then it's only allow to change value by buttons +/-, prefix label and unit are shown.  Otherwise, if parameter enabled it's allow to changing value directly by keyboard, but prefix label and unit are not shown. 0 - disabled, 1 - enabled.";
  var $hint_prefix="Prefix. Shown before value";
  var $hint_suffix="Suffix (unit). Shown after value";
};


  let template = createTemplate(
    `:host {
  --text-color: var(--control-text-color);
  --value-background-color: var(--control-background-color);
  --value-text-color: var(--control-text-color);
  --value-plus-minus-color: var(--control-border-color);
  --value-border-color: var(--control-border-color);
  --label-text-color: var(--text-color);
  display: flex;
  justify-content: space-between;
  align-items: center;
  position: relative;
  padding: 0px;
}
#title {
  display: block;
  position: relative;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
  padding: 10px;
}
#inputValue {
  --background-color: var(--value-background-color);
  --text-color: var(--value-text-color);
  --plus-minus-color: var(--value-plus-minus-color);
  display: block;
  height: 100%;
  position: relative;
  border: none;
  border-left: solid 1px var(--value-border-color);
  border-radius: 0px;
  flex-shrink: 0;
}
`,
    `<div id="title"></div>
<control-common-input1 id="inputValue"></control-common-input1>
`,
  );

  Util.registerCustomElement(class ControlMobileInput1 extends ControlMobileProto1{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          type:"string",
          target:'title',
          property:'innerHTML',
          default:$name,
        },

        padding:{
          target:'title',
          style:true,
        },

        padding_left:{
          target:'title',
          style:true,
        },

        padding_top:{
          target:'title',
          style:true,
        },

        padding_right:{
          target:'title',
          style:true,
        },

        padding_bottom:{
          target:'title',
          style:true,
        },

        value:{
          type:"number",
          default:0,
          hint:$hint_value,
          update:"forward_input_props",
        },

        plus_minus:{
          type:"number",
          default:1,
          hint:$hint_plus_minus,
          update:"forward_input_props",
        },

        plus_minus_step:{
          type:"number",
          default:1,
          visibleIf:"plus_minus=,1",
          hint:$hint_plus_minus_step,
          update:"forward_input_props",
        },

        max_value:{
          type:"number",
          hint:$hint_max_value,
          update:"forward_input_props",
        },

        min_value:{
          type:"number",
          hint:$hint_min_value,
          update:"forward_input_props",
        },

        round:{
          type:"number",
          hint:$hint_round,
          update:"forward_input_props",
        },

        editable:{
          type:"number",
          default:0,
          hint:$hint_editable,
          visibleIf:"plus_minus=,1",
          update:"forward_input_props",
        },

        prefix:{
          type:"string",
          hint:$hint_prefix,
          visibleIf:"editable=,0",
          update:"forward_input_props",
        },

        suffix:{
          type:"string",
          hint:$hint_suffix,
          visibleIf:"editable=,0",
          update:"forward_input_props",
        },

        value_width:{
          default:120,
          type:"number",
          property:"width",
          target:"inputValue",
        },

        value_size:{
          type:"number",
          default:14,
          property:"text_size",
          target:"inputValue",
        },

        value_bold:{
          type:"number",
          default:0,
          property:"text_bold",
          target:"inputValue",
        },

        value_uppercase:{
          type:"number",
          default:0,
          property:"text_uppercase",
          target:"inputValue",
        },

        border_color:{
          type:'string',
          palette:true,
        },

        value_plus_minus_color:{
          type:"string",
          visibleIf:"plus_minus=,1",
          palette:true,
        },

        value_background_color:{
          type:"string",
          palette:true,
        },

        value_text_color:{
          type:"string",
          palette:true,
        },



      });
      super.markProperiesAsDisabled(props,['click']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
      self.dom.inputValue.addEventListener('change',self.onInputChange.bind(self));
    }

    onInputChange(e){
      let self=this;
      self.value=e.detail;
    }

    forward_props(control,changes){
      let self=this;
      for(let i of changes){
        self.dom[control][i]=self[`__${i}`];
      }
    }

    forward_input_props(changes){
      let self=this;
      self.forward_props('inputValue',changes);
    }



  });

})();
(function () {

  if(locale("ru")){
  var $name='Поле ввода';
  var $hint_value="Значение поля ввода";
  var $hint_plus_minus="Кнопки +/-: 0 - нет, 1 - есть";
  var $hint_plus_minus_color="Цвет кнопок +/-";
  var $hint_plus_minus_step="Шаг изменения значения при нажатии кнопок +/-";
  var $hint_max_value="Максимально допустимое значение";
  var $hint_min_value="Минимально допустимое значение";
  var $hint_round="Округление";
  var $hint_editable="Редактируемое/нередактируемое поле ввода. Если поле ввода нередактируемое, изменение значения возможно только нажатием кнопок +/-. При этом доступно отображение префикса и единицы измерения. При редактируемом поле изменять значение можно с клавиатуры, но в этом случае невозможно отображение префикса и ед. изм. Значения: 0 - нередактируемое, 1 - редатируемое.";
  var $hint_prefix="Префикс. Отображается перед значением.";
  var $hint_suffix="Суффикс. Отображается после значения.";
}else{
  var $name='Input';
  var $hint_value="Input value";
  var $hint_plus_minus="Buttons +/-: 0 - disabled, 1 - enabled";
  var $hint_plus_minus_color="Buttons +/- color";
  var $hint_plus_minus_step="Value changing step by buttons +/-";
  var $hint_max_value="Maximum value";
  var $hint_min_value="Minimum value";
  var $hint_round="Rounding";
  var $hint_editable="Keyboard edit of value enabled/disabled. If parameter disabled then it's only allow to change value by buttons +/-, prefix label and unit are shown.  Otherwise, if parameter enabled it's allow to changing value directly by keyboard, but prefix label and unit are not shown. 0 - disabled, 1 - enabled.";
  var $hint_prefix="Prefix. Shown before value";
  var $hint_suffix="Suffix (unit). Shown after value";
};


  let template = createTemplate(
    `:host{--text-color:var(--control-text-color);--value-background-color:var(--control-background-color);--value-text-color:var(--control-contrast-color);--value-plus-minus-color:var(--control-border-color);--value-border-color:var(--control-border-color);--label-text-color:var(--text-color);display:flex;justify-content:space-between;align-items:center;position:relative;padding:0}#title{display:block;position:relative;text-overflow:ellipsis;overflow:hidden;white-space:nowrap;padding:10px}#inputValue{--background-color:var(--value-background-color);--text-color:var(--value-text-color);--plus-minus-color:var(--value-plus-minus-color);display:block;height:100%;position:relative;border:none;border-left:solid 1px var(--value-border-color);border-radius:0;flex-shrink:0}`,
    `<div id="title"></div>
<control-common-input1 id="inputValue"></control-common-input1>
`,
  );

  Util.registerCustomElement(class ControlMobileInput2 extends ControlMobileProto2{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          type:"string",
          target:'title',
          property:'innerHTML',
          default:$name,
        },

        padding:{
          target:'title',
          style:true,
        },

        padding_left:{
          target:'title',
          style:true,
        },

        padding_top:{
          target:'title',
          style:true,
        },

        padding_right:{
          target:'title',
          style:true,
        },

        padding_bottom:{
          target:'title',
          style:true,
        },

        value:{
          type:"number",
          default:0,
          hint:$hint_value,
          update:"forward_input_props",
        },

        plus_minus:{
          type:"number",
          default:1,
          hint:$hint_plus_minus,
          update:"forward_input_props",
        },

        plus_minus_step:{
          type:"number",
          default:1,
          visibleIf:"plus_minus=,1",
          hint:$hint_plus_minus_step,
          update:"forward_input_props",
        },

        max_value:{
          type:"number",
          hint:$hint_max_value,
          update:"forward_input_props",
        },

        min_value:{
          type:"number",
          hint:$hint_min_value,
          update:"forward_input_props",
        },

        round:{
          type:"number",
          hint:$hint_round,
          update:"forward_input_props",
        },

        editable:{
          type:"number",
          default:0,
          hint:$hint_editable,
          visibleIf:"plus_minus=,1",
          update:"forward_input_props",
        },

        prefix:{
          type:"string",
          hint:$hint_prefix,
          visibleIf:"editable=,0",
          update:"forward_input_props",
        },

        suffix:{
          type:"string",
          hint:$hint_suffix,
          visibleIf:"editable=,0",
          update:"forward_input_props",
        },

        value_width:{
          default:120,
          type:"number",
          property:"width",
          target:"inputValue",
        },

        value_size:{
          type:"number",
          property:"text_size",
          target:"inputValue",
          default:Util.isMobile?16:12,
        },

        value_bold:{
          type:"number",
          default:0,
          property:"text_bold",
          target:"inputValue",
        },

        value_uppercase:{
          type:"number",
          default:0,
          property:"text_uppercase",
          target:"inputValue",
        },

        border_color:{
          type:'string',
          palette:true,
        },

        border_bottom_width:{
          default:1,
        },

        value_plus_minus_color:{
          type:"string",
          visibleIf:"plus_minus=,1",
          palette:true,
        },

        value_background_color:{
          type:"string",
          palette:true,
          default:'transparent',
        },

        value_text_color:{
          type:"string",
          palette:true,
        },
        height:{
          default:ControlMobileProto1.defaultMobileHeight,
        },
        width: {
          default: '100%'
        }

      });
      super.markProperiesAsDisabled(props,['click']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
      self.dom.inputValue.addEventListener('change',self.onInputChange.bind(self));
    }

    onInputChange(e){
      let self=this;
      self.value=e.detail;
    }

    forward_props(control,changes){
      let self=this;
      for(let i of changes){
        self.dom[control][i]=self[`__${i}`];
      }
    }

    forward_input_props(changes){
      let self=this;
      self.forward_props('inputValue',changes);
    }



  });

})();
(function () {

  if(locale("ru")){
  var $name='Надпись';
  var $hint_value_color="Цвет значения";
  var $hint_value_bold="Жирный шрифт значения. 1 - вкл, 0 - откл.";
  var $hint_list="Элементы списка и их значения, пример:<br><br>0=Откл,1=Вкл,2=Авто,*=Ошибка<br><br>При использовании списка в тексте надписи будет выводится строка, соответствующая числовому значению в поле value. Для всех других числовых значений будет выводиться строка соответствующая звездочке (*)";
  var $hint_prefix="Префикс. Отображается перед значением.";
  var $hint_suffix="Суффикс. Отображается после значения.";
}else{
  var $name='Label';
  var $hint_value_color="Value color";
  var $hint_value_bold="Bold font for value. 1 - enable, 0 - disabled.";
  var $hint_list="Map list for values, for example: <br><br>0=Off,1=On,2=Auto,*=Error<br><br> This option allow to showing list item, which according to value. For all not existing values in list, will be shown item under star(*) sign";
  var $hint_prefix="Prefix. Shown before value";
  var $hint_suffix="Suffix (unit). Shown after value";
};


  let template = createTemplate(
    `:host {
  --text-color: var(--control-text-color);
  --value-color: var(--control-text-color);
  --host_height: var(--height, 36);
  display: flex;
  justify-content: space-between;
  align-items: center;
  height: var(--host_height);
}
#value {
  color: var(--value-color);
  font-weight: normal;
  white-space: nowrap;
  position: relative;
}
#title {
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
}
#value._link {
  box-sizing: border-box;
  min-height: 16px;
  padding-right: 25px;
}
#value._link ._link1,
#value._link ._link2 {
  display: block;
}
#value ._link1 {
  display: none;
  background: var(--value-color);
  position: absolute;
  width: 10px;
  height: 2px;
  right: 10px;
  top: 5px;
  transform: rotate(45deg);
}
#value ._link2 {
  display: none;
  background: var(--value-color);
  position: absolute;
  width: 10px;
  height: 2px;
  right: 10px;
  top: 11px;
  transform: rotate(-45deg);
}
`,
    `<div id="title"></div>
<div id="value">
  <div id="valueText"></div>
  <div class="_link1"></div>
  <div class="_link2"></div>
</div>
`,
  );

  Util.registerCustomElement(class ControlMobileLabel1 extends ControlMobileProto1{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          default:$name,
          type:"string",
        },

        value:{
          type:"string",
          update:"update_label",
        },

        value_color:{
          type:"string",
          palette:true,
          hint:$hint_value_color,
        },

        value_bold:{
          type:"number",
          hint:$hint_value_bold,
        },

        list:{
          type:"string",
          hint:$hint_list,
          update:"update_label",
        },

        prefix:{
          type:"string",
          hint:$hint_prefix,
          default:"",
          update:"update_label",
        },

        suffix:{
          type:"string",
          hint:$hint_suffix,
          default:"",
          update:"update_label",
        },

        round:{
          type:"number",
          update:"update_label",
        },

        fixed:{
          type:"number",
          update:"update_label",
        },

        padding:{
          default:10,
        },
        // text_size:{
        //   default: 14,
        // },

        height:{
          default:undefined,
        }

      });
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

    update_label(){
      let self=this;
      let v=self.__value;

      if(self.__round!==undefined){
        if(Util.isNumeric(v)){
          v=Util.round(v,self.__round);
        }
      }

      if(self.__fixed!==undefined){
        if(Util.isNumeric(v)){
          v=v*1;
          v=v.toFixed(self.__fixed);
        }
      }

      let list=Util.parseList(self.__list);
      let lv=Util.getListValue(list,v);
      let t="";
      if(lv!==undefined){
        t=lv;
      }else{
        if(v!=='' && v!==undefined){
          t=v+'';
          t=t.split("\n").join("<br>");
        }
      }
      t=self.__prefix+(t+"")+self.__suffix;


      self.dom.valueText.innerHTML=t;
    }

    update_name(){
      let self=this;
      let t=(self.__name)?self.__name.split("\n").join("<br>"):"";
      self.dom.title.innerHTML=t;
    }

    update_value_bold(){
      let self=this;
      self.dom.valueText.style.fontWeight=self.__value_bold?"bold":"";
    }

    update_click(){
      let self=this;
      if(self.__click && (
        self.__click === "gotoScreen" ||
        self.__click === "gotoLink")){
        self.dom.value.classList.add("_link");
      }else{
        self.dom.value.classList.remove("_link");
      }
    }

  });

})();
(function () {

  if(locale("ru")){
  var $name='Надпись';
  var $hint_value_color="Цвет значения";
  var $hint_value_bold="Жирный шрифт значения. 1 - вкл, 0 - откл.";
  var $hint_list="Элементы списка и их значения, пример:<br><br>0=Откл,1=Вкл,2=Авто,*=Ошибка<br><br>При использовании списка в тексте надписи будет выводится строка, соответствующая числовому значению в поле value. Для всех других числовых значений будет выводиться строка соответствующая звездочке (*)";
  var $hint_prefix="Префикс. Отображается перед значением.";
  var $hint_suffix="Суффикс. Отображается после значения.";
  var $hint_round="Округление до указанного знака после запятой";
  var $hint_fixed="Фиксированное количество знаков после запятой";
}else{
  var $name='Label';
  var $hint_value_color="Value color";
  var $hint_value_bold="Bold font for value. 1 - enable, 0 - disabled.";
  var $hint_list="Map list for values, for example: <br><br>0=Off,1=On,2=Auto,*=Error<br><br> This option allow to showing list item, which according to value. For all not existing values in list, will be shown item under star(*) sign";
  var $hint_prefix="Prefix. Shown before value";
  var $hint_suffix="Suffix (unit). Shown after value";
  var $hint_round="Round to the specified decimal place";
  var $hint_fixed="Fixed number of decimal places";
};


  let template = createTemplate(
    `:host{--text-color:var(--control-text-color);--value-color:var(--control-text-color);--host_height:var(--height,36);display:flex;justify-content:space-between;align-items:center;height:var(--host_height)}#value{color:var(--value-color);font-weight:400;white-space:nowrap;position:relative}#title{text-overflow:ellipsis;overflow:hidden;white-space:nowrap}#value._link{box-sizing:border-box;min-height:16px;padding-right:25px}#value._link #valueText{margin-right:10px}#value._link ._link1,#value._link ._link2{display:block}#value ._link1{display:none;background:var(--value-color);position:absolute;width:10px;height:2px;right:10px;top:50%;margin-top:-4px;transform:rotate(45deg)}#value ._link2{display:none;background:var(--value-color);position:absolute;width:10px;height:2px;right:10px;top:50%;margin-top:2px;transform:rotate(-45deg)}`,
    `<div id="title"></div>
<div id="value">
  <div id="valueText"></div>
  <div class="_link1"></div>
  <div class="_link2"></div>
</div>
`,
  );

  Util.registerCustomElement(class ControlMobileLabel2 extends ControlMobileProto2{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          default:$name,
          type:"string",
        },

        value:{
          type:"string",
          update:"update_label",
        },

        value_color:{
          type:"string",
          palette:true,
          hint:$hint_value_color,
        },

        value_bold:{
          type:"number",
          hint:$hint_value_bold,
        },

        list:{
          type:"string",
          hint:$hint_list,
          update:"update_label",
        },

        prefix:{
          type:"string",
          hint:$hint_prefix,
          default:"",
          update:"update_label",
        },

        suffix:{
          type:"string",
          hint:$hint_suffix,
          default:"",
          update:"update_label",
        },

        round:{
          type:"number",
          hint:$hint_round,
          update:"update_label",
        },

        fixed:{
          type:"number",
          hint:$hint_fixed,
          update:"update_label",
        },

        padding:{
          default:10,
        },
        
        border_bottom_width:{
          default:1,
        },
        height:{
          default:ControlMobileProto1.defaultMobileHeight,
        },
        width: {
          default: '100%'
        }

      });
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

    update_label(){
      let self=this;
      let v=self.__value;

      if(self.__round!==undefined){
        if(Util.isNumeric(v)){
          v=Util.round(v,self.__round);
        }
      }

      if(self.__fixed!==undefined){
        if(Util.isNumeric(v)){
          v=v*1;
          v=v.toFixed(self.__fixed);
        }
      }

      let list=Util.parseList(self.__list);
      let lv=Util.getListValue(list,v);
      let t="";
      if(lv!==undefined){
        t=lv;
      }else{
        if(v!=='' && v!==undefined){
          t=v+'';
          t=t.split("\n").join("<br>");
        }
      }
      t=self.__prefix+(t+"")+self.__suffix;


      self.dom.valueText.innerHTML=t;
    }

    update_name(){
      let self=this;
      let t=(self.__name)?self.__name.split("\n").join("<br>"):"";
      self.dom.title.innerHTML=t;
    }

    update_value_bold(){
      let self=this;
      self.dom.valueText.style.fontWeight=self.__value_bold?"bold":"";
    }

    update_click(){
      let self=this;
      super.update_click();
      if(self.__click && (
        self.__click === "gotoScreen" ||
        self.__click === "gotoLink")){
        self.dom.value.classList.add("_link");
      }else{
        self.dom.value.classList.remove("_link");
      }
    }

  });

})();
(function () {

  if(locale("ru")){
  var $hint_value="Управление статусом лампы";
  var $hint_on_value="Значение для включенной лампы";
  var $hint_off_value="Значение для выключенной лампы";
  var $hint_on_color="Цвет включенной лампы";
  var $hint_off_color="Цвет выключенной лампы";
  var $hint_size="Размер лампы";
  var $hint_off_style="Стиль выключенной лампы: border_only - только обод, visible - лампа видна, invisible - лампа невидима";
}else{
  var $hint_value="Lamp state manage";
  var $hint_on_value="Value for on lamp";
  var $hint_off_value="Value for off lamp";
  var $hint_on_color="Color for on lamp";
  var $hint_off_color="Color for off lamp";
  var $hint_size="Lamp size";
  var $hint_off_style="Style for off lamp";
};


  let template = createTemplate(
    `:host {
  --on-color: var(--control-on-color);
  --off-color: var(--control-off-color);
  --lamp-on-color: var(--on-color);
  --lamp-off-color: var(--off-color);
  --lamp-text-color: var(--text-color);
  display: flex;
  justify-content: space-between;
  align-items: center;
  position: relative;
  padding: 10px;
}
#title {
  display: block;
  position: relative;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
}
#lamp {
  --on-color: var(--lamp-on-color);
  --off-color: var(--lamp-off-color);
}
`,
    `<div id="title"></div>
<control-common-lamp1 id="lamp"></control-common-lamp1>
`,
  );

  Util.registerCustomElement(class ControlMobileLamp1 extends ControlMobileProto1{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          type:"string",
          target:'title',
          property:'innerHTML',
        },

        value:{
          default:0,
          type:"number",
          hint:$hint_value,
          update:'forward_lamp_props',
        },

        value_on:{
          type:"number",
          hint:$hint_on_value,
          update:'forward_lamp_props',
        },

        value_off:{
          type:"number",
          hint:$hint_off_value,
          update:'forward_lamp_props',
        },

        on_color:{
          type:'string',
          hint:$hint_on_color,
          palette:true,
        },

        off_color:{
          type:'string',
          hint:$hint_off_color,
          palette:true,
        },

        size:{
          type:'number',
          default:20,
          css_var:true,
          hint:$hint_size,
          update:'forward_lamp_props',
        },

        off_style:{
          type:'string',
          options:['border_only','visible','invisible'],
          default:'border_only',
          hint:$hint_off_style,
        },

        height:{
          default:undefined,
        }

      });
      super.markProperiesAsDisabled(props,[],['click']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

    forward_props(control,changes){
      let self=this;
      for(let i of changes){
        self.dom[control][i]=self[`__${i}`];
      }
    }


    forward_lamp_props(changes){
      let self=this;
      self.forward_props('lamp',changes);
    }

    update_off_style(){
      let self=this;
      let lamp=self.dom.lamp;
      setTimeout(()=>{
        let svg=lamp.shadowRoot.getElementById("svg");
        for(let i of self.properties.off_style.options){
          svg.classList.remove('off_style_'+i);
        }
        svg.classList.add('off_style_'+self.__off_style);
      },0);
    }


  });

})();
(function () {

  if(locale("ru")){
  var $name="Лампа";
  var $hint_value="Управление статусом лампы";
  var $hint_on_value="Значение для включенной лампы";
  var $hint_off_value="Значение для выключенной лампы";
  var $hint_on_color="Цвет включенной лампы";
  var $hint_off_color="Цвет выключенной лампы";
  var $hint_size="Размер лампы";
  var $hint_off_style="Стиль выключенной лампы: border_only - только обод, visible - лампа видна, invisible - лампа невидима";
}else{
  var $name='Lamp';
  var $hint_value="Lamp state manage";
  var $hint_on_value="Value for on lamp";
  var $hint_off_value="Value for off lamp";
  var $hint_on_color="Color for on lamp";
  var $hint_off_color="Color for off lamp";
  var $hint_size="Lamp size";
  var $hint_off_style="Style for off lamp";
};


  let template = createTemplate(
    `:host {
  --on-color: var(--control-on-color);
  --off-color: var(--control-off-color);
  --lamp-on-color: var(--on-color);
  --lamp-off-color: var(--off-color);
  --lamp-text-color: var(--text-color);
  display: flex;
  justify-content: space-between;
  align-items: center;
  position: relative;
  padding: 10px;
}
#title {
  display: block;
  position: relative;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
}
#lamp {
  --on-color: var(--lamp-on-color);
  --off-color: var(--lamp-off-color);
}
`,
    `<div id="title"></div>
<control-common-lamp1 id="lamp"></control-common-lamp1>
`,
  );

  Util.registerCustomElement(class ControlMobileLamp2 extends ControlMobileProto2{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          type:"string",
          target:'title',
          property:'innerHTML',
          default:$name,
        },

        value:{
          default:0,
          type:"number",
          hint:$hint_value,
          update:'forward_lamp_props',
        },

        value_on:{
          type:"number",
          hint:$hint_on_value,
          update:'forward_lamp_props',
        },

        value_off:{
          type:"number",
          hint:$hint_off_value,
          update:'forward_lamp_props',
        },

        on_color:{
          type:'string',
          hint:$hint_on_color,
          palette:true,
        },

        off_color:{
          type:'string',
          hint:$hint_off_color,
          palette:true,
        },

        size:{
          type:'number',
          default:20,
          css_var:true,
          hint:$hint_size,
          update:'forward_lamp_props',
        },

        off_style:{
          type:'string',
          options:['border_only','visible','invisible'],
          default:'border_only',
          hint:$hint_off_style,
        },

        height:{
          default:ControlMobileProto1.defaultMobileHeight,
        },
        width: {
          default: '100%'
        },

        border_bottom_width:{
          default:1,
        },

      });
      super.markProperiesAsDisabled(props,['click']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

    forward_props(control,changes){
      let self=this;
      for(let i of changes){
        self.dom[control][i]=self[`__${i}`];
      }
    }


    forward_lamp_props(changes){
      let self=this;
      self.forward_props('lamp',changes);
    }

    update_off_style(){
      let self=this;
      let lamp=self.dom.lamp;
      setTimeout(()=>{
        let svg=lamp.shadowRoot.getElementById("svg");
        for(let i of self.properties.off_style.options){
          svg.classList.remove('off_style_'+i);
        }
        svg.classList.add('off_style_'+self.__off_style);
      },0);
    }


  });

})();
(function () {

  let template = createTemplate(
    `:host {
  --background-color: var(--control-background-color);
  --text-color: var(--control-text-color);
  --border-color: var(--control-border-color);
  position: relative;
  box-sizing: border-box;
  border-bottom: solid 1px var(--border-color);
  border-color: var(--border-color);
  background-color: var(--background-color);
  color: var(--text-color);
}
`,
  );

  Util.registerCustomElement(class ControlMobileProto1 extends ControlCommonProto1{

    static get properties(){
      let props=Util.merge(super.properties,{
        border_color:{
          palette:true,
        },
        height:{
          default: "32px",
        },
      });
      super.markProperiesAsDisabled(props,['dimensionsLimits','transform','rotation'],['text_height']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

  });

  ControlMobileProto1.defaultMobileHeight=Util.isMobile ? 44 : undefined;

})();
(function () {

  let template = createTemplate(
    `:host{--background-color:transparent;--text-color:var(--control-text-color);--border-color:var(--control-border-color);position:relative;box-sizing:border-box;border-bottom:solid 1px var(--border-color);border-color:var(--border-color);background-color:var(--background-color);color:var(--text-color)}`,
  );

  Util.registerCustomElement(class ControlMobileProto2 extends ControlCommonProto1{

    static get properties(){
      let props=Util.merge(super.properties,{
        border_color:{
          palette:true,
        },
        height:{
          default: "32px",
        },
      });
      super.markProperiesAsDisabled(props,['dimensionsLimits','transform','rotation'],['text_height']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
    }

  });

  ControlMobileProto2.defaultMobileHeight=Util.isMobile ? 44 : undefined;

})();
(function () {

  if(locale("ru")){
  var $hint_value="Связанная переменная";
  var $hint_list="Элементы списка и их значения, пример:<br>0=Откл<br>1=Вкл<br>2=Авто";
}else{
  var $hint_value="Linked variable";
  var $hint_list="List's elements and its values, for intance:<br>0=Off<br>1=On<br>2=Auto";
};


  let template = createTemplate(
    `:host {
  --background-color: var(--control-background-color);
  --text-color: var(--control-text-color);
  --border-color: var(--control-border-color);
  --value-border-color: var(--control-border-color);
  --value-background-color: var(--control-background-color);
  --value-text-color: var(--control-text-color);
  --padding: 10px;
  --value-padding: var(--padding);
  display: flex;
  justify-content: space-between;
  align-items: center;
  position: relative;
  padding: 0px;
}
:host #title {
  display: block;
  position: relative;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
  padding: var(--padding);
}
:host #value {
  --border-color: var(--value-border-color);
  --background-color: var(--value-background-color);
  --text-color: var(--value-text-color);
  --padding: 0px var(--value-padding);
  display: block;
  height: 100%;
  position: relative;
  border: none;
  border-left: solid 1px var(--value-border-color);
  background-color: var(--value-background-color);
  border-radius: 0px;
  flex-shrink: 0;
}
`,
    `<div id="title"></div>
<control-common-select1 id="value"></control-common-select1>
`,
  );

  Util.registerCustomElement(class ControlMobileSelect1 extends ControlMobileProto1{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          type:"string",
          target:'title',
          property:'innerHTML',
        },

        padding:{
          target:'title',
          style:true,
        },

        padding_left:{
          target:'title',
          style:true,
        },

        padding_top:{
          target:'title',
          style:true,
        },

        padding_right:{
          target:'title',
          style:true,
        },

        padding_bottom:{
          target:'title',
          style:true,
        },

        value:{
          type:"number",
          default:0,
          hint:$hint_value,
          update:"forward_select_props",
        },

        list:{
          default:"0=Откл\n1=Вкл\n2=Авто",
          type:"string",
          hint:$hint_list,
          update:"forward_select_props",
        },

        value_width:{
          type:"number",
          property:"width",
          target:"value",
        },

        value_background_color:{
          type:"string",
          palette:true,
        },

        value_size:{
          type:"number",
          //default:14,
          property:"text_size",
          target:"value",
        },

        value_color:{
          type:"string",
          css_var:"text-color",
          target:"value",
        },

        value_bold:{
          type:"number",
          default:0,
          property:"text_bold",
          target:"value",
        },

        value_uppercase:{
          type:"number",
          default:0,
          property:"text_uppercase",
          target:"value",
        },

        border_color:{
          type:'string',
          palette:true,
        },

      });
      super.markProperiesAsDisabled(props,['click']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
      self.dom.value.addEventListener('change',self.onSelectChange.bind(self));
    }

    onSelectChange(e){
      let self=this;
      self.value=e.detail;
    }

    forward_props(control,changes){
      let self=this;
      for(let i of changes){
        self.dom[control][i]=self[`__${i}`];
      }
    }

    forward_select_props(changes){
      let self=this;
      self.forward_props('value',changes);
    }



  });

})();
(function () {

	if(locale("ru")){
  var $name="Список";
  var $hint_value="Связанная переменная";
  var $hint_list="Элементы списка и их значения, пример:<br>0=Откл<br>1=Вкл<br>2=Авто";
}else{
  var $name='List';
  var $hint_value="Linked variable";
  var $hint_list="List's elements and its values, for intance:<br>0=Off<br>1=On<br>2=Auto";
};


	let template = createTemplate(
		`:host{--value-border-color:var(--control-border-color);--value-text-color:var(--control-contrast-color);--value-background-color:var(--control-background-color);--padding:10px;--value-padding:0 10px;display:flex;justify-content:space-between;align-items:center;position:relative;padding:0}:host #title{display:block;position:relative;text-overflow:ellipsis;overflow:hidden;white-space:nowrap;padding:var(--padding)}:host #value{border:none;background-color:var(--value-background-color);border-left:solid 1px var(--value-border-color);height:100%;position:relative;padding:var(--value-padding);box-sizing:border-box}:host #select{background-color:var(--value-background-color);color:var(--value-text-color);border:none;-moz-appearance:unset;text-transform:inherit;text-decoration:inherit;font-weight:inherit;font-family:inherit;font-size:inherit;display:block;height:100%;position:relative;width:100%;border-radius:0;flex-shrink:0}:host #select:focus{outline:0}`,
		`<div id="title"></div>
<div id="value"><select id="select"></select></div>
`,
	);

	Util.registerCustomElement(class ControlMobileSelect2 extends ControlMobileProto2{

		static get properties(){
			let props=Util.merge(super.properties,{

				name:{
					type:"string",
					target:'title',
					property:'innerHTML',
					default:$name,
				},

				padding:{
					target:'title',
					style:true,
				},

				padding_left:{
					target:'title',
					style:true,
				},

				padding_top:{
					target:'title',
					style:true,
				},

				padding_right:{
					target:'title',
					style:true,
				},

				padding_bottom:{
					target:'title',
					style:true,
				},

				value:{
					type:"number",
					default:0,
					hint:$hint_value,
				},

				list:{
					default:"0=Откл\n1=Вкл\n2=Авто",
					type:"string",
					hint:$hint_list,
				},

				value_width:{
					type:"number",
					css_style:"width",
					target:"value",
				},

				value_background_color:{
					type:"string",
					palette:true,
				},
				
				value_size:{
					type:"number",
					//default:14,
					css_style:"font-size",
					target:"select",
				},
				
				value_align:{
					type:"string",
					css_style:"text-align",
					default:'left',
					options:['left','center','right'],
					target:"select",
				},

				value_color:{
					type:"string",
					css_style:"color",
					target:"select",
				},
				
				value_bold:{
					type:"number",
					default:0,
					css_style:"font-weight",
					map:{0:'',1:'bold'},
					target:"select",
				},

				value_uppercase:{
					type:"number",
					default:0,
					css_style:"text-transform",
					map:{0:'',1:'uppercase'},
					target:"select",
				},

				border_color:{
					type:'string',
					palette:true,
				},

				border_bottom_width:{
					default:1,
				},

				height:{
					default:ControlMobileProto1.defaultMobileHeight,
				},
				width: {
					default: '100%'
				}

			});
			super.markProperiesAsDisabled(props,['click']);
			return props;
		}

		create(){
			super.create();
			let self=this;
			self.append(template);
			self._select=self.dom.select;
			self._select.onchange=function (e) {
				let i=self._select.options.selectedIndex;
				if(self._select.options[i].value!==undefined){
					self.value=self._select.options[i].value;
					self.fire('change',self.value);
				}
			};
		}

		update_value(){
			let self=this;
			self._select.value=self.__value;
		}

		update_list(){
			let self=this;
			self._select.innerHTML="";
			let a=Util.parseList(self.__list);
			for(let i in a){
				let o = document.createElement('option');
				o.value=i;
				o.text=a[i];
				self._select.appendChild(o);
			}
			self.update_value();
		}

	});

})();
(function () {

  if(locale("ru")){
  var $name="Переключатель";
  var $hint_value="Управление статусом переключателя";
  var $hint_on_value="Значение для включенного переключателя";
  var $hint_off_value="Значение для выключенного переключателя";
  var $hint_on_color="Цвет фона включенного переключателя";
  var $hint_off_color="Цвет фона выключенного переключателя";
  var $hint_handle_on_color="Цвет бегунка включенного переключателя";
  var $hint_handle_off_color="Цвет бегунка выключенного переключателя";
}else{
  var $name="Switch";
  var $hint_value="Manage state of switch";
  var $hint_on_value="Value for on switch";
  var $hint_off_value="Value for off switch";
  var $hint_on_color="Background color for on switch";
  var $hint_off_color="Background color for off switch";
  var $hint_handle_on_color="Switch on pin color";
  var $hint_handle_off_color="Switch off pin color";
};


  let template = createTemplate(
    `:host {
  --on-color: var(--control-on-color);
  --off-color: var(--control-off-color);
  --handle-on-color: var(--control-contrast-color);
  --handle-off-color: var(--control-contrast-color);
  --text-color: var(--control-text-color);
  --switch-on-color: var(--on-color);
  --switch-off-color: var(--off-color);
  --switch-handle-on-color: var(--handle-on-color);
  --switch-handle-off-color: var(--handle-off-color);
  display: flex;
  justify-content: space-between;
  align-items: center;
  position: relative;
  padding: 10px;
}
#title {
  display: block;
  position: relative;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
}
#switch {
  --on-color: var(--switch-on-color);
  --off-color: var(--switch-off-color);
  --handle-on-color: var(--switch-handle-on-color);
  --handle-off-color: var(--switch-handle-off-color);
}
`,
    `<div id="title"></div>
<control-common-switch1 id="switch"></control-common-switch1>
`,
  );

  Util.registerCustomElement(class ControlMobileSwitch1 extends ControlMobileProto1{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          type:"string",
          target:'title',
          property:'innerHTML',
          default:$name,
        },

        value:{
          default:0,
          type:"number",
          hint:$hint_value,
          update:'forward_switch_props',
        },

        value_on:{
          type:"number",
          hint:$hint_on_value,
          update:'forward_switch_props',
        },

        value_off:{
          type:"number",
          hint:$hint_off_value,
          update:'forward_switch_props',
        },

        on_color:{
          type:"string",
          hint:$hint_on_color,
          palette:true,
        },
        off_color:{
          type:"string",
          hint:$hint_off_color,
          palette:true,
        },
        handle_on_color:{
          type:"string",
          hint:$hint_handle_on_color,
          palette:true,
        },
        handle_off_color:{
          type:"string",
          hint:$hint_handle_off_color,
          palette:true,
        },

      });
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
      self.dom.switch.addEventListener('change',self.onSwitchChange.bind(self));
    }

    onSwitchChange(e){
      let self=this;
      self.value=e.detail;
    }

    forward_props(control,changes){
      let self=this;
      for(let i of changes){
        self.dom[control][i]=self[`__${i}`];
      }
    }


    forward_switch_props(changes){
      let self=this;
      self.forward_props('switch',changes);
    }



  });

})();
(function () {

  if(locale("ru")){
  var $name="Переключатель";
  var $hint_value="Управление статусом переключателя";
  var $hint_on_value="Значение для включенного переключателя";
  var $hint_off_value="Значение для выключенного переключателя";
  var $hint_on_color="Цвет фона включенного переключателя";
  var $hint_off_color="Цвет фона выключенного переключателя";
  var $hint_handle_on_color="Цвет бегунка включенного переключателя";
  var $hint_handle_off_color="Цвет бегунка выключенного переключателя";
}else{
  var $name="Switch";
  var $hint_value="Manage state of switch";
  var $hint_on_value="Value for on switch";
  var $hint_off_value="Value for off switch";
  var $hint_on_color="Background color for on switch";
  var $hint_off_color="Background color for off switch";
  var $hint_handle_on_color="Switch on pin color";
  var $hint_handle_off_color="Switch off pin color";
};


  let template = createTemplate(
    `:host{--on-color:var(--control-on-color);--off-color:var(--control-off-color);--handle-on-color:var(--control-contrast-color);--handle-off-color:var(--control-contrast-color);--text-color:var(--control-text-color);--switch-on-color:var(--on-color);--switch-off-color:var(--off-color);--switch-handle-on-color:var(--handle-on-color);--switch-handle-off-color:var(--handle-off-color);display:flex;justify-content:space-between;align-items:center;position:relative;padding:10px}#title{display:block;position:relative;text-overflow:ellipsis;overflow:hidden;white-space:nowrap}#switch{--on-color:var(--switch-on-color);--off-color:var(--switch-off-color);--handle-on-color:var(--switch-handle-on-color);--handle-off-color:var(--switch-handle-off-color)}`,
    `<div id="title"></div>
<control-common-switch1 id="switch"></control-common-switch1>
`,
  );

  Util.registerCustomElement(class ControlMobileSwitch2 extends ControlMobileProto1{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          type:"string",
          target:'title',
          property:'innerHTML',
          default:$name,
        },

        value:{
          default:0,
          type:"number",
          hint:$hint_value,
          update:'forward_switch_props',
        },

        value_on:{
          type:"number",
          hint:$hint_on_value,
          update:'forward_switch_props',
        },

        value_off:{
          type:"number",
          hint:$hint_off_value,
          update:'forward_switch_props',
        },

        on_color:{
          type:"string",
          hint:$hint_on_color,
          palette:true,
        },
        off_color:{
          type:"string",
          hint:$hint_off_color,
          palette:true,
        },
        handle_on_color:{
          type:"string",
          hint:$hint_handle_on_color,
          palette:true,
        },
        handle_off_color:{
          type:"string",
          hint:$hint_handle_off_color,
          palette:true,
        },
        border_bottom_width:{
          default:1,
        },
        height:{
          default:ControlMobileProto1.defaultMobileHeight,
        },
        width: {
          default: '100%'
        }

      });
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
      let sw=self.dom.switch;
      sw.addEventListener('change',self.onSwitchChange.bind(self));
      sw.radius=20;
      sw.padding=0;
      if(Util.isMobile){
        sw.height=24;
        sw.width=48;
      }
      if(sw.update_switch) sw.update_switch();
    }

    onSwitchChange(e){
      let self=this;
      self.value=e.detail;
    }

    forward_props(control,changes){
      let self=this;
      for(let i of changes){
        self.dom[control][i]=self[`__${i}`];
      }
    }


    forward_switch_props(changes){
      let self=this;
      self.forward_props('switch',changes);
    }



  });

})();
(function () {

  let template = createTemplate(
    `:host {
  --border-color: var(--control-border-color);
  --background-color: var(--control-background-color);
  --select-color: var(--control-selected-color);
  --select-text-color: var(--control-contrast-color);
  --list-text-color: var(--control-text-color);
  position: relative;
  background-color: var(--background-color);
  border-bottom: solid 1px var(--border-color);
  border-color: var(--border-color);
  overflow: hidden;
  box-sizing: border-box;
  cursor: default;
}
#list {
  display: flex;
  flex-direction: row;
  color: var(--list-text-color);
  border: solid 1px var(--select-color);
  border-radius: 3px;
  border-width: 1px;
  box-sizing: border-box;
}
#list > div {
  background-color: transparent;
  font-weight: inherit;
  text-transform: inherit;
  text-decoration: inherit;
  flex: 1;
  border-right: 1px solid;
  border-color: var(--select-color);
  text-align: center;
  box-sizing: border-box;
  overflow: hidden;
  text-overflow: ellipsis;
  padding: 0px 5px;
}
#list > div.selected {
  background-color: var(--select-color);
  color: var(--select-text-color);
}
#list > div:last-child {
  border-right-width: 0px;
}
`
  );


  Util.registerCustomElement(class ControlMobileTabs1 extends ControlCommonListProto1{
    static get properties(){
      let props=Util.merge(super.properties,{
        height:{
          default:"40px",
        },
        border_color:{
          palette:true,
        },
      });
      super.markProperiesAsDisabled(props,['dimensionsLimits','transform','rotation','padding'],['text_align','text_height','position']);
      return props;
    }

    create(){
      let self=this;
      super.create();
      self.append(template);
      self._controlVersion="mobile";
    }

  });

})();
(function () {

	if(locale("ru")){
	var $hint_value="Значение (индекс элемента списка)";
	var $hint_list="Элементы списка и их индексы, пример:<br>0=Откл<br>1=Вкл<br>2=Авто";
	var $hint_select_color="Цвет выбранного элемента";
	var $hint_select_text_color="Цвет текста выбранного элемента";
}else{
	var $hint_value="Value (index of the list item)";
	var $hint_list="List items and their indexes, example:<br>0=Off<br>1=On<br>2=Auto";
	var $hint_select_color="Color of the selected element";
	var $hint_select_text_color="Text color of the selected element";
};
  

	let template = createTemplate(
		`:host{--select-color:var(--control-selected-color);--select-text-color:var(--control-contrast-color);--list-text-color:var(--control-text-color);position:relative;background-color:var(--background-color);border-bottom:solid 1px var(--border-color);border-color:var(--border-color);overflow:hidden;box-sizing:border-box;cursor:default}#list{display:flex;flex-direction:row;color:var(--list-text-color);border:1px solid var(--select-color);border-radius:3px;border-width:1px;box-sizing:border-box;height:100%}#list>div{background-color:transparent;font-weight:inherit;text-transform:inherit;text-decoration:inherit;flex:1;border-right:1px solid;border-color:var(--select-color);text-align:center;box-sizing:border-box;overflow:hidden;text-overflow:ellipsis;padding:0 5px;display:flex;justify-content:center;align-items:center}#list>div.selected{background-color:var(--select-color);color:var(--select-text-color)}#list>div:last-child{border-right-width:0}`
	);


	Util.registerCustomElement(class ControlMobileTabs2 extends ControlMobileProto2{
		static get properties(){
			let props=Util.merge(super.properties,{
				value:{
					type:"number",
					default:0,
					hint:$hint_value,
					update:"update_value",
					category:'main',
				},
				list:{
					default:"0=Off\n1=On\n2=Auto",
					type:"string",
					hint:$hint_list,
					update:["update_list"],
					category:'main',
				},
				select_color:{
					type:"string",
					hint:$hint_select_color,
					category:'main',
					palette:true,
				},
				select_text_color:{
					type:"string",
					hint:$hint_select_text_color,
					category:'main',
					palette:true,
				},
				border_color:{
					palette:true,
				},
				border_bottom_width:{
					default:1,
				},
				height:{
					default:Util.isMobile ? 60 : 40,
				},
				padding:{
					default:'10',
				},
				width: {
					default: '100%'
				}

			});
			super.markProperiesAsDisabled(props,['dimensionsLimits','transform','rotation'],['text_align','text_height']);
			return props;
		}

		create(){
			let self=this;
			super.create();
			self.append(template);
			self.___div=document.createElement('div');
			self.___div.id='list';
			self.append(self.___div);
		}

		update_list(){
			let self=this;
			self.___div.innerHTML="";
			let a=Util.parseList(self.__list);
			for(let i in a){
				let itemDiv = document.createElement('div');
				itemDiv.value=i;
				itemDiv.addEventListener("click",function (e) {
					self.value=this.value;
				});
				itemDiv.innerHTML=`<span>${a[i]}</span>`;
				self.___div.appendChild(itemDiv);
			}
			self.update_value();
		}

		update_value(){
			let self=this;
			if(!self.___div.children.length) return;
			for(let i=0; i<self.___div.children.length; i++){
				let li=self.___div.children[i];
				li.classList.toggle("selected",li.value==self.__value);
			}
		}

	});

})();
(function () {

  if(locale("ru")){

  var $hint_value="Текущее значение";
  var $hint_min_value="Минимальное значение";
  var $hint_max_value="Максимальное значение";
  var $hint_step="Шаг значений";
  var $hint_smooth_shift="Сглаживание перемещения бегунка при перетаскивании. 0 - откл, 1 - вкл. Может быть полезно при использования параметра 'step'";
  var $hint_pin_width="Ширина бегунка, px";
  var $hint_pin_radius="Скругление бегунка, %";
  var $hint_pin_border="Толщина границы бегунка, px";
  var $hint_progress_height="Толщина полоски индикатора";
  var $hint_progress_radius="Скругление полоски индикатора, %";
  var $hint_pin_color="Цвет бегунка";
  var $hint_progress_active_color="Активный цвет полоски индикатора";
  var $hint_progress_inactive_color="Неактивный цвет полоски индикатора";
  var $hint_value_color="Цвет значения";
  var $hint_value_bold="Жирный шрифт значения. 1 - вкл, 0 - откл.";
  var $hint_prefix="Префикс. Отображается перед значением.";
  var $hint_suffix="Суффикс. Отображается после значения.";
}else{
  var $hint_value="Current value";
  var $hint_min_value="Minimum value";
  var $hint_max_value="Maximum value";
  var $hint_step="Delta step";
  var $hint_smooth_shift="Smooth drag of volume pin. 0 - off, 1 - on. Useful then 'step' parametr is enabled";
  var $hint_pin_width="Pins width, px";
  var $hint_pin_radius="Pins border radius, %";
  var $hint_pin_border="Pins border width, px";
  var $hint_progress_height="Progress line height";
  var $hint_progress_radius="Progress line border radius, %";
  var $hint_pin_color="Pin color";
  var $hint_progress_active_color="Active color for progress line";
  var $hint_progress_inactive_color="Inactive color for progress line";
  var $hint_value_color="Value color";
  var $hint_value_bold="Bold font for value. 1 - enable, 0 - disabled.";
  var $hint_prefix="Prefix. Shown before value";
  var $hint_suffix="Suffix (unit). Shown after value";
};


  let template = createTemplate(
    `:host {
  --pin-color: var(--control-selected-color);
  --progress-active-color: var(--control-selected-color);
  --progress-inactive-color: var(--control-off-color);
  --value-pin-color: var(--pin-color);
  --value-progress-active-color: var(--progress-active-color);
  --value-progress-inactive-color: var(--progress-inactive-color);
  --value-color: var(--label-value-color);
  --text-color: var(--control-text-color);
  --label-value-color: var(--value-color);
  --label-text-color: var(--text-color);
  display: flex;
  flex-direction: column;
  justify-content: space-evenly;
  position: relative;
  padding: 10px;
}
#label {
  padding: 0px;
  border-bottom: none;
  --text-color: var(--label-text-color);
  --value-color: var(--label-value-color);
}
#volume {
  display: block;
  position: relative;
  margin-top: 5px;
  --pin-color: var(--value-pin-color);
  --progress-active-color: var(--value-progress-active-color);
  --progress-inactive-color: var(--value-progress-inactive-color);
}
`,
    `<control-mobile-label1 id="label"></control-mobile-label1>
<control-common-volume1 id="volume"></control-common-volume1>
`,
  );

  Util.registerCustomElement(class ControlMobileVolume1 extends ControlMobileProto1{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          type:"string",
          update:'forward_label_props',
        },

        value:{
          default:0,
          type:"number",
          hint:$hint_value,
        },

        height:{
          default:"60px",
        },

        min_value:{
          default:0,
          type:"number",
          hint:$hint_min_value,
          update:'forward_volume_props',
        },

        max_value:{
          default:100,
          type:"number",
          hint:$hint_max_value,
          update:'forward_volume_props',
        },

        step:{
          type:"number",
          default:1,
          hint:$hint_step,
          update:'forward_volume_props',
        },

        smooth_shift:{
          default:0,
          type:"number",
          hint:$hint_smooth_shift,
          update:'forward_volume_props',
        },

        pin_width:{
          default:30,
          type:"number",
          hint:$hint_pin_width,
          update:'forward_volume_props',
        },

        pin_radius:{
          default:100,
          type:"number",
          hint:$hint_pin_radius,
          update:'forward_volume_props',
        },

        pin_border:{
          default:0,
          type:"number",
          hint:$hint_pin_border,
          update:'forward_volume_props',
        },

        progress_height:{
          default:4,
          type:"number",
          hint:$hint_progress_height,
          update:'forward_volume_props',
        },

        progress_radius:{
          default:100,
          type:"number",
          hint:$hint_progress_radius,
          update:'forward_volume_props',
        },

        pin_color:{
          type:"string",
          palette:true,
          hint:$hint_pin_color,
        },

        progress_active_color:{
          type:"string",
          palette:true,
          hint:$hint_progress_active_color,
        },

        progress_inactive_color:{
          type:"string",
          palette:true,
          hint:$hint_progress_inactive_color,
        },

        value_color:{
          type:"string",
          palette:true,
          hint:$hint_value_color,
        },

        value_bold:{
          type:"number",
          hint:$hint_value_bold,
          update:'forward_label_props',
        },

        prefix:{
          type:"string",
          hint:$hint_prefix,
          default:"",
          update:'forward_label_props',
        },

        suffix:{
          type:"string",
          hint:$hint_suffix,
          default:"",
          update:'forward_label_props',
        },

        text_color:{
          type:"string",
          palette:true,
        },

      });
      super.markProperiesAsDisabled(props,['click']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
      self.dom.volume.width="100%";
      self.dom.volume.addEventListener('change',self.onVolumeChange.bind(self));
    }

    onVolumeChange(e){
      let self=this;
      self.value=e.detail;
    }

    forward_props(control,changes){
      let self=this;
      for(let i of changes){
        self.dom[control][i]=self[`__${i}`];
      }
    }

    forward_label_props(changes){
      let self=this;
      self.forward_props('label',changes);
    }

    forward_volume_props(changes){
      let self=this;
      self.forward_props('volume',changes);
    }

    update_value(changes){
      let self=this;
      self.forward_props('label',changes);
      self.forward_props('volume',changes);
    }



  });

})();
(function () {

  if(locale("ru")){

  var $hint_value="Текущее значение";
  var $hint_min_value="Минимальное значение";
  var $hint_max_value="Максимальное значение";
  var $hint_step="Шаг значений";
  var $hint_smooth_shift="Сглаживание перемещения бегунка при перетаскивании. 0 - откл, 1 - вкл. Может быть полезно при использования параметра 'step'";
  var $hint_pin_width="Ширина бегунка, px";
  var $hint_pin_radius="Скругление бегунка, %";
  var $hint_pin_border="Толщина границы бегунка, px";
  var $hint_progress_height="Толщина полоски индикатора";
  var $hint_progress_radius="Скругление полоски индикатора, %";
  var $hint_pin_color="Цвет бегунка";
  var $hint_progress_active_color="Активный цвет полоски индикатора";
  var $hint_progress_inactive_color="Неактивный цвет полоски индикатора";
  var $hint_value_color="Цвет значения";
  var $hint_value_bold="Жирный шрифт значения. 1 - вкл, 0 - откл.";
  var $hint_prefix="Префикс. Отображается перед значением.";
  var $hint_suffix="Суффикс. Отображается после значения.";
  var $hint_round="Округление до указанного знака после запятой";
  var $hint_fixed="Фиксированное количество знаков после запятой";
}else{
  var $hint_value="Current value";
  var $hint_min_value="Minimum value";
  var $hint_max_value="Maximum value";
  var $hint_step="Delta step";
  var $hint_smooth_shift="Smooth drag of volume pin. 0 - off, 1 - on. Useful then 'step' parametr is enabled";
  var $hint_pin_width="Pins width, px";
  var $hint_pin_radius="Pins border radius, %";
  var $hint_pin_border="Pins border width, px";
  var $hint_progress_height="Progress line height";
  var $hint_progress_radius="Progress line border radius, %";
  var $hint_pin_color="Pin color";
  var $hint_progress_active_color="Active color for progress line";
  var $hint_progress_inactive_color="Inactive color for progress line";
  var $hint_value_color="Value color";
  var $hint_value_bold="Bold font for value. 1 - enable, 0 - disabled.";
  var $hint_prefix="Prefix. Shown before value";
  var $hint_suffix="Suffix (unit). Shown after value";
  var $hint_round="Round to the specified decimal place";
  var $hint_fixed="Fixed number of decimal places";
};


  let template = createTemplate(
    `:host{--pin-color:var(--control-selected-color);--progress-active-color:var(--control-selected-color);--progress-inactive-color:var(--control-off-color);--value-pin-color:var(--pin-color);--value-progress-active-color:var(--progress-active-color);--value-progress-inactive-color:var(--progress-inactive-color);--value-color:var(--label-value-color);--text-color:var(--control-text-color);--label-value-color:var(--value-color);--label-text-color:var(--text-color);display:flex;flex-direction:column;justify-content:space-evenly;position:relative;padding:10px}#label{padding:0;border-bottom:none;--text-color:var(--label-text-color);--value-color:var(--label-value-color)}#volume{display:block;position:relative;margin-top:10px;--pin-color:var(--value-pin-color);--progress-active-color:var(--value-progress-active-color);--progress-inactive-color:var(--value-progress-inactive-color)}`,
    `<control-mobile-label2 id="label"></control-mobile-label2>
<control-common-volume1 id="volume"></control-common-volume1>
`,
  );

  Util.registerCustomElement(class ControlMobileVolume2 extends ControlMobileProto2{

    static get properties(){
      let props=Util.merge(super.properties,{

        name:{
          type:"string",
          update:'forward_label_props',
        },

        value:{
          default:0,
          type:"number",
          hint:$hint_value,
        },

        height:{
          default: Util.isMobile ? 70 : 60,
        },
        width: {
          default: '100%'
        },

        min_value:{
          default:0,
          type:"number",
          hint:$hint_min_value,
          update:'forward_volume_props',
        },

        max_value:{
          default:100,
          type:"number",
          hint:$hint_max_value,
          update:'forward_volume_props',
        },

        step:{
          type:"number",
          default:1,
          hint:$hint_step,
          update:'forward_volume_props',
        },

        smooth_shift:{
          default:0,
          type:"number",
          hint:$hint_smooth_shift,
          update:'forward_volume_props',
        },

        pin_width:{
          default:Util.isMobile ? 24 : 20,
          type:"number",
          hint:$hint_pin_width,
          update:'forward_volume_props',
        },

        pin_radius:{
          default:100,
          type:"number",
          hint:$hint_pin_radius,
          update:'forward_volume_props',
        },

        pin_border:{
          default:0,
          type:"number",
          hint:$hint_pin_border,
          update:'forward_volume_props',
        },

        progress_height:{
          default:4,
          type:"number",
          hint:$hint_progress_height,
          update:'forward_volume_props',
        },

        progress_radius:{
          default:100,
          type:"number",
          hint:$hint_progress_radius,
          update:'forward_volume_props',
        },

        pin_color:{
          type:"string",
          palette:true,
          hint:$hint_pin_color,
        },

        progress_active_color:{
          type:"string",
          palette:true,
          hint:$hint_progress_active_color,
        },

        progress_inactive_color:{
          type:"string",
          palette:true,
          hint:$hint_progress_inactive_color,
        },

        value_color:{
          type:"string",
          palette:true,
          hint:$hint_value_color,
        },

        value_bold:{
          type:"number",
          hint:$hint_value_bold,
          update:'forward_label_props',
        },

        prefix:{
          type:"string",
          hint:$hint_prefix,
          default:"",
          update:'forward_label_props',
        },

        suffix:{
          type:"string",
          hint:$hint_suffix,
          default:"",
          update:'forward_label_props',
        },

        round:{
          type:"number",
          hint:$hint_round,
          default:"",
          update:"forward_label_props",
        },

        fixed:{
          type:"number",
          default:"",
          hint:$hint_fixed,
          update:"forward_label_props",
        },

        text_color:{
          type:"string",
          palette:true,
        },
        border_bottom_width:{
          default:1,
        },

      });
      super.markProperiesAsDisabled(props,['click']);
      return props;
    }

    create(){
      super.create();
      let self=this;
      self.append(template);
      self.dom.volume.width="100%";
      self.dom.volume.addEventListener('change',self.onVolumeChange.bind(self));
    }

    onVolumeChange(e){
      let self=this;
      self.value=e.detail;
    }

    forward_props(control,changes){
      let self=this;
      for(let i of changes){
        self.dom[control][i]=self[`__${i}`];
      }
    }

    forward_label_props(changes){
      let self=this;
      self.forward_props('label',changes);
    }

    forward_volume_props(changes){
      let self=this;
      self.forward_props('volume',changes);
    }

    update_value(changes){
      let self=this;
      self.forward_props('label',changes);
      self.forward_props('volume',changes);
    }



  });

})();

