let enable_cache=true;

self.addEventListener('fetch', function(event){
	if(enable_cache){
		event.respondWith((async () => {
			let cachedResponse = await caches.match(event.request);
			if (cachedResponse) {
				return cachedResponse;
			}else{
				let response = await fetch(event.request);
				if (!response || response.status !== 200 || response.type !== 'basic') {
					return response;
				}else{
					let cacheName;
					//console.log(event.request.url,event.request.referrer+'projects/');
					if(event.request.url.startsWith(event.request.referrer+'projects/')){
						//console.log(event.request);
						cacheName='projects';
					}else{
						cacheName='system';
					}
					let cache = await caches.open(cacheName);
					await cache.put(event.request, response.clone());
				}
				return response;
			}
		})());
	}
});


self.addEventListener("message", function (event){
	let e=event.data;
	if(e.type==='reset_cache'){
		//console.log('reset_cache',e.payload);
		let name=e.payload;
		if(name){
			caches.delete(name);
		}else{
			caches.keys().then(function(names) {
				for (let name of names){
					caches.delete(name);
				}
			});
		}

	}else if(e.type==='enable_cache'){
		enable_cache=e.payload;
	}
});

