/*--PSEUDO-CODE--*/

if(locale('ru')){
	var $editor='Редактор';
	var $backups='Резервные копии';
	var $backups_desc='Сохраненные резервные копии проектов';
    var $backup="Создать копию проекта";
    var $delete="Удалить";
    var $all_projects="Все проекты";
    var $restore_question="Заменить текущую версию проекта <br>версией из выбранной резервной копии?";
    var $delete_backups="Удалить резервные копии";
    var $delete_help="Выбранные резервные копии (%s) будут удалены";
    var $delete_success='Удален';
    var $restore="Восстановить";
    var $name="Имя";
    var $size="Размер";
    var $actions="Действия";
    var $download="Скачать";
    var $creating_backup="Создается резервная копия";
    var $restoring_backup="Проект восстанавливается из резервной копии";
    var $time="Время";
	var $no_backups="Нет доступных резервных копий";
	var $backup_error="Ошибки восстановления резервной копии";
	var $not_imported="Некоторые объекты не были импортированы";
	var $backup_restored="Резервная копия успешно восстановлена";
}else{
	var $editor='Editor';
	var $backups='Backups';
	var $backups_desc='Saved backup copies of projects';
    var $delete="Delete";
    var $all_projects="All projects";
    var $restore_question="Replace the current version of the project <br>with a version from the selected backup?";
    var $delete_backups="Delete backups";
    var $delete_help="Selected backups (%s) will be deleted";
    var $delete_success='Deleted';
    var $restore="Restore";
    var $name="Name";
    var $size="Size";
    var $actions="Actions";
    var $download="Download";
    var $creating_backup="A backup is being created";
    var $restoring_backup="The project is restored from a backup";
    var $time="Time";
	var $no_backups="No backups available";
	var $backup_error="Backup errors";
	var $not_imported="Some objects were not imported";
	var $backup_restored="Backup successfully restored";
}
  

PROTO=widgetEditorProtoCommon;

TEMPLATE = createTemplate(
	``,
	``,
);

ONCREATE=create;
ONUPDATE=update;

PROPERTIES={
	project:{
		type:'string',
	},
};


let editor;
let grid;
let columns;
let project;

function create(){

	editor=self.editor;
	//console.log('create');
	editor.oncreated=function (){

		editor.showTitle($backups,'/images/backup.svg');
		editor.showDescription($backups_desc);
		editor.showPath([[$editor,'#editor/home'],[$backups,'#editor/backups']]);
		editor.selectMenuItem('/backups');

		editor.showProperties(null);

		columns=[
			{
				key:'name',
				caption:$name,
				onrender:function (value,record,column,index,row,cell,refresh) {
					let text=record.name;
					let icon='/images/zip.svg';
					cell.innerHTML=`<a-icon src='${icon}'></a-icon> ${text}`;
				},
			},
			{
				key:'size',
				caption:$size,
				sort_by_format:false,
				onrender:function (value,record,column,index,row,cell,refresh) {
					cell.innerHTML=Util.formatSize(record.size);
				},
			},
			{
				key:'_time',
				caption:$time,
				sort_by_format:false,
				onrender:function (value,record,column,index,row,cell,refresh) {
					let a=record._time.split('-');
					let t=a[2]+'.'+a[1]+'.'+a[0]+' '+a[3]+'.'+a[4]+'.'+a[5];
					cell.innerHTML=t;
					record.__time=t;
				},
			},
			{
				key:'_restore',
				caption:$actions,
				onrender:function (value,record,column,index,row,cell,refresh) {
					let a=document.createElement('a');
					cell.innerHTML='';
					cell.appendChild(a);
					a.innerHTML=$restore;
					a.onclick=function (){
						restoreBackup(record.name,record._project,record.__time);
					}
					let dw=document.createElement('span');
					dw.innerHTML='&nbsp;|&nbsp;<a href="/backups/'+record.name+'">'+$download+'</a>';
					cell.appendChild(dw);

				},
			}
		],

		grid=editor.showTable(null,null,columns,function (){
			editor.refreshToolbarButtons();
			editor.refreshStatus();
		});

		grid.sort_column=3;
		grid.sort_order='desc';
		grid.table_empty=$no_backups;

		editor.showLeftToolbar([
			{
				tag:'a-select',
				id:'sel_project',
				list:pult.user.projects,
				undefined:$all_projects,
				value:self.__project,
				onchange:function (){
					self.project=this.value;
				}
			},
			'-',
			{
				key:'delete',
				disabled:true,
				onclick:function (){
					console.log('delete');
					deleteBackup();
				}
			}
		]);

		editor.showRightToolbar([
			{key:'filter'}
		]);

		loadBackupList();

	};
}

function update(params){
	for(let k in params){
		if(k==='project'){
			project=params[k];
			dom.sel_project.value=project;
			loadBackupList();
		}
	}
}

function loadBackupList(){

    pult.request(self,'backup_list',{project:project},function (req,res,err){
        if(err){
            pult.showModalError(self,err);
        }else{
			for(let i=0; i<res.length; i++){
				let b=res[i];
				//"_2024_05_23_02_13_49.tar.gz"
				let t=(b.name.substring(b.name.length-23)).substring(0,19);
				b._time=t;
				b._project=b.name.substring(0,b.name.length-24);
			}
            grid.records=res;
        }
    });
}


function deleteBackup(){

    let f=pult.showBatchForm(self,{
    
        caption:$delete_backups,
        html:Util.format($delete_help,grid.selection.length),
        submit: $delete,
		width:600,
    
        onsubmit:function(data){           
            let rr=[];
            for(let i=0; i<grid.selection.length; i++){
                let r=grid.records[grid.selection[i]];  
                rr.push(['backup_delete',{backup:r.name}]);
            }
        
            pult.requests(self,rr,function(reqs,ress,errs){
                for(let i=0; i<reqs.length; i++){
                    f.result(reqs[i][1].backup,errs[i],$delete_success);
                }
                f.hideSubmit();
                grid.unselect();
                loadBackupList();
            });
    
        }
    
    });
}

function restoreBackup(backup,project,time){

	pult.showConfirm(self,{
		
		caption:"Восстановить резервную копию проекта?",
		html:Util.format(`Текущая версия проекта "%s" будет заменена версией из резервной копии от %s. 
		<br><br>
		Убедитесь, что у вас есть резервная копия текущей версии проекта для отката изменений, если это потребуется.`,project,time),
		width:500,
		submit:$restore,

	},function (){

		setTimeout(function (){
			let f=pult.showBatchErrors(self,{
				caption:$backup_error,
				html:$not_imported,
				width:500,
			});
		
			pult.asyncRequest(self,'backup_restore',{
				backup:backup
			},function (req,res,err){
				if(err){
					pult.showModalError(self,err);
				}else{
					let ee=[];
					let pp=[];
					for(let i=0; i<res.length; i++){
						let p=res[i];
						if(p){
							if(p.error){
								ee.push(p.error);
								f.result(p.import,p.error);
							}else{
								pp.push({
									path:p.path,
									parent:false,
									docs:'@prop.json',
									unpack:'@prop.json',
									access:editor.ACS_TYPE_EDIT
								});
							}
						}
					}
		
					//console.log(res);
					pult.fdb.batch_load(self,pp,function (reqs,ress,errs){
						for(let i=0; i<ress.length; i++){
							let o=ress[i];
							if(o){
								editor.deleteMenuItem(o._path);
								editor.addMenuItem(o);
							}
						}
		
						if(ee.length===0){
							pult.showTooltip(self,$backup_restored);
						}
		
					});
				}
			},true);
		},100);
		
	});

}