/*--PSEUDO-CODE--*/

if(locale('ru')){
	var $users='Пользователи';
	var $users_desc='Пользователи, входящие в группу';
	var $user='Пользователь';
	var $delete='Удалить';
	var $total_count="Всего: %s";
  	var $selected_count="Выбрано: %s";
  	var $add_users="Добавить пользователей";
  	var $add="Добавить";
  	var $name="Имя";
  	var $position="Должность";
  	var $department="Отдел";
  	var $groups="Группы";
	var $no_user_to_add="Нет пользователей для добавления. <br> Все пользователи системы уже добавлены в группу.";
	var $del_users="Удалить пользователей из группы?";
	var $del_users_text="Выбранные пользователи (%s) будут удалены из группы \"%s\"";
	var $delete="Удалить";
}else{
	var $users='Users';
	var $users_desc='Users included in the group';
	var $user='User';
	var $delete='Delete';
	var $total_count="Total: %s";
	var $selected_count="Selected: %s";
	var $add_users="Add users";
	var $add="Add";
	var $name="Name";
	var $position="Position";
	var $department="Department";
	var $groups="Groups";
	var $no_user_to_add="There are no users to add. <br> All system users have already been added to the group.";
	var $del_users="Delete users from the group?";
	var $del_users_text="The selected users (%s) will be removed from the group \"%s\"";
	var $delete="Delete";
}

PROTO=widgetEditorProtoCommon;

ONCREATE=create;

let editor;
let object;
let grid;
let buttons;
let timerSelect;
let users;
let columns;

function create(){
	editor=self.editor;
	editor.tabs=[
		{
			key:'users',
			caption:$users,
			desc:$users_desc,
			onshow:show,
		},
		"code",
	];
}

function destroy(){
	clearTimeout(timerSelect);
}

function show(){

	object=editor.object;
	if(!object) return;
	if(!editor.projectPath) return;
	if(!object.users) object.users=[];

	grid=Util.create(dom._editor_content,'a-grid');
	grid.checkbox_width=50;
	grid.checkbox=true;
	grid.row_height=32;
	grid.sort_column=1;
	grid.onselect=onTableSelect;
	grid.css=`.row.deleted{color:var(--app-comment-color)}.row.deleted a-icon{--color:var(--app-comment-color)}.row.deleted .c1{text-decoration:line-through}.row .c2,.row .c3,.row .c4,.row .c5{color:var(--app-comment-color)}`;


	columns=[
		{
			key:'login',
			caption:$user,
			format:grid.getIconFormat('${icon}','${login}'),
			onrender:function (value,record,column,index,row,cell,refresh) {
				row.classList.toggle('deleted',!!record.deleted);
			}
		},
		{
			key:'_groups',
			caption:$groups,
		},
		{
			key:'name',
			caption:$name,
		},
		{
			key:'position',
			caption:$position,
		},
		{
			key:'department',
			caption:$department,
		},
	
	];	

	grid.columns=columns;
	
	grid.refresh();

	buttons=editor.showLeftToolbar([
		{
			icon:'/images/add.svg',
			caption:$user,
			onclick:addUsers
		},
		'-',
		{
			icon:'/images/del.svg',
			text_color:'var(--app-soft-red-color)',
			caption:$delete,
			enableBySelect:true,
			onclick:function (){
				delUsers();
			}
		}
	]);


	refreshButtons();
	refreshUsers();

	


}

function refreshButtons(){
	for(let i=0; i<buttons.length; i++){
		let b=buttons[i];
		if(b.getAttribute('enableBySelect')) b.disabled = !grid.selection?.length;
	}
}

function onTableSelect(rr){
	clearTimeout(timerSelect);
	timerSelect=setTimeout(function (){
		refreshButtons();
		refreshStatus();
		if(grid.selection.length){
			editor.showProperties(null);
		}else{
			editor.showProperties([object]);
		}
	},10);
}

function refreshStatus(){
	if(grid.selection.length){
		editor.showLeftStatus(Util.format($selected_count,grid.selection.length));
	}else{
		editor.showLeftStatus(Util.format($total_count,grid.records.length));
	}
}

function refreshUsers(){

	

	pult.request(self,'editor_group_users',{
		project:editor.projectPath,
	},function (req,res,err){
		if(res){
			users=Util.ato(res,'login');
			for(let k in users){
				let u=users[k];
				if(!u.icon) u.icon='/images/user.svg';
				u._groups=[];
				for(let i=0; i<u.groups?.length; i++){
					let g=u.groups[i];
					u._groups.push(Util.getFileTitle(g));
				}
				Util.sort(u._groups);
			}
			
			let uu=[];
			for(let i=0; i<object.users.length; i++){
				let u=object.users[i];
				let user=Util.clone(users[u]);
				if(!user){
					user={
						login:u,
						icon:'/images/user.svg',
						deleted:true,
					}
				}
				uu.push(user);
			}
			grid.records=uu;
		}else{
			pult.showModalError(self,err);
		}
	});
}

function delUsers(){
	pult.showConfirm(self,{
		caption:$del_users,
		html:Util.format($del_users_text,grid.selection.length,object._title),
		submit:$delete,
		width:500
	},function (){
		let ou=object.users;
		let uu=grid.getSelectedRecords();
		for(let i=0; i<uu.length; i++){
			let u=uu[i];
			for(let i=ou.length-1; i>=0; i--){
				let login=ou[i];
				if(login===u.login){
					ou.splice(i,1);
					break;
				}
			}
		}
		editor.requestSave(object,'!reload');
		grid.deleteSelectedRecords();
	});
}

function addUsers(){
	let grid;

	let f=pult.showForm(self,{
		caption:$add_users,
		submit:$add,
		width:600,
		height:400,
		padding:0,
		html:`<a-grid id='_modal_users'></a-grid>`,
		onsubmit:function (e){
			let rr=grid.getSelectedRecords();
			for(let i=0; i<rr.length; i++){
				let u=rr[i];
				if(!object.users.includes(u.login)){
					object.users.push(u.login);
				}
			}

			editor.requestSave(object,'!reload');
			refreshUsers();
		}
	});

	f.dom._btn_submit.disabled=true;

	grid=f.dom._modal_users;
	grid.checkbox=true;
	grid.row_height=32;
	grid.table_empty=$no_user_to_add;
	grid.onselect=function (){
		f.dom._btn_submit.disabled=!grid.selection.length;
	};
	grid.columns=columns;


	let uu=[];

	for(let k in users){
		let u=Util.clone(users[k]);
		if(!object.users.includes(u.login)){
			uu.push(u);
		}
	}

	Util.keySort(uu,'login');
	grid.records=uu;

	
}