/*--PSEUDO-CODE--*/

if(locale('ru')){
	var $home='Главная';
	var $projects='Проекты';
	var $manage_projects='Управление проектами';
	var $project_editor='Редактор проектов';
	var $new_project='Создать новый проект';
	var $active_projects='Активные проекты';
	var $project_desc=`
	Проект представляет собой совокупность узлов, мнемосхем и других компонентов, необходимых для мониторинга и управления производственным процессом или инженерной системой.
	
	Редактор проектов предоставляет полный набор инструментов и функций для создания и редактирования проектов на данном сервере, включая графический редактор мнемосхем.
	`
}else{
	var $home='Home';
	var $projects='Projects';
	var $manage_projects='Manage projects';
	var $project_editor='Project editor';
	var $new_project='Create new project';
	var $active_projects='Active projects';
	var $project_desc=`
	A project is a collection of nodes, mnemonic diagrams and other components necessary for monitoring and controlling a production process or engineering system.

	The project editor provides a full set of tools and functions for creating and editing projects on this server, including a graphical mnemonic editor.
	`
}

PROTO=widgetEditorProtoCommon;

TEMPLATE = createTemplate(
	`#_editor_content{background-color:var(--app-form-color)}#content{padding:20px}#desc{margin-top:-20px;max-width:600px;white-space:pre-line}h1{white-space:nowrap}#projects{display:none}#templates a h4{display:inline-block;margin-bottom:5px}a-browser{margin-top:0;padding:0;--item-height:150px;--item-width:150px}a-browser a-browser-item{border:1px solid var(--app-button-color);--text-hover-color:var(--app-active-text-color);--icon-hover-color:var(--app-active-text-color);padding-top:40px}a-browser a-browser-item:hover{border:1px solid var(--app-selected-color);background-color:var(--app-selected-color)}#links{white-space:nowrap}#links a-icon{vertical-align:middle;position:relative;top:-2px;width:20px;height:20px}#links h4{font-size:14px}#link_manage{display:none}`,
);

ONCREATE=create;

let editor;

let tabEditor;

function create(){

	tabEditor={
		show:show,
	};

	editor=self.editor;
	editor.tabs=[
		{
			key:'home',
			caption:$home,
			desc:$project_editor,
			onshow:tabEditor.show,
			onhide:tabEditor.hide,
		},
		{
			key:'objects',
			caption:$projects,
			desc:$manage_projects,
			onshow:tabObjects.show,
			onhide:tabObjects.hide,
		}
	];
}

function show(){

	//console.log('show projects',editor.object);

	dom._editor_content.innerHTML=`<div id="content">

	<h1 class="mb10">
		${$project_editor}
	</h1>
	
	<div id="desc" class="comment">
		${$project_desc}
	</div>

	<div id="links">
		<div id="templates"></div>
	</div>

	<div id="projects" class="mt20 pt20 bt" >
		<h3 class="mb20">${$active_projects}</h3>
		<a-browser id="browser">
	</div>

	</a-browser>
</div>`;
	
	editor.loadList({
		path:'/projects',
		docs:'@prop.json',
		unpack:'@prop.json'
	},function (res){
		let n=0;
		dom.browser.innerHTML='';

		if(res.length){
			dom.link_manage.style.display='inline';
			for(let i=0; i<res.length; i++){
				let o=res[i];
				if(!o.inactive){
					n++;
					Util.create(dom.browser,{
						tag:'a-browser-item',
						title:o._title,
						icon_size:32,
						href:encodeURI(o._editor),
						icon_src:o._icon,
					});
				}
			}
		}else{
			dom.link_manage.style.display='none';
		}
		
		if(n){
			dom.projects.style.display='block';
		}else{
			dom.projects.style.display='none';
		}
	});



	dom.templates.innerHTML='';

	pult.request(self,'fdb_templates',{
		dir:'projects',
	},function (req,res,err){
		if(err){
			pult.showModalError(self,err);
		}else{
			let tt=res;
			for(let k in tt){
				let t=tt[k];
				let n=locale_string(t.title)+'1'+'.project';
				let a=document.createElement('a');
				a.href='javascript:void(0)';
				a.innerHTML=`<h4><a-icon src="/images/add.svg"></a-icon> ${locale_string(t.name)}</h4><br>`;
				a.onclick=function (){
					editor.importTemplate('projects/'+k,n,function (reqs,ress,errs){
						for(let i=0; i<ress.length; i++){
							let o=ress[i];
							editor.addMenuItem(o);
							location.hash=o._editor;
							break;
						}
					});
				}
				dom.templates.appendChild(a);
			}
		}
	});

	dom.links.innerHTML+=`<h4><a href="#editor/home?tab=objects" id="link_manage"><a-icon src="/images/project.svg"></a-icon> ${$manage_projects}</a></h4>`;
	
	if(config.template_projects_link){
		dom.links.innerHTML+=`<h4><a href="${config.template_projects_link}"><a-icon src="${config.template_projects_icon}"></a-icon> ${config.template_projects_text}</a></h4>`;
	}

	


	// dom.link_create.onclick=function (){

	// 	let ts=schema.types.project;
	// 	let name=locale_string(ts.typename);
	// 	let path='/projects/' + name + '.project';

	// 	let params={
	// 		path:path,
	// 		nextname:true,
	// 	}

	// 	pult.fdb.create(params,function (req,res,err){
	// 		if(err){
	// 			pult.showError(self,err);
	// 		}else{
	// 			pult.fdb.load({
	// 				path:res,
	// 				parent:false,
	// 				docs:'@prop.json',
	// 				unpack:'@prop.json',
	// 				access:editor.ACS_TYPE_EDIT
	// 			},function (req,res,err){
	// 				if(err){
	// 					pult.showError(self,err);
	// 				}else{
	// 					editor.addMenuItem(res);
	// 					location.hash=res._editor;
	// 				}
	// 			});
	// 		}
	// 	});

	// }

}


