/*--PSEUDO-CODE--*/

if(locale("ru")){
	var $project="Проект";
	var $sections='Разделы';
	var $sections_desc='Разделы проекта';
    var $export="Экспорт";
    var $import="Импорт";
    var $prototypes="Прототипы";
    var $mimics="Мнемосхемы";
    var $nodes="Узлы";
    var $screens="Экраны";
    var $groups="Группы";
    var $backup="Резервные копии";
	var $manage_sections='Управление разделами';
	var $manage_access='Управление доступом';
    var $prototypes_text=`
    Прототипы узлов, в которых определяется набор параметров и список переменных узла. Каждый прототип может применяться к одному или к нескольким узлам. Один прототип может содержать переменные разных драйверов.
    `;
    var $nodes_text=`
    Дерево узлов проекта. Узлы наследуют параметры и список переменных в соответствии со своим прототипом. Каждый узел является логической единицей, может содержать переменные разных драйверов и работать с несколькими физическими узлами.
    `;
    var $mimics_text=`
    Мнемосхема представляет собой шаблон экрана и является макетом графического интерфейса какого-либо устройств или инженерной системы. Каждая мнемосхема может применяться к одному или к нескольким экранам.
    `;
    var $groups_text=`
    Группы пользователей проекта. Каждая группа содержит свой список пользователей. Пользователи получают доступ к элементам проекта в соответствии с разрешениями, установленными для групп, в которые они включены.
    `;
    var $screens_text=`
    Дерево экранов отображается в интерфейсе пользователя. Экран связывает мнемосхему с одним или несколькими узлами, визуализирует значения переменных и предоставляет оператору интерфейс для управления узлом или инженерной системой.
    `;
    var $backup_text=`
    Резервные копии проекта создаются пользователем и представляют собой полный архив папки проекта в формате TAR.GZ, который может быть скачан и/или перенесен на другой сервер. Архив не содержит исторических данных, типа трендов, тревог или журнала проекта.
    `;
    var $home="Главный экран";
    var $layout="Раскладка:";
}else{
    var $project="Project";
	var $sections='Sections';
	var $sections_desc='Project sections';
    var $export="Export";
    var $import="Import";
    var $prototypes="Prototypes";
    var $mimics="Mimics";
    var $nodes="Nodes";
    var $screens="Screens";
    var $groups="Groups";
    var $backup="Backups";
	var $manage_sections='Manage sections';
	var $manage_access='Manage access';
    var $prototypes_text=`
	Node prototypes that define a set of parameters and a list of node variables. Each prototype can be applied to one or more nodes. One prototype can contain variables from different drivers.
	`;
	var $nodes_text=`
	Project node tree. Nodes inherit parameters and a list of variables according to their prototype. Each node is a logical unit, can contain variables from different drivers and work with multiple physical nodes.
	`;
	var $mimics_text=`
	A mnemonic diagram is a screen template and is a layout of the graphical interface of any device or engineering system. Each mimic can be applied to one or more screens.
	`;
	var $groups_text=`
	Project user groups. Each group contains its own list of users. Users have access to project items based on the permissions set for the groups they are assigned to.
	`;
	var $screens_text=`
	The screen tree is displayed in the user interface. The screen connects the mnemonic diagram with one or more nodes, visualizes the values of variables and provides the operator with an interface for controlling the node or engineering system.
	`;
	var $backup_text=`
	Project backups are created by the user and represent a complete archive of the project folder in TAR.GZ format, which can be downloaded and/or transferred to another server. The archive does not contain historical data such as trends, alarms or project logs.
    `;
    var $home="Home screen";
    var $layout="Layout:";
}

PROTO=widgetEditorProtoCommon;

TEMPLATE = createTemplate(
	`#_editor_content{background-color:var(--app-form-color)}#content{padding:20px}#project{margin-bottom:30px}#project .header{margin-top:20px}#project .header a-icon{width:48px;height:48px;margin-right:13px;--color:var(--app-text-color)}#links{margin-top:20px;white-space:nowrap;display:flex;flex-direction:row;align-items:center}#links a{margin-right:40px}#links a-icon{vertical-align:middle;position:relative;top:-2px;width:20px;height:20px}#links h4{font-size:14px}#tiles{border-top:solid 1px var(--app-control-color);border-bottom:solid 1px var(--app-control-color);padding-top:50px;padding-bottom:50px;display:grid;grid-template-columns:repeat(3,1fr);grid-column-gap:50px;grid-row-gap:50px;max-width:1200px}.tile .text{margin-top:10px;color:var(--app-comment-color)}.header{display:inline-flex;flex-direction:row;font-size:24px;align-items:center;white-space:nowrap}.header a-icon{width:32px;height:32px;margin-right:10px}a.header:hover{color:var(--app-active-text-color)}a.header:hover a-icon{--color:var(--app-active-text-color)}`,
);

ONCREATE=create;
ONDESTROY=destroy;

let editor;
let object;
let dbtimer;
let sizetimer;

let tabProject;
let tabHomeScreen;

function create(){

	tabProject={
		show:showProject,
	};
	
	tabHomeScreen={
		show:showHomeScreen,
	};

	editor=self.editor;
	editor.tabs=[
		{
			key:'project',
			caption:$project,
			onshow:tabProject.show,
			onhide:tabProject.hide,
		},
		{
			key:'home',
			caption:$home,
			onshow:tabHomeScreen.show,
			onhide:tabHomeScreen.hide,
		},
		{
			key:'objects',
			caption:$sections,
			desc:$sections_desc,
			onshow:tabObjects.show,
			onhide:tabObjects.hide,
		},
		'access',
		'code'
	];
}

function destroy(){
	clearTimeout(dbtimer);
	clearTimeout(sizetimer);
}

function showProject(){

	object=editor.object;
	if(!object) return;
	if(object._type!=='project') return;

	dom._editor_content.innerHTML=`<div id="content">
	<div id="project">
		<div class="header">
			<a-icon id="icon"></a-icon>
			<h1 id="name"></h1>
		</div>
	</div>
	<div id="tiles"></div>
	<div id="links">
		<h4><a id="manage_sections"><a-icon src="/images/menu.svg"></a-icon> ${$manage_sections}</a></h4>
		<h4><a id="manage_access"><a-icon src="/images/access.svg"></a-icon> ${$manage_access}</a></h4>
	</div>
</div>`;
	dom.name.innerHTML=editor.object._title;
	dom.icon.src=editor.object._icon;

	dom.manage_access.href=`#editor/project?path=${object._path}&tab=access`;
	dom.manage_sections.href=`#editor/project?path=${object._path}&tab=objects`;
	
	editor.loadList({
		path:object._path,
		unpack:'@prop.json',
		docs:'@prop.json',
	},function (oo){
		dom.tiles.innerHTML='';
    	for(let i=0; i<oo.length; i++){
			let o=oo[i];
			if(!o.inactive){
				let st=schema.types[o._type];
				if(!st.hideInEditorProjectWelcome){
					drawTile(o._title,o._icon,o._editor,locale_string(st.help));
				}
			}
		}
	});
}


function drawTile(title,icon,href,text){
    Util.create(dom.tiles,{
        class:'tile',
        html:[
            {
                tag:'a',
                class:'header',
                href:href,
                html:[
                    {
                        tag:'a-icon',
                        src:icon,
                    },
                    {
                        tag:'div',
                        html:title
                    }
                ]
            },
            {
                class:'text',
                html:text
            }
        ]
    });
}


function showHomeScreen(){

	object=editor.object;
	if(!object) return;
	if(object._type!=='project') return;

	editor.showLeftToolbar([
		{
			tag:'span',
			html:$layout,
		},
		{
			icon:'/images/layout-s-1.svg',
			value:'S-1',
			title:'S-1',
			onclick:setLayout,
		},
		{
			icon:'/images/layout-h-1-2.svg',
			value:'H-1-2',
			title:'H-1-2',
			onclick:setLayout,
		},
		{
			icon:'/images/layout-v-1-2.svg',
			value:'V-1-2',
			title:'V-1-2',
			onclick:setLayout,
		},
		{
			icon:'/images/layout-h-12-3.svg',
			value:'H-12-3',
			title:'H-12-3',
			onclick:setLayout,
		},
		{
			icon:'/images/layout-v-12-3.svg',
			value:'V-12-3',
			title:'V-12-3',
			onclick:setLayout,
		},
		{
			icon:'/images/layout-h-3-12.svg',
			value:'H-3-12',
			title:'H-3-12',
			onclick:setLayout,
		},
		{
			icon:'/images/layout-v-3-12.svg',
			value:'V-3-12',
			title:'V-3-12',
			onclick:setLayout,
		},
		{
			icon:'/images/layout-h-12-34.svg',
			value:'H-12-34',
			title:'H-12-34',
			onclick:setLayout,
		},
		{
			icon:'/images/layout-v-12-34.svg',
			value:'V-12-34',
			title:'V-12-34',
			onclick:setLayout,
		},
	]);
	
	editor.onpropchange=function (oo,p){
		editor.requestSave(oo,[p.key]);
		clearTimeout(dbtimer);
		dbtimer=setTimeout(function (){
			drawDashboard();
		},300);
	}

	editor.loadList({
		path:object._path,
		unpack:'@prop.json',
		docs:'@prop.json',
	},function (oo){
		object._children=oo;
		drawDashboard();
	});


}


function drawDashboard(){

	pult.drawDashboard(dom._editor_content,object,true);
	refreshDashboardButtons();
	
	let layout1234=dom.layout1234;
	if(layout1234){
		layout1234.onresize=function (e){
			//console.log(e.detail);
			let s=e.detail;
			if(s.manual){
				
				let st=schema.types.project;		
				let size12 = Util.toNumber(object.size12  ?? st._properties.size12.default);
				let size34 = Util.toNumber(object.size34  ?? st._properties.size34.default);

				if(s.slot===1 && size12) object.size12=s.size;
				if(s.slot===2 && size34) object.size34=s.size;
				clearTimeout(sizetimer);

				sizetimer=setTimeout(function (){
					editor.showProperties();
					editor.requestSave();
				},500);
			}
		}
	}

	let layout3412=dom.layout3412;
	if(layout3412){
		layout3412.onresize=function (e){
			//console.log(e.detail);
			let s=e.detail;
			if(s.manual){
				
				let st=schema.types.project;		
				let size12 = Util.toNumber(object.size12  ?? st._properties.size12.default);
				let size34 = Util.toNumber(object.size34  ?? st._properties.size34.default);

				if(s.slot===2 && size12) object.size12=s.size;
				if(s.slot===1 && size34) object.size34=s.size;
				clearTimeout(sizetimer);

				sizetimer=setTimeout(function (){
					editor.showProperties();
					editor.requestSave();
				},500);
			}
		}
	}


	let layout12=dom.layout12;
	if(layout12){
		layout12.onresize=function (e){

			let s=e.detail;
			if(s.manual){
				
				let st=schema.types.project;
			
				let size1 =  Util.toNumber(object.size1  ?? st._properties.size1.default);
				let size2 =  Util.toNumber(object.size2  ?? st._properties.size2.default);

				if(s.slot===1 && size1) object.size1=s.size;
				if(s.slot===2 && size2) object.size2=s.size;
				clearTimeout(sizetimer);

				sizetimer=setTimeout(function (){
					editor.showProperties();
					editor.requestSave();
				},500);
			}
		}
	}

	let layout34=dom.layout34;
	if(layout34){
		layout34.onresize=function (e){

			let s=e.detail;
			if(s.manual){
				
				let st=schema.types.project;
			
				let size3 =  Util.toNumber(object.size3  ?? st._properties.size3.default);
				let size4 =  Util.toNumber(object.size4  ?? st._properties.size4.default);

				if(s.slot===1 && size3) object.size3=s.size;
				if(s.slot===2 && size4) object.size4=s.size;
				clearTimeout(sizetimer);

				sizetimer=setTimeout(function (){
					editor.showProperties();
					editor.requestSave();
				},500);
			}
		}
	}

}

function refreshDashboardButtons(){
	let bb=dom._editor_toolbar_left.querySelectorAll('a-button');
	for(let i=0; i<bb.length; i++){
		let b=bb[i];
		let v=b.getAttribute('value');
		b.classList.toggle('pressed',v===object.layout);
	}
}

function setLayout(e){
	object.layout=this.getAttribute('value');
	editor.showProperties();
	editor.requestSave();
	drawDashboard();
}