/*--PSEUDO-CODE--*/

if(locale("ru")){
	var $params="Параметры";
	var $drivers="Драйверы";
	var $script="Скрипт";
	var $scripts="Скрипты";
	var $scripts_desc="Скрипты";
	var $param="Параметр";
	var $params_desc="Параметры узла";
	var $nodes="Узлы";
	var $nodes_desc="Узлы, ассоциированные с прототипом";
	var $total="Всего: %s";
	var $no_nodes="Нет узлов, ассоциированных с данным прототипом";
	var $var="Переменная";
	var $select_property="Выбор свойства";
	var $select_property_desc="Выберите драйвер и свойство переменой, к которому будет применим параметр";
	var $select_driver="Выберите драйвер";
	var $select_property="Выберите свойство";
	var $name_used="Имя уже используется в драйвере %s";
	var $report="Отчет";
	var $reports="Отчеты";
	var $reports_desc="Отчеты по разнице показателей за период";
	var $make_status_var="Назначить переменную индикатором статуса";
	var $made_status_var="Переменная назначена индикатором статуса в свойствах прототипа";
	var $make_alarms="Сгенерировать тревожные переменные";
}else{
	var $params="Parameters";
	var $drivers="Drivers";
	var $script="Script";
	var $scripts="Scripts";
	var $scripts_desc="Scripts";
	var $param="Parameter";
	var $params_desc="Node parameters";
	var $nodes="Nodes";
	var $nodes_desc="Nodes associated with the prototype";
	var $total="Total: %s";
	var $no_nodes="No nodes associated with this prototype";
	var $var="Var";
	var $select_property="Select property";
	var $select_property_desc="Select the driver and variable property to which the parameter will be applied";
	var $select_driver="Select driver";
	var $select_property="Select property";
	var $name_used="The name is already in use in driver %s";
	var $report="Report";
	var $reports="Reports";
	var $reports_desc="Reports on the difference in indicators for the period";
	var $make_status_var="Make the var an status indicator";
	var $made_status_var="The variable is assigned as a status indicator in the prototype properties";
	var $make_alarms="Generate alarm variables";
}

TEMPLATE = createTemplate(
	`#node_list{padding:20px;display:flex;flex-direction:column;flex-wrap:wrap;height:100%;align-content:flex-start}#node_list>div{margin-bottom:10px;margin-right:40px}#node_list>div a-icon{vertical-align:middle;position:relative;top:-2px}`,
);

PROTO=widgetEditorProtoCommon;

ONCREATE=create;
ONDESTROY=destroy;

PROPERTIES={
	select:{
		type:'object',
		propagate:false,
	},
};

let editor,object,content,nodes,tabDriver,tabParams,tabScripts,tabReports;
let curtab,intCounts;

let tabDriverProto=function (){
	
this.show=show;

function show(){

	let type=editor.tab.key;
	let driver=type.substring(10);

	let st=schema.types[type];
	schema._typeProperties[type]=undefined;
	let addParams={};

	let clipboardType = st.clipboardType ? st.clipboardType : type;
	editor.tableClipboardType=clipboardType;

	// setpup params defs
	for(let i=0; i<st.properties.length; i++){
		let p=st.properties[i];
		if(p.init) addParams[p.key]=p.init;
		p.customdef=getParamSubstitution(driver,p.key);
	}

	editor.showLeftToolbar([
		{
			key:'add',
			defname:st.defaultVarName || 'var',
			caption:$var,
			params:addParams,
			onclick:function (){
				let names=[];
				for(let k in content.drivers){
					let d=content.drivers[k];
					for(let i=0; i<d.length; i++){
						let v=d[i];
						names.push(v.name);
					}
				}
				editor.addRow(this.defname,names,this.params);
			}
		},
		'-',
		{key:'clone',onclick:function (){
			editor.cloneRows(undefined,getNames());
		}},
		{key:'cut'},
		{key:'copy'},
		{key:'paste',clipboardType:clipboardType,onclick:function (){
			editor.pasteRows(getNames());
		}},
		'-',
		{key:'moveup'},
		{key:'movedown'},
		'-',
		{key:'increase'},
		{
			key:'status_var',
			title:$make_status_var,
			icon:'/images/online.svg',
			enableBySelect:1,
			onclick:function (){
				let v=grid.getSelectedRecords()[0];
				object.status_var=v.name;
				pult.showTooltip(self,$made_status_var);
				//grid.unselect();
				editor.requestSave();
			}
		},
		{
			key:'make_alarm',
			title:$make_alarms,
			icon:'/images/alarms.svg',
			enableBySelect:true,
			onclick:function (){
				makeAlarms();
			}
		},
		'-',
		{key:'delete'}
	]);

	editor.showRightToolbar([
		{key:'filter'}
	]);

	if(!content.drivers[driver]) content.drivers[driver]=[];

	grid=editor.showTable(type);
	let x=grid.columns[0];
	x.onrender=function (value,record,column,index,row,cell,refresh) {
		row.classList.toggle("inactive",record.extra_server_active===false);
	}
	
	grid.records=content.drivers[driver];

	if(self.select){
		setTimeout(function (){
			let ss=[];
			for(let i=0; i<self.select.length; i++){
				let name=self.select[i];
				let j=grid.records.findIndex(function (r){
					return r.name===name;
				});
				if(j>=0){
					ss.push(j);
				}
			}
			grid.select(ss);
		},10);
	}


	editor.onvalidate=function (objects,types,key,value,control){
		if(key==='name'){
			let o=objects[0];
			for(let k in content.drivers){
				let d=content.drivers[k];
				for(let i=0; i<d.length; i++){
					let v=d[i];
					if(v!==o && v.name===value){
						if(k!==driver){
							return Util.format($name_used,k.substring(4).toUpperCase());
						}
					}
				}
			}
		}
		return true;
	}
}

function getNames(){
	let names=[];
	for(let k in content.drivers){
		let d=content.drivers[k];
		for(let i=0; i<d.length; i++){
			let v=d[i];
			names.push(v.name);
		}
	}
	return names;
}

function makeAlarms(){
	let vv=grid.getSelectedRecords();
	let names=getNames();
	let added=[];
	let alarms=content.drivers.drv_alarm;
	if(!alarms) alarms=content.drivers.drv_alarm=[];
	for(let i=0; i<vv.length; i++){
		let v=vv[i];
		let name='alarm_'+v.name;
		if(names.includes(name)) name=Util.getNextName(name,names);
		let a={
			name:name,
			drv_signal:'$'+v.name,
			extra_server_description:v.extra_server_description,
			extra_server_tags:v.extra_server_tags,
		};
		names.push(a.name);
		added.push(a.name);
		alarms.push(a);
	}

	//pult.showTooltip(self,$made_status_var);
	//grid.unselect();
	editor.requestSave();
	self.select=added;
	self.tab='prototype_drv_alarm';
}
};

let tabParamsProto=function (){
	
let grid;

this.show=show;
this.hide=hide;

let lastAppDriver;
let lastAppProp;
let lastAppList;

function show(){

	editor.showLeftToolbar([
		{
			key:'add',
			defname:'param',
			caption:$param
		},
		'-',
		{key:'clone'},
		{key:'cut'},
		{key:'copy'},
		{key:'paste',clipboardType:'prototype_param'},
		'-',
		{key:'moveup'},
		{key:'movedown'},
		'-',
		{key:'delete'}
	]);

	editor.showRightToolbar([
		{key:'filter'}
	]);

	grid=editor.showTable('prototype_param');
	grid.records=content.params;

	window.prototypeParamSelectApplication=function (control){

		let drivers=[];
		let drvtypes=[];
		let max=0;
		for(let k in schema.types){
			if(k.startsWith('prototype_drv_')){
				let st=schema.types[k];
				let dt={
					name:k.substring(10),
					caption:k.substring(14).toUpperCase(),
					desc:locale_string(st.drvdesc)
				};
				drvtypes.push(dt);
				max = dt.caption.length > max ? dt.caption.length : max;
			}
		}

		for(let i=0; i<drvtypes.length; i++){
			let dt=drvtypes[i];
			drivers.push([
				dt.name,
				(dt.caption+' ').padEnd(max+1,'.') + '... ' + dt.desc,
			]);
		}

		

		let form=pult.showForm(self,{
			caption:$select_property,
			hide_by_click:false,
			submit:null,
			cancel:null,
			width:400,
			html:[
				{
					tag:'div',
					html:$select_property_desc,
					class:'comment mb20'
				},
				{
					tag:'a-select',
					placeholder:$select_driver,
					list:drivers,
					value:lastAppDriver,
					name:'driver',
					class:'mb10',
					width:'100%',
					validation:['notEmpty'],
					onchange:function (e){
						let drv=e.detail;
						form.dom.prop.disabled=false;
						setTimeout(function (){
							form.dom.prop.focus();
						},100);

						let st=schema.types['prototype_'+drv];

						let props=[];
						for(let i=0; i < st.properties?.length; i++){
							let p=st.properties[i];
							let name;
							//if(!p.control || p.control==='input' || p.control==='textarea' || p.control==='edit'){
								if(p.group){
									name = locale_string(p.group) + (p.caption ? ' | ' + locale_string(p.caption) : '');
								}else{
									name = locale_string(p.caption);
								}
								props.push([
									p.key, 
									name
								]);
							//}
						}
						form.dom.prop.list=props;
						lastAppList=props;
					}
				},
				{
					tag:'a-combo-list',
					placeholder:$select_property,
					name:'prop',
					list:lastAppList,
					focusable:true,
					width:'100%',
					height:200,
					disabled:!lastAppProp,
					validation:['notEmpty'],
					onchange:function (){
						form.submit();
					}
				}
			],
			onsubmit:function (e){
				let data=e.detail;
				let v=control.value || '';
				if(v) v=v+'\n';
				v+=data.driver+'.'+data.prop;
				control.value=v;
				control.fire('change',control.value);
				lastAppDriver=data.driver;
				lastAppProp=data.prop;
			}
		});
	}

}

function hide(){
	delete window.prototypeParamSelectApplication;
}


};

let tabScriptsProto=function (){
	
let grid;
this.show=show;


function show(){

	editor.showLeftToolbar([
		{
			key:'add',
			defname:$script,
			caption:$script
		},
		'-',
		{key:'clone'},
		{key:'cut'},
		{key:'copy'},
		{key:'paste',clipboardType:'prototype_script'},
		'-',
		{key:'moveup'},
		{key:'movedown'},
		'-',
		{key:'delete'}
	]);

	editor.showRightToolbar([
		{key:'filter'}
	]);

	grid=editor.showTable('prototype_script');
	grid.records=content.scripts;

	let c=grid.getColumnByKey('type');
	c.onrender=function (value,record,column,index,row,cell,refresh){
		if(record.inactive) row.classList.add('inactive');
		if(record._cut)	row.classList.add('cut');
		cell.innerHTML=grid.getIconFormat('/images/script.svg',$script,`#editor/prototype_script?path=${editor.object._path}&name=${record.name}`);
	}

}
};

let tabReportsProto=function (){
	
let grid;
this.show=show;


function show(){
	console.log('reports show',editor.tab.key);

	editor.showLeftToolbar([
		{
			key:'add',
			defname:$report,
			caption:$report
		},
		'-',
		{key:'clone'},
		{key:'cut'},
		{key:'copy'},
		{key:'paste',clipboardType:'prototype_report'},
		'-',
		{key:'moveup'},
		{key:'movedown'},
		'-',
		{key:'delete'}
	]);

	editor.showRightToolbar([
		{key:'filter'}
	]);

	grid=editor.showTable('prototype_report');
	grid.records=content.reports;

	let c=grid.getColumnByKey('type');
	c.onrender=function (value,record,column,index,row,cell,refresh){
		row.classList.toggle('inactive',!!record.inactive);
		if(record._cut)	row.classList.add('cut');
		cell.innerHTML=grid.getIconFormat('/images/report.svg',$report,`#editor/prototype_report?path=${editor.object._path}&name=${record.name}`);
	}

}
};

let tabNodesProto=function (){
	
this.show=show;

function show(){
	console.log('nodes show',editor.tab.key);

	dom._editor_content.innerHTML='';
	let list=[];

	for(let i=0; i<nodes.length; i++){
		let o=nodes[i];
		list.push(`<div><a href='${o._editor}'><a-icon width=16 height=16 src='${o._icon}'></a-icon> ${pult.getPseudoPath(o._path,undefined,2)}</a></div>`);
	}

	if(list.length){
		dom._editor_content.innerHTML=`
			<div id='node_list'>
				${list.join('')}
			</div>
		`;
	}else{
		dom._editor_content.innerHTML=`
			<div class='pult_empty'>${$no_nodes}</div>
		`;
	}

	editor.showLeftStatus(Util.format($total,nodes.length));

}
};

function create(){
	editor=self.editor;
	

	tabDriver=new tabDriverProto();
	tabParams=new tabParamsProto();
	tabScripts=new tabScriptsProto();
	tabReports=new tabReportsProto();
	tabNodes=new tabNodesProto();

	let tabs=[];

	tabs.push({
		key:'prototype_params',
		caption:$params,
		desc:$params_desc,
		onshow:show,
		onhide:hide,
	});
	
	tabs.push({
		key:'prototype_scripts',
		caption:$scripts,
		desc:$scripts_desc,
		onshow:show,
		onhide:hide,
	});

	tabs.push({
		key:'prototype_reports',
		caption:$reports,
		desc:$reports_desc,
		onshow:show,
		onhide:hide,
		right_border:true,
	});
	
	tabs.push({
		key:'prototype_drivers',
		caption:$drivers+':',
		disabled:true,
	});

	for(let k in schema.types){
		if(k.startsWith('prototype_drv_')){
			let st=schema.types[k];
			let t=st.drvtitle || k.substring(14).toUpperCase();
			tabs.push({
				key:k,
				caption:t,
				desc:st.drvdesc,
				onshow:show,
				onhide:hide,
			});
		}
	}

	tabs[tabs.length-1].right_border=true;

	tabs.push({
		key:'prototype_nodes',
		caption:$nodes,
		desc:$nodes_desc,
		right_border:true,
		onshow:show,
		onhide:hide,
	});
	
	let access_tab=Util.merge(editor.EDITOR_TABS['access'],{
		key:'access',
		onshow:show,
		onhide:hide,
	});

	tabs.push(access_tab);
	
	tabs.push('code');

	for(let i=0; i<tabs.length; i++){
		let t=tabs[i];
		t._caption=t.caption;
	}

	editor.tabs=tabs;

	dom._editor_tabs.css=`#container div span:nth-child(2){background:var(--app-text-color);color:var(--app-background-color);padding:1px 3px 0;position:relative;top:-1px;font-weight:700;border-radius:2px}#container div.selected span:nth-child(2){background:var(--app-active-text-color)}`;

	intCounts=setInterval(refreshCounts,100);

}

function destroy(){
	clearInterval(intCounts);
}

function show(){

	object=editor.object;
	if(!object) return;

	editor.onsave=cbSave;
	loadContent(showTab);

}

function hide(){
	hideTab();
}

function showTab(){
	if		(editor.tab.key==='prototype_params')				curtab=tabParams;
	else if	(editor.tab.key==='prototype_scripts')				curtab=tabScripts;
	else if	(editor.tab.key==='prototype_reports')				curtab=tabReports;
	else if	(editor.tab.key==='prototype_nodes')				curtab=tabNodes;
	else if	(editor.tab.key.startsWith('prototype_drv_'))		curtab=tabDriver;
	else if	(editor.tab.key==='access')							curtab=editor.tabAccess;
	curtab.show();
}

function hideTab(){
	if(curtab && curtab.hide) curtab.hide();
}

function loadContent(handler){

	let file='@content.json';

	if(object[file]){
		handler();
	}else{
		
		object[file]={};
		Util.promises(function (resolve){
			pult.fdb.loadDoc(self,object._path,{
				file:file,
				format:'json',
			},function (req,res,err){
				if(err && err.message!=='FDB_ERROR_DOC_NOT_FOUND'){
					pult.showError(self,err);
				}
				let doc=object[file]=res;
				if(!doc) doc=object[file]={
					format:'json',
					data:null,
				};
				content=doc.data;
				if(!content) content=doc.data={};
				if(!content.params) content.params=[];
				if(!content.reports) content.reports=[];
				if(!content.scripts) content.scripts=[];
				if(!content.drivers) content.drivers={};

				let vc=0;
				for(let k in content.drivers){
					let d=content.drivers[k];
					if(d.length && !content._drivers?.[k]){
						editor.requestSave();
						break;
					}
				}

				resolve();
			});

		},function (resolve){
			
			pult.request(self,'fdb_prototype_nodes',{
				path:object._path,
			},function (req,res,err){
				if(err){
					pult.showModalError(self,err);
				}else{
					for(let i=0; i<res.length; i++){
						res[i]=pult.fdb.unpack(res[i]);
					}
					Util.keySort(res,'_path');
					nodes=res;
					resolve();
				}
			});
		},function (){
			refreshCounts();			
			handler();
		});
	}
}

function refreshCounts(){
	if(content && nodes){
		let tabs=dom._editor_tabs;
		showTabCount('prototype_nodes',nodes.length);
		showTabCount('prototype_params',content.params.length);
		showTabCount('prototype_reports',content.reports.length);
		showTabCount('prototype_scripts',content.scripts.length);
		for(let i=0; i<tabs.tabs.length; i++){
			let t=tabs.tabs[i];
			if(t.key.startsWith('prototype_drv_')){
				let driver=t.key.substring(10);
				showTabCount(t.key,content.drivers[driver]?.length);
			}
		}
	}
}

function showTabCount(key,count){
	let tabs=dom._editor_tabs;
	let c=tabs.getTab(key)._caption;
	if(count){
		tabs.setCaption(key,`<span>${c}</span>&nbsp;<span>${count}</span>`);
	}else{
		tabs.setCaption(key,`<span>${c}</span>`);
	}
}

function getParamSubstitution(driver,field){
	for(let i=0; i<content.params.length; i++){
		let prm=content.params[i];
		if(prm.application){
			let aa=prm.application.split('\n');
			for(let i=0; i<aa.length; i++){
				let a=aa[i];
				let [drv,prop]=a.split('.');
				if(!prop){
					prop=drv;
					drv='*';
				}
				if(drv==='*' || drv===driver){
					if(prop===field){
						return `%${prm.name}%`;
					}
				}
			}
		}
	}
}

function cbSave(objects){
	if(objects.length===1 && objects[0]._type==='prototype'){
		let spp=schema.types.prototype_param._properties;
		for(let i=0; i<content.params.length; i++){
			let p=content.params[i];
			for(let k in p){
				let sp=spp[k];
				if(sp && sp.visibleIf){
					let v=Util.checkIf(p,sp.visibleIf);
					if(!v)	delete p[k];
				}
			}
		}

		content._drivers={};

		// setpup params defs
		let drivers=content.drivers;
		let _drivers=content._drivers;
		for(let driver in drivers){
			_drivers[driver]=[];
			let vars=drivers[driver];
			let _vars=_drivers[driver];

			let pp=schema.types[`prototype_`+driver]._properties;

			let defs={};
			let drvdefs={};

			for(let k in pp){
				let p=pp[k];
				if(p.def!==undefined) defs[k]=p.def;
				if(p.drvdef!==undefined) drvdefs[k]=p.drvdef;
			}


			for(let i=0; i<vars.length; i++){
				
				let v=vars[i];

				if(v.extra_server_active!==false){

					v=Util.clone(v);
					
					for(let k in pp){
						let p=pp[k];
						if(Util.checkIf(v,p.visibleIf,defs)){
							let subst=getParamSubstitution(driver,k);
							let def=defs[k];
							let drvdef=drvdefs[k];
							if(def!==undefined && drvdef===def) def=undefined;
							if(v[k]===undefined && subst!==undefined) v[k]=subst;
							if(v[k]===undefined && def!==undefined)   v[k]=def;
						}else{
							if(v[k]!==undefined) v[k]=undefined;
						}
					}
					
					// v.extra_server_active=undefined;
					// v.extra_data=undefined;
					// v.extra_data=undefined;

					for(let k in v){
						if(v[k]===undefined){
							delete v[k];
						}else if(k.startsWith('extra_service')){
							//
						}else if(k.startsWith('extra_server')){
							//
						}else if(k.startsWith('extra_')){
							delete v[k];
						}
					}

					let kv=[];
					for(let k in v){
						kv.push([k,v[k]]);
					}
					Util.keySort(kv,0);
					
					v={};
					for(let i=0; i<kv.length; i++){
						v[kv[i][0]]=kv[i][1];
					}

					_vars.push(v);
				}
			}

		}
	

	}
}

