/*--PSEUDO-CODE--*/

if(locale("ru")){
	var $editor="Редактор";
	var $reports="Отчеты";
	var $report="Отчет";
	var $report_desc="Отчет по разнице показателей за период";
	var $indicator='Показатель';
	var $report_not_found="Отчет не найден";
}else{
	var $editor="Редактор";
	var $reports="Reports";
	var $report="Report";
	var $report_desc="Report on the difference in indicators for the period";
	var $indicator='Indicator';
	var $report_not_found="Report not found";
}

PROTO=widgetEditorProtoCommon;

PROPERTIES=[
	'name'
];


ONCREATE=create;

let editor;
let object;
let content;
let report;

function create(){
	editor=self.editor;
	object=editor.object;
	editor.tabs=[
		{
			key:'report',
			caption:$report,
			desc:$report_desc,
			onshow:show,
			dontShowObjectProps:true,
		}
	];

}


function show(){

	object=editor.object;
	if(!object) return;
	//editor.onsave=cbSave;
	dom.btn_export.hidden=1;

	let obj=object;
	let path=[];
	while(obj){
		path.unshift([obj._title,obj._editor]);
		obj=obj._parent;
	}
	path.unshift([$editor,'#editor/home?tab=home']);
	path.push([$reports,`#editor/prototype?path=${object._path}&tab=prototype_reports`]);
	pult.showPath(self,path);

	editor.showTitle(self.name,'/images/report.svg');

	let file='@content.json';
	pult.fdb.loadDoc(self,object._path,{
		file:file,
		format:'json',
	},function (req,res,err){
		if(err && err.message!=='FDB_ERROR_DOC_NOT_FOUND'){
			pult.showError(self,err);
		}
		let doc=object[file]=res;
		if(!doc) doc=object[file]={
			format:'json',
			data:null,
		};
		content=doc.data;
		report=content?.reports?.find(function (r){
			if(r.name===self.name) return r;
		});

		if(report){

			dom._editor_tab_inactive.style.display=(report.inactive ? 'block' : 'none');
			if(!report.indicators) report.indicators=[];

			editor.showLeftToolbar([
				{
					key:'add',
					defname:$indicator,
					caption:$indicator
				},
				'-',
				{key:'clone'},
				{key:'cut'},
				{key:'copy'},
				{key:'paste',clipboardType:'prototype_report_indicator'},
				'-',
				{key:'moveup'},
				{key:'movedown'},
				'-',
				{key:'delete'}
			]);
		
			editor.showRightToolbar([
				{key:'filter'}
			]);
		
			grid=editor.showTable('prototype_report_indicator');
			grid.records=report.indicators;

			grid.onselect=function (e){
				editor.refreshToolbarButtons();
				editor.refreshStatus();

				let oo=grid.getSelectedRecords();
				if(oo.length){
					editor.showProperties(oo,editor.tableSchemaType);
				}else{
					editor.showProperties(report,'prototype_report');
				}

			};

			editor.showProperties(report,'prototype_report');


		}else{
			pult.showModalError(self,$report_not_found);
		}
		

	});




}