/*--PSEUDO-CODE--*/

if(locale("ru")){
	var $editor="Редактор";
	var $scripts="Скрипты";
	var $script="Скрипт";
	var $script_desc="Ограниченный JavaScript";
	var $script_not_found="Скрипт не найден";
	var $debug="Отладка";
    var $inout_var="Переменная";
    var $inout_input="Ввод";
    var $inout_output="Вывод";
    var $run_in_emulator="Выполнить в эмуляторе (Ctrl+R)";
    var $setup_debug_values="Установите значения переменных на вводе и выполните скрипт в эмуляторе чтобы проверить его работу";
    var $var_not_recognized="Переменные не найдены.<br>Используйте $ перед именем переменной.<br> Например: $room_setpoint";
    var $debug_executed="Выполнено за %s мс";
    var $swap_inbyout="Передать вывод на ввод для нового цикла";
    var $console_log_out="Консоль отладки | Вывод функции print()";
    var $script_lines="Всего строк";
}else{
	var $editor="Редактор";
	var $scripts="Scripts";
	var $script="Script";
	var $script_desc="Restricted JavaScript";
	var $script_not_found="Script not found";
	var $debug="Debug";
    var $inout_var="Variable";
    var $inout_input="Input";
    var $inout_output="Output";
    var $run_in_emulator="Run in emulator (Ctrl+R)";
    var $setup_debug_values="Set the input var values and run the script in the emulator to test it.";
    var $var_not_recognized="Vars not found.<br>Use $ before var name.<br> Example: $room_setpoint";
    var $debug_executed="Executed by %s ms";
    var $swap_inbyout="Pass output to input for new cycle";
    var $console_log_out="Debug console | Output of function print()";
    var $script_lines="Code lines";
}

PROTO=widgetEditorProtoCommon;

PROPERTIES=[
	'name'
];

TEMPLATE = createTemplate(
	`#script{height:100%;display:flex;flex-direction:row;overflow:hidden;border-bottom:solid 1px var(--app-background-color)}#script_debcont .comment{margin-top:20px;padding-top:10px;border-top:solid 1px var(--app-control-color);color:var(--app-comment-color)}#script_debcont .hor{display:flex;flex-direction:row;justify-content:space-between;align-items:center}#script_debug{padding:20px}#script_input{overflow:auto}#script_inout{width:500px!important;flex-shrink:0;display:flex;flex-direction:column}#script_inout>div:first-child{display:flex;flex-direction:column;overflow:hidden}#btn_debug{--background-color:var(--app-orange-color);--text-color:var(--app-active-text-color)}#script_inpcont{border-top:solid 1px var(--app-control-color);height:100%;overflow:hidden;display:flex;flex-direction:column}#script_inpcont .empty{color:var(--app-comment-color);text-align:center;margin-top:30vh}#script_inhd{width:100%;display:flex;flex-direction:row;background-color:var(--app-control-color);text-transform:uppercase}#btn_swap{text-decoration:underline dashed;cursor:pointer;user-select:none;margin-top:10px;display:inline-block}#btn_swap:hover{color:var(--app-active-text-color)}#console_log{padding:10px;margin:0;overflow:auto;font-size:12px;color:#CCC;background-color:#000;flex-grow:1}#conscont{display:flex;flex-direction:column}#conscont h1{font-size:12px;padding:0 10px;line-height:28px;margin:0;background-color:var(--app-grid-header-color);border:none;border-top:solid 1px var(--app-control-color);font-weight:700;flex-shrink:0;flex-grow:0}#script_text{display:none}.CodeMirror{width:100%;height:100%!important;font-family:'JetBrains Mono'!important;font-size:12px!important}`
);

ONCREATE=create;

let editor;
let object;
let content;
let script;

let varnames=[];
let scriptEditor;
let input_values={};
let output_values={};

function create(){
	
	self.showLoading();

	editor=self.editor;
	object=editor.object;
	editor.tabs=[
		{
			key:'script',
			caption:$script,
			desc:$script_desc,
			onshow:show,
			dontShowObjectProps:true,
		}
	];

}


function show(){

	self.showLoading();

	object=editor.object;
	if(!object) return;

	dom.btn_export.hidden=1;
	dom._editor_content.innerHTML=`<div id="script">
	<a-layout id='editor_layout_script' orientation="horizontal" stretch='slot1' size2=500 store=true>
		<div slot='1'>
			<textarea id='script_text'></textarea>
		</div>
		<a-layout id="script_inout" slot='2' orientation="vertical" stretch='slot1' size2=150 store=true>
			<div slot='1'>
				<div id="script_debcont">
					<div id="script_debug">
						<div class="hor">
							<a-button id="btn_debug" focusable=0  icon="/images/play.svg" caption="${$run_in_emulator}" ></a-button>
							<div id="script_debug_time"></div>
						</div>
						<div class="comment">${$setup_debug_values}</div>
						<div><span id='btn_swap'>${$swap_inbyout}</span></div>
					</div>
				</div>
				<div id="script_inpcont">
					<a-grid id="script_input"></a-grid>
				</div>
			</div>
			<div id="conscont" slot='2'>
				<h1>${$console_log_out}</h1>
				<pre id="console_log"></pre>
			</div>
		</a-layout>
	</a-layout>
</div>`;

	dom.btn_debug.onclick=debug;

	editor.onsave=cbSave;

	let obj=object;
	let path=[];
	while(obj){
		path.unshift([obj._title,obj._editor]);
		obj=obj._parent;
	}
	path.unshift([$editor,'#editor/home?tab=home']);
	path.push([$scripts,`#editor/prototype?path=${object._path}&tab=prototype_scripts`]);
	pult.showPath(self,path);

	editor.showTitle(self.name,'/images/script.svg');

	let file='@content.json';
	pult.fdb.loadDoc(self,object._path,{
		file:file,
		format:'json',
	},function (req,res,err){
		if(err && err.message!=='FDB_ERROR_DOC_NOT_FOUND'){
			pult.showError(self,err);
		}else{
			let doc=object[file]=res;
			if(!doc) doc=object[file]={
				format:'json',
				data:null,
			};
			content=doc.data;
			script=content?.scripts?.find(function (s){
				if(s.name===self.name) return s;
			});

			if(script){

				dom.script_text.innerHTML=script.content || '';
				dom._editor_tab_inactive.style.display=(script.inactive ? 'block' : 'none');
						
				editor.showProperties(script,'prototype_script');

				Util.loadjss(['/index/codemirror.js','/index/codemirror.css'],function (e){
					let t=createTemplate(e[1]);
					self.append(t);
					initScript();
					self.hideLoading();
				});

			}else{
				pult.showModalError(self,$script_not_found);
			}
		}
	});

}

function initScript(){
	let grid=dom.script_input;

    grid.columns=[
        {
            key:"var",
            caption:$inout_var,
            onrender:function (value,record,column,index,row,cell,refresh) {
				if(refresh){
					row.classList.remove('updated');
					row.classList.add('updated');
				}
			},
        },
        {
            key:"input",
            caption:$inout_input,
            width:150,
            align:'right',
            edit:'number',
            editor_save_by_exit:true,
        },
        {
            key:"output",
            caption:$inout_output,
            width:150,
            align:'right',
        },
    ];

    grid.sort_column=0;
    grid.css=``;

    grid.onchange=function (e){
        let r=e.detail.record;
        input_values[r.var]=r.input;
    }

    let lwt=dom.editor_layout_script;
    lwt.onresize=function (e){
        let r=e.detail;
        if(r.slot===2){
            grid.columns[0].width=r.size-330;
        }
        grid.resize();
    }

    dom.btn_swap.onclick=function (){
        console.log('swap');
        for(let i=0; i<grid.records.length; i++){
            let r=grid.records[i];
            input_values[r.var]=r.output;
            if(r.input!==r.output){
                grid.setRecordValue(i,'input',r.output);
                grid.refreshRow(i);
            }
        }
    }

    scriptEditor = CodeMirror.fromTextArea(dom.script_text, {
        matchBrackets: true,
        autoCloseBrackets: true,
        mode: "application/json",
        lineWrapping: true,
        lineNumbers: true,
        lint: { 'esversion': '6' },
        foldGutter: true,
        theme: 'pult-'+pult.config.theme,
        styleActiveLine: { nonEmpty: true },
        extraKeys: {
            "Shift-Ctrl-D": "duplicateSelected",
            "Ctrl-D": "duplicateSelection",
            "Ctrl-R": "run",
        },
        gutters: ["CodeMirror-lint-markers","CodeMirror-linenumbers", "CodeMirror-foldgutter"]
    });

    refreshVars();

    editor.showLeftStatus($script_lines+': '+scriptEditor.lineCount());
    //scriptEditor.setValue(script.content);
    
    let tmr1;

    scriptEditor.on("change",function(){
        script.content=scriptEditor.getValue();
        editor.requestSave([editor.object]);
        editor.showLeftStatus($script_lines+': '+scriptEditor.lineCount());
        
        clearTimeout(tmr1);
        tmr1=setTimeout(function (){
            refreshVars();
        },500);
    });

    CodeMirror.commands.run = function(cm) {
        debug();
    };

    CodeMirror.commands.duplicateSelected = CodeMirrorDuplicateSelected;
    CodeMirror.commands.duplicateSelection = CodeMirrorDuplicateSelection;

    function getVars(code){
        let start=-1;
        let vars=[];
        for(let i=0; i<=code.length; i++){
            let a=code[i];
            let c=a?a.charCodeAt(0):0;
            if(a==='$'){
                start=i;
            }else if(start>=0){
                if(!((c>=48 && c<=57)
                  || (c>=65 && c<=90)
                  || (c>=97 && c<=122)
                  || (a==='_')
                )){
    
                    let v=code.substr(start,i-start);
                    if(vars.indexOf(v)<0) vars.push(v);
                    start=-1;
    
                }
            }
        }
        Util.sort(vars);
        return vars;
    }


    function refreshVars(){
        
        let grid=dom.script_input;
        let records=[];

        let code=scriptEditor.getValue();
        let vars=getVars(code);

        if(!input_values) input_values={};
        
        if(vars.length){
                  
            for(let i=0; i<vars.length; i++){
                let v=vars[i];
                if(input_values[v]===undefined) input_values[v]=0;
                let val=input_values[v];
                records.push({
                    var:v,
                    input:val,
                    output:output_values[v] || 0,
                });
                //rows.push(`<tr><td>${v}</td><td><a-number  value=${val} var_name=${v}></a-number></td><td><span var_name=${v}>0</span></td></tr>`);
            }


            // dom.script_input.innerHTML=`<table>${rows.join('')}</table>`;
    
            // let nn=dom.script_input.querySelectorAll('a-number');
            // for(let i=0; i<nn.length; i++){
            //     let n=nn[i];
            //     let v=n.getAttribute('var_name');
            //     n.onchange=function(){
            //         input_values[v]=this.value;
            //         //console.log(v,this.value);
            //     }
            // }
    
        }else{
            dom.script_input.innerHTML=`<div class='empty'>${$var_not_recognized}</div>`;
        }
    
        grid.records=records;

    }

}



function CodeMirrorDuplicateSelected(cm) {

    var selection = cm.getSelection();
    if(selection.length){
        var from = cm.getCursor("start");
        var to = cm.getCursor("end");
        console.log(from,to);
        var text = cm.getRange(from, to);
        cm.replaceRange(text, to);
        cm.setSelection(to, cm.getCursor("end"));
    }else{
        var from = cm.getCursor();
        cm.replaceRange(cm.getLine(from.line) + "\n", {line: from.line + 1, ch: 0});
        cm.setCursor({line: from.line + 1, ch: from.ch});
    }
  
};
  
function CodeMirrorDuplicateSelection(cm) {
    
    setTimeout(function(){
      cm.focus();
    },100);
  
    var lastSel = cm.listSelections()[cm.listSelections().length - 1];
    var from = lastSel.anchor;
    var to = lastSel.head;
    var selectedText = cm.getRange(from,to);
    var cursor = cm.getSearchCursor(selectedText);
    cursor.pos.from=from;
    cursor.pos.to=to;
    if (cursor.findNext()) {
        cm.addSelection(cursor.from(), cursor.to());
    }else{
        cursor.pos.from.line=0;
        cursor.pos.from.ch=0;
        cursor.pos.to.line=0;
        cursor.pos.to.ch=0;
        if (cursor.findNext()) {
            cm.addSelection(cursor.from(), cursor.to());
        }
    }
  
};


function debug(){

    let values=input_values;
    let nn=dom.script_input.querySelectorAll('a-number');
    
    let icon=dom.btn_debug.icon;
    dom.btn_debug.submit_start();

    let code=scriptEditor.getValue();
    let timeout=editor.object.script_timeout;

    pult.request(self,'script_debug',{
        
        code:code,
        timeout:timeout,
        values:values,

    },function(req,res,err){

        setTimeout(function(){
            dom.btn_debug.submit_reset();
            dom.btn_debug.icon=icon;
        },100);

        if(err){
            pult.showInfo(self,pult.errstr(err));
        }else{

            dom.console_log.innerHTML=res.console;

            let time=res.time;
            let grid=dom.script_input;
            dom.script_debug_time.innerHTML=Util.format($debug_executed,time);
            let values=res.values;

            for(let i=0; i<grid.records.length; i++){
                let r=grid.records[i];
                let v=values[r.var];
                if(v===undefined) v=input_values[r.var];
                output_values[r.var]=v;
                if(v!==r.output){
                    grid.setRecordValue(i,'output',v);
				    grid.refreshRow(i);
                }
            }

        }
    });
}


function cbSave(objects){
	if(objects.length===1 && objects[0]._type==='prototype'){
		let spp=schema.types.prototype_script._properties;
		
		script._defaults={};
		for(let k in spp){
			let def=spp[k].def;
			if(def!==undefined) script._defaults[k]=def;
		}
	}
}
