/*--PSEUDO-CODE--*/

if(locale("ru")){
	var $content="Содержание";
	var $content_desc="Содержание экрана";
	var $open_desktop_mimic="Десктопная мнемосхема";
	var $open_mobile_mimic="Мобильная мнемосхема";
}else{
	var $content="Content";
	var $content_desc="Screen content";
	var $open_desktop_mimic="Desktop mimic";
	var $open_mobile_mimic="Mobile mimic";
}

PROTO=widgetEditorProtoCommon;

TEMPLATE = createTemplate(
	`#_editor_content{position:relative}#mcontent{position:relative;height:100%;width:1100px;margin-left:40px}#desktop,#mobile{position:absolute;background-color:var(--app-background-color);outline:var(--app-background-color) solid 10px}#desktop a-icon,#mobile a-icon{--color:var(--app-button-color);width:100%;position:absolute;display:block;bottom:0;left:0}#desktop>div,#mobile>div{position:absolute;border:1px solid var(--app-background-color)}#desktop>div>a,#mobile>div>a{display:block;position:relative;width:100%;height:100%}#desktop>div>a>widget-interface-screen,#mobile>div>a>widget-interface-screen{pointer-events:none;display:block;transform-origin:0 0}#desktop{left:224px;bottom:0;width:1004px;height:820px}#desktop>div{overflow:hidden;left:41px;top:55px;width:923px;height:573px;border-radius:4px}#desktop>div>a>widget-interface-screen{width:130%;height:130%;transform:scale(.769)}#mobile{left:0;bottom:0;width:200px;height:425px;border-radius:25px;z-index:1000000}#mobile>div{overflow:hidden;left:16px;top:20px;width:169px;height:385px;border-radius:16px}#mobile>div>a>widget-interface-screen{width:200%;height:200%;transform:scale(.5)}`,
);

ONCREATE=create;

let editor;
let object;

function create(){
	editor=self.editor;
	editor.tabs=[
		{
			key:'content',
			caption:$content,
			desc:$content_desc,
			onshow:show,
			onhide:hide,
		},
		"objects",
		"access",
		"code",
	];

}

function show(){
	object=editor.object;
	if(!object) return;
	
	editor.onsaved=function (){
		refreshWidgets();
		refreshButtons();
	}
	
	// editor.onpropchange=function (oo,p){
	// 	editor.requestSave(oo,[p.key]);
	// 	if(p.key==='desktop_mimic' || p.key==='mobile_mimic'){
	// 		refreshButtons();
	// 	}
	// }
	
	editor.showLeftToolbar([
		{
			id:'btn_desktop_mimic',
			caption:$open_desktop_mimic,
			icon:'/images/mimic.svg',
		},
		{
			id:'btn_mobile_mimic',
			caption:$open_mobile_mimic,
			icon:'/images/mimic.svg',
		},
	]);

	refreshWidgets();
	refreshButtons();

}

function hide(){
	
}

function refreshButtons(){
	dom.btn_desktop_mimic.href=`#editor/mimic?path=${editor.projectPath}/mimics/${object.desktop_mimic}`;
	dom.btn_desktop_mimic.disabled=!object.desktop_mimic;	
	
	dom.btn_mobile_mimic.href=`#editor/mimic?path=${editor.projectPath}/mimics/${object.mobile_mimic}`;
	dom.btn_mobile_mimic.disabled=!object.mobile_mimic;
}

function refreshWidgets(){

	dom._editor_content.innerHTML=`<div id="mcontent">
	<div id="desktop">
		<a-icon src="/images/mockup_desktop.svg"></a-icon>
		<div>
			<a id="desktop_link"></a>
		</div>
	</div>
	<div id="mobile">
		<a-icon src="/images/mockup_mobile.svg"></a-icon>
		<div>
			<a id="mobile_link"></a>
		</div>
	</div>
</div>`;
	let path=object._path; //pult.getMimicPath(self,pult.getMimicTag(self,object.desktop_mimic));

	pult.rpc.clearCache();

	{
		let a=dom.desktop_link;
		a.innerHTML=``;
		a.innerHTML=`<widget-interface-screen id="desktop_widget"></widget-interface-screen>`;
		let w=dom.desktop_widget;
		w.setAttribute('path',path);
		w.setAttribute('mobile',false);
		w.setAttribute('show_alarms',false);
		if(object.desktop_mimic){
			a.href=`#editor/mimic?path=${pult.getMimicPath(self,pult.getMimicTag(self,object.desktop_mimic))}`;
		}else if(object.mobile_mimic){
			a.href=`#editor/mimic?path=${pult.getMimicPath(self,pult.getMimicTag(self,object.mobile_mimic))}`;
		}
	}
	
	{
		let a=dom.mobile_link;
		a.innerHTML=``;
		a.innerHTML=`<widget-interface-screen id="mobile_widget"></widget-interface-screen>`;
		let w=dom.mobile_widget;
		w.setAttribute('path',path);
		w.setAttribute('mobile',true);
		w.setAttribute('show_alarms',false);
		
		if(object.mobile_mimic){
			a.href=`#editor/mimic?path=${pult.getMimicPath(self,pult.getMimicTag(self,object.mobile_mimic))}`;
		}else if(object.desktop_mimic){
			a.href=`#editor/mimic?path=${pult.getMimicPath(self,pult.getMimicTag(self,object.desktop_mimic))}`;
		}
	}

}
