/*--PSEUDO-CODE--*/

if(locale('ru')){
	var $editor='Редактор';
	var $settings='Настройки';
	var $settings_desc='Настройки редактора';
	var $panels_settings='Настройка панелей';
	var $panel_navigation='Навигация';
	var $panel_props='Свойства';
	var $panel_controls='Контролы';
	var $panel_vars='Отладка';
	var $panel_elements='Элементы';
	var $panel_left_top='Левая верхняя панель';
	var $panel_left_bottom='Левая нижняя панель';
	var $panel_right_top='Правая верхняя панель';
	var $panel_right_bottom='Правая нижняя панель';
	var $reset_link='Сбросить на настройки по умолчанию';
	var $reset_conf='Сбросить настройки редактора на настройки по умолчанию?';
}else{
	var $editor='Editor';
	var $settings='Settings';
	var $settings_desc='Editor settings';
	var $panels_settings='Panel settings';
	var $panel_navigation='Navigation';
	var $panel_props='Properties';
	var $panel_controls='Controls';
	var $panel_elements='Elements';
	var $panel_vars='Debugger';
	var $panel_left_top='Left-Top Panel';
	var $panel_left_bottom='Left-Bottom Panel';
	var $panel_right_top='Right-Top Panel';
	var $panel_right_bottom='Right-Bottom Panel';
	var $reset_link='Reset to default settings';
	var $reset_conf='Reset editor settings to default?';
}
  

PROTO=widgetEditorProtoCommon;

TEMPLATE = createTemplate(
	``,
	``,
);

ONCREATE=create;

let editor;

function create(){

	editor=self.editor;
	//console.log('create');
	editor.showTitle($settings,'/images/settings.svg');
	editor.showDescription($settings_desc);
	editor.showPath([[$editor,'#editor/home'],[$settings,'#editor/settings']]);
	editor.selectMenuItem('/settings');

	editor.showProperties(null);

	let settings=editor.getSettings();

	let panels=[
		['panel_lt',$panel_left_top],
		['panel_lb',$panel_left_bottom],
		['panel_rt',$panel_right_top],
		['panel_rb',$panel_right_bottom],
	];

	let s=[

		{
			tag:'h1',
			html:$panels_settings
		},

		{
			tag:'a-form-row',
			caption:$panel_navigation,
			html:{
				tag:'a-select',
				name:'layout_panel_navigation',
				list:panels,
				placeholder:'panel_lt'
			}
		},

		{
			tag:'a-form-row',
			caption:$panel_props,
			html:{
				tag:'a-select',
				name:'layout_panel_props',
				list:panels,
				placeholder:'panel_lb'
			}
		},

		{
			tag:'a-form-row',
			caption:$panel_elements,
			html:{
				tag:'a-select',
				name:'layout_panel_elements',
				list:panels,
				placeholder:'panel_rt'
			}
		},
				
		{
			tag:'a-form-row',
			caption:$panel_controls,
			html:{
				tag:'a-select',
				name:'layout_panel_controls',
				list:panels,
				placeholder:'panel_rt'
			}
		},

		{
			tag:'a-form-row',
			caption:$panel_vars,
			class:'mb20',
			html:{
				tag:'a-select',
				name:'layout_panel_vars',
				list:panels,
				placeholder:'panel_rb'
			}
		},


		
		'-',

		{
			tag:'a-form-row',
			html:{
				tag:'a',
				style:{
					textDecoration:'underline dashed'
				},
				href:'javascript:void(0)',
				onclick:function (){
					pult.showConfirm(self,$reset_conf,function (){
						editor.setSettings({});
						pult.reload(true);
					});
				},
				html:$reset_link
			}
		},
		

	];


	form=pult.drawForm(dom._editor_content,s,{
		values:settings,
		cancelButton:true,
		submitButton:true,
		passwordConfirmation:true,
		onchange:function(){
			pult.needSave=true;
		},
		oncancel:function(){
			pult.needSave=false;
			pult.reload();
		},
		onsubmit:function(data){       
			form.complete();
			pult.needSave=false;
			console.log(data);       
			editor.setSettings(data);
			pult.reload(true);
		}
	});



}

