/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $menu="Навигация";
  var $props="Свойства";
  var $settings="Настройки редактора";
  var $interface="Открыть интерфейс";
  var $backups="Резервные копии";
  var $building="Сборка проектов";
  var $buildlog='Лог сборки';
  var $build_complete='Сборка выполнена';
}else{
  var $menu="Navigation";
  var $props="Properties";
  var $settings="Editor settings";
  var $interface="Goto Interface";
  var $backups="Backups";
  var $building="Building projects";
  var $buildlog='Build log';
  var $build_complete='Build completed';
}



const ACS_TYPE_VIEW = 1;
const ACS_TYPE_EXEC = 2;
const ACS_TYPE_EDIT = 4;
const ACS_SET 		= 128; // object has @access.json

let menu;
let props;
let parent;
let sub_builder;


let building;

//////////////////////////////////////////////////////////////////////////////

PROTO=widgetProtoCommon;

PROPERTIES={
	breadcrumbs:{
		type:'object',
		propagate:false,
	},
};

TEMPLATE = createTemplate(
	`#body{display:none;flex-direction:column;flex-wrap:nowrap;position:relative;width:100%;height:100%}a-frame{height:100%;border-bottom:solid 1px var(--app-control-color)}a-message{z-index:1000}#layout1{width:100%;height:100%}#left_panel_icon{left:0}#right_panel_icon{right:0}.panel_icon{z-index:200;width:35px;height:32px;position:absolute;top:0;transition-property:left,right;transition-duration:.1s;background-color:var(--app-editor-topline-color);cursor:pointer}.panel_icon svg{display:block;position:absolute;width:16px;height:16px;left:9.5px;top:8px}.panel_icon svg path{fill:var(--app-editor-topline-text-color)}a-panel{overflow:hidden;--caption-background-color:var(--app-editor-topline-color);--caption-text-color:var(--app-editor-topline-text-color);--caption-height:32px}a-panel .tabslot{padding-left:1px;border-top:solid 1px var(--app-background-color);border-left:solid 1px var(--app-form-color);background-color:var(--app-form-color)}a-panel ._mimic_controls{overflow:auto;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}a-panel ._mimic_controls a-section{margin-bottom:1px}a-panel ._mimic_controls a-icon{width:24px;height:24px;padding:4px;opacity:.5}a-panel ._mimic_controls a-icon:hover{opacity:1}a-panel ._mimic_vars a-textarea{--background-color:var(--app-card-control-color);--white-space:pre;--padding:10px;max-width:100%;height:100%}a-card{--control-background-color:var(--anode-card-control-color)}.panel_caption_pad{--caption-padding:0 10px 0 34px}#left,#mid{overflow:hidden;display:flex;flex-direction:column}#mid_header{background-color:var(--app-editor-topline-color);height:32px;border-bottom:solid 1px var(--app-shade-color);z-index:100;flex-shrink:0;color:var(--app-editor-topline-text-color);white-space:nowrap;padding-right:5px;padding-left:10px;transition:.1s padding;display:flex;flex-direction:row;justify-content:space-between;align-items:center}#body.left_closed #mid_header{padding-left:40px}#body.right_closed #mid_header{padding-right:40px}#mid_header a{text-decoration:none}#mid_header a svg path{fill:var(--app-editor-topline-text-color)}#mid_header a-button{--text-color:var(--app-editor-topline-button-text-color);--border-color:transparent;--shadow:none;--disabled-background-color:transparent;--disabled-text-color:var(--app-editor-topline-disabled-text-color);--disabled-border-color:transparent}#mid_header a-button+a-button{margin-left:-4px}#breadcrumbs{overflow:hidden;white-space:nowrap;text-overflow:ellipsis;color:var(--app-editor-topline-text-color)}#breadcrumbs a{color:var(--app-editor-topline-text-color);text-decoration:none}#breadcrumbs a:hover{color:var(--app-active-text-color)}#left_title,#mid_title{line-height:32px;white-space:nowrap;padding:0 10px;font-size:12px;text-transform:uppercase}#left_title{padding:0;font-weight:700}#left_center{flex-grow:1;overflow:auto}#menu{border-bottom:solid 1px var(--app-shade-color);--background-color:var(--app-form-color)}#props{height:100%;background-color:var(--app-form-color);--group-background-color:var(--app-header-color);--group-text-color:var(--app-header-text-color);--background-color:var(--app-form-color);--value-text-color:var(--app-soft-green-color);--value-font:inherit;--caption-font-weight:normal;--border-color:var(--app-control-color)}`,
	`<div id="body">
	<a-layout id='editor_layout1' stretch='slot2' size1=340 store=true >
		
		<!-- LEFT -->

		<div id='left' slot='1'>
			<a-layout id='editor_layout4' orientation="vertical" min_size1="32" min_size2="32" stretch='slot1' store=true  >
				<a-panel id="panel_lt" slot="1"></a-panel>
				<a-panel id="panel_lb" slot="2"></a-panel>
			</a-layout>
		</div>

		<!-- CENTER -->
		
		<a-layout id='editor_layout2' stretch='slot1' orientation="horizontal"  size2=220 store=true slot="2" >
			
			<div id="mid" slot='1'>
				<div id="mid_header">
					<div id="breadcrumbs"></div>
					<div id="buttons">
						<a-button disabled="true"  id="btn_save" caption="${$save}" icon="/images/save.svg" hotkey="Ctrl+S"></a-button>
						<a-button disabled="true"  id="btn_build" caption="${$build}" icon="/images/build.svg"></a-button>
					</div>
				</div>
				<a-widget id="main_widget"></a-widget>
			</div>
			
			<!-- RIGHT -->

			<div id='right' slot='2'>
				<a-layout id='editor_layout4' orientation="vertical"  min_size1="32" min_size2="32"  stretch='slot1' store=true  >
					<a-panel id="panel_rt" slot="1"></a-panel>
					<a-panel id="panel_rb" slot="2"></a-panel>
				</a-layout>
			</div>

		</a-layout>  
  
	</a-layout>
	<div class="panel_icon" id='left_panel_icon' style="display: none;"><svg viewBox="0 0 32 32" xmlns="http://www.w3.org/2000/svg"><path d="m28 4h-24c-1.1045695 0-2 .8954305-2 2v20c0 1.104569.8954305 2 2 2h24c1.104569 0 2-.895431 2-2v-20c0-1.1045695-.895431-2-2-2zm0 22h-14v-20h14z"/></svg></div>
	<div class="panel_icon" id='right_panel_icon' style="display: none;"><svg viewBox="0 0 32 32" xmlns="http://www.w3.org/2000/svg"><path d="m4 4h24c1.104569 0 2 .8954305 2 2v20c0 1.104569-.895431 2-2 2h-24c-1.104569 0-2-.895431-2-2v-20c0-1.1045695.895431-2 2-2zm0 22h14v-20h-14z"/></svg></div>
  
</div>	`,
);


ONCREATE=function(){

	self.build_log=[];
	self.build_errors=[];
	self.getSettings=getSettings;

	document.getElementById("favicon").href=config.brand_editor_icon;
	window.name = 'editor';
	menu=dom.menu;
	parent=self.parentNode.host;
	
	if(pult.user.editor_access){
		
		dom.body.style.display='flex';
		self.addMenuItem=addMenuItem;
		parent.addEventListener('change',cbWorkspaceSrcChanged);
		cbWorkspaceSrcChanged();

		prepareGlobal();
		prepareLayouts();
		preparePanels();
		setTimeout(function (){
			prepareMenu();
			prepareProps();	
		},0);
	
		sub_builder=pult.subscribe("builder",null,function (s,p){
			if(p?.error){
				pult.showModalError(self,p.error);
			}else{
				if(p?.data?.action==='need_build'){
					pult.needBuild=p.data.need_build;
					if(pult.onNeedBuild) pult.onNeedBuild(p.data.need_build);
				}else if(p?.data?.action==='signal'){
					let s=p.data.signal;
					if(building){
						if(s==='building_projects_started'){
							self.build_log=[];
							pult.showProgress(dom.main_widget.widget);
						}else if(s==='building_vars_finished'){
							pult.hideProgress(dom.main_widget.widget);
							building=false;
							pult.showTooltip(self,$build_complete);
							if(self.build_errors.length){
								pult.navigate('#editor/buildlog');
							}
							//pult.showTooltip(self,"Building complete successfully");
						}
					}
				}else if(p?.data?.action==='status'){
					let s=p.data.status;
					let log=[];
					for(let i=0; i<s?.log?.length; i++){
						let l=s.log[i];
						self.build_log.push(l);
						log.push(l);
						if(l.includes('error:')){
							self.build_errors.push(l);
						}
					}
					if(editor.drawBuildLog) editor.drawBuildLog(log);
				}
			}
		});

	}else{
		pult.showModalError(self,WEBAPP_ERROR_EDITOR_ACCESS_DENIED);
	}

	dom.btn_build.onclick=function (e){
		if(!building){
			self.build_errors=[];
			building=true;
			pult.request(self,'editor_start_build',null,function (req,res,err){
				if(err){
					building=false;
					pult.showError(self,err);
				}
			});
		}
	}

	self.openLeftPanel=function (){
		dom.editor_layout1.open(1,100);
	}

	self.closeLeftPanel=function (){
		dom.editor_layout1.close(1,100);
	}
	
	self.openRightPanel=function (){
		dom.editor_layout2.open(2,100);
	}

	self.closeRightPanel=function (){
		dom.editor_layout2.close(2,100);
	}
	
}

ONDESTROY=function(){
	parent.removeEventListener('change',cbWorkspaceSrcChanged);
	pult.unsubscribe(sub_builder);
}

ONUPDATE=function(changes){
	for(let k in changes){
		if(k==='breadcrumbs') update_breadcrumbs();
	}
}


//////////////////////////////////////////////////////////////////////////////



function cbWorkspaceSrcChanged(){
	self.hideModalError();

	let ppath=aWidget.getPath(parent.src);
	let wpath=aWidget.getPath(dom.main_widget.src);

	if(wpath!==ppath) dom.main_widget.src=ppath;
}




function update_breadcrumbs(){
	let path=self.breadcrumbs;
	let a=[];
	for(let i=0; i<path?.length; i++){
		let p=path[i];
		a.push(`<a href='${p[1]}'>${p[0]}</a>`);
	}
	dom.breadcrumbs.innerHTML=a.join(' / ');   
	document.title=path[path.length-1][0];
}



function refreshPanels(){
	let lts=[dom.editor_layout1,dom.editor_layout2];



	for(let i=0; i<lts.length; i++){
		let lt=lts[i];
		let [p1,p2]=lt.children;

		if(lt===dom.editor_layout1){
			p1=dom.panel_lt;
			p2=dom.panel_lb;
		}else if(lt===dom.editor_layout2){
			p1=dom.panel_rt;
			p2=dom.panel_rb;
		}

		p1.classList.remove('panel_caption_pad');
		p2.classList.remove('panel_caption_pad');

		if(!p1.tab_count && !p2.tab_count){
			//lt.store=false;
			if (lt===dom.editor_layout1){
				lt.close(1);
				dom.left_panel_icon.style.display='none';
			}else if (lt===dom.editor_layout2){
				lt.close(2);
				dom.right_panel_icon.style.display='none';
			}
		}else if(!p1.tab_count){
			if (lt===dom.editor_layout1){
				lt.open(1);
				p2.classList.add('panel_caption_pad');
				dom.left_panel_icon.style.display='';
			}else if (lt===dom.editor_layout2){
				lt.open(2);
				dom.right_panel_icon.style.display='';
			}
			lt=p1.parentNode;
			lt.close(1);
			lt.open(2);
		}else if(!p2.tab_count){
			if (lt===dom.editor_layout1){
				lt.open(1);
				p1.classList.add('panel_caption_pad');
				dom.left_panel_icon.style.display='';
			}else if (lt===dom.editor_layout2){
				lt.open(2);
				dom.right_panel_icon.style.display='';
			}
			lt=p2.parentNode;
			lt.close(2);
			lt.open(1);
		}else{
			if (lt===dom.editor_layout1){
				lt.open(1);
				dom.left_panel_icon.style.display='';
				p1.classList.add('panel_caption_pad');
			}else if (lt===dom.editor_layout2){
				lt.open(2);
				dom.right_panel_icon.style.display='';
			}
			lt=p1.parentNode;
			lt.open(1);
			lt.open(2);
			//lt.store=true;
		}
	}

	if(dom.left_panel_icon.style.display==='none'){
		dom.mid_header.style.paddingLeft='10px';
	}else{
		dom.mid_header.style.paddingLeft='';
	}

}

function prepareGlobal(){
	self.createPanel=function (panel,tab,caption,toolbar){
		let p=dom[panel];
		if(p){
			let ret=p.createTab(tab,caption,toolbar);
			refreshPanels();
			return ret;
		}
	}

	self.deletePanel=function (panel,tab){
		let p=dom[panel];
		if(p){
			p.deleteTab(tab);
			refreshPanels();
		}
	}
}

function preparePanels(){
	
	let p;
	p=dom.panel_lt;
	p.ontitleclick=function (e){
		if(!dom.panel_lb.hidden){
			let h=p.parentNode.offsetHeight-32;
			if(p.parentNode.size1===h){
				p.parentNode.size1=p.___height || p.parentNode.offsetHeight/2;
			}else{
				p.___height=p.offsetHeight;
				p.parentNode.size1=h;
			}
		}
	}

	p=dom.panel_lb;
	p.ontitleclick=function (e){
		if(!dom.panel_lt.hidden){
			let h=32;
			if(p.parentNode.size1===h){
				p.parentNode.size1=p.___height || p.parentNode.offsetHeight/2;
			}else{
				p.___height=p.parentNode.offsetHeight - p.offsetHeight;
				p.parentNode.size1=h;
			}
		}
	}

	p=dom.panel_rt;
	p.ontitleclick=function (e){
		if(!dom.panel_rb.hidden){
			let h=p.parentNode.offsetHeight-32;
			if(p.parentNode.size1===h){
				p.parentNode.size1=p.___height || p.parentNode.offsetHeight/2;
			}else{
				p.___height=p.offsetHeight;
				p.parentNode.size1=h;
			}
		}
	}

	p=dom.panel_rb;
	p.ontitleclick=function (e){
		if(!dom.panel_rt.hidden){
			let h=32;
			if(p.parentNode.size1===h){
				p.parentNode.size1=p.___height || p.parentNode.offsetHeight/2;
			}else{
				p.___height=p.parentNode.offsetHeight - p.offsetHeight;
				p.parentNode.size1=h;
			}
		}
	}

	//dom.panel_rt.ontitleclick=function (e){ p.parentNode.size1=32;}

}

function refresh_left_closed() {
	dom.body.classList.toggle('left_closed',!!dom.editor_layout1.closed && dom.left_panel_icon.style.display!=='none');
}

function refresh_right_closed() {
	dom.body.classList.toggle('right_closed',!!dom.editor_layout2.closed && dom.right_panel_icon.style.display!=='none');
}


function prepareLayouts(){
	
	dom.left_panel_icon.style.display='';
	dom.left_panel_icon.onclick=function (e) {
		if(dom.editor_layout1.closed){
			self.openLeftPanel();
		}else{
			self.closeLeftPanel();
		}
	}

	dom.right_panel_icon.style.display='';
	dom.right_panel_icon.onclick=function (e) {
		if(dom.editor_layout2.closed){
			self.openRightPanel();
		}else{
			self.closeRightPanel();
		}
	}


	dom.editor_layout1.onclose=refresh_left_closed;
	dom.editor_layout1.onopen=refresh_left_closed;
	refresh_left_closed();
	
	dom.editor_layout2.onclose=refresh_right_closed;
	dom.editor_layout2.onopen=refresh_right_closed;
	refresh_right_closed();
	

}


function getSettings(){
	let s=localStorage.editor_settings || '{}';
	let settings=JSON.parse(s);
	return settings;
}

function setSerrings(settings){
	let s=JSON.stringify(settings);
	localStorage.editor_settings=s;
}

function prepareMenu(){

	let settings=getSettings();
	let pk=settings.layout_panel_navigation || 'panel_lt';
	
	let toolbar=[
		{
			tag:'a-button',
			id:'btn_menu_interface',
			icon:'/images/interface.svg',
			href:'#interface/projects',
			target:'interface',
			title:$interface
		},
		{
			tag:'a-button',
			id:'btn_menu_settings',
			icon:'/images/settings.svg',
			href:'#editor/settings',
			title:$settings
		},
		{
			tag:'a-button',
			id:'btn_menu_backups',
			icon:'/images/backup.svg',
			href:'#editor/backups',
			title:$backups
		},
		{
			tag:'a-button',
			id:'btn_menu_buildlog',
			icon:'/images/buildlog.svg',
			href:'#editor/buildlog',
			title:$buildlog
		},
	];

	let panel=self.createPanel(pk,'menu',$menu,toolbar);

	if(panel){
		menu=document.createElement('a-dtree');
		menu.id='menu';
		panel.appendChild(menu);
		
		menu.css=`:host{--selected-background-color:var(--app-selected-color)}.text svg path{fill:var(--app-text-color)}.inactive>.title .link .text{color:var(--app-comment-color)}.inactive>.title .link a-icon{--color:var(--app-comment-color)}`;
		
		menu.onload=function (e){
			let item=e.detail;
			if(item.folder){
				loadMenu(item.path);
			}
		}

		pult.loadObject(self,{
			path:'/projects',
			access:ACS_TYPE_EDIT,
			parent:true,
			docs:'@prop.json',
			unpack:'@prop.json'
		},function (o){
			addMenuItem(o);
		});
	}
}

function prepareProps(){

	let settings=getSettings();
	let pk=settings.layout_panel_props || 'panel_lb';

	let toolbar=[
		{
			tag:'a-button',
			id:'btn_less_props'
		}
	];

	let panel=self.createPanel(pk,'props',$props,toolbar);
	self.propsPanelId=pk;
	if(panel){
		props=document.createElement('a-card');
		props.id='props';
		props.expand_values=true;
		panel.appendChild(props);	
	}
	

}

function loadMenu(path){

	let params={
		path:path,
		docs:'@prop.json',
		unpack:'@prop.json',
		access:ACS_TYPE_EDIT,
	};

	pult.loadList(self,params,function (res){
		for(let i=0; i<res.length; i++){
			let o=res[i];
			addMenuItem(o);
		}
	});
}

function addMenuItem(object,atIndex){
	let lock='';
	if((object._access & ACS_SET)) lock=' <svg height="7" viewBox="0 0 6 7" width="6" xmlns="http://www.w3.org/2000/svg"><path d="m1 0v3h-1v4h6v-4h-1v-3zm1 1h2v2h-2z"/></svg>';
	menu.addItem({
		path:object._path,
		folder:object._count,
		text:object._title+lock,
		icon:object._icon,
		href:object._editor,
		class:object.inactive?'inactive':undefined,
	},atIndex);
}
