/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $filter="Фильтр";
  var $filter_empty="Нет объектов, удовлетворяющих фильтру";
  var $count_filter="Фильтр";
  var $noobjects="Нет объектов";
  var $objects="Объекты";
}else{
  var $filter="Filter";
  var $filter_empty="No objects matching the filter";
  var $count_filter="Filter";
  var $noobjects="No objects";
  var $objects="Objects";
}
(function (){
    
    window.base64_decode=function(base64string) { // base64 string to arrayBuffer
        var binaryString = (base64string!==null && base64string!=='') ? atob(base64string) : '';
        var bytes = new Uint8Array(binaryString.length);
        for (var i = 0; i < binaryString.length; i++) {
            bytes[i] = binaryString.charCodeAt(i);
        }
        return bytes.buffer;
    }


    window.base64_encode=function(arrayBuffer) { // arrayBuffer to base64 string
        
        var base64    = ''
        var encodings = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
      
        var bytes         = new Uint8Array(arrayBuffer)
        var byteLength    = bytes.byteLength
        var byteRemainder = byteLength % 3
        var mainLength    = byteLength - byteRemainder
      
        var a, b, c, d
        var chunk
      
        // Main loop deals with bytes in chunks of 3
        for (var i = 0; i < mainLength; i = i + 3) {
          // Combine the three bytes into a single integer
          chunk = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2]
      
          // Use bitmasks to extract 6-bit segments from the triplet
          a = (chunk & 16515072) >> 18 // 16515072 = (2^6 - 1) << 18
          b = (chunk & 258048)   >> 12 // 258048   = (2^6 - 1) << 12
          c = (chunk & 4032)     >>  6 // 4032     = (2^6 - 1) << 6
          d = chunk & 63               // 63       = 2^6 - 1
      
          // Convert the raw binary segments to the appropriate ASCII encoding
          base64 += encodings[a] + encodings[b] + encodings[c] + encodings[d]
        }
      
        // Deal with the remaining bytes and padding
        if (byteRemainder == 1) {
          chunk = bytes[mainLength]
      
          a = (chunk & 252) >> 2 // 252 = (2^6 - 1) << 2
      
          // Set the 4 least significant bits to zero
          b = (chunk & 3)   << 4 // 3   = 2^2 - 1
      
          base64 += encodings[a] + encodings[b] + '=='
        } else if (byteRemainder == 2) {
          chunk = (bytes[mainLength] << 8) | bytes[mainLength + 1]
      
          a = (chunk & 64512) >> 10 // 64512 = (2^6 - 1) << 10
          b = (chunk & 1008)  >>  4 // 1008  = (2^6 - 1) << 4
      
          // Set the 2 least significant bits to zero
          c = (chunk & 15)    <<  2 // 15    = 2^4 - 1
      
          base64 += encodings[a] + encodings[b] + encodings[c] + '='
        }
        
        return base64
    }
})();



PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`a-browser-item{--icon-hover-color:var(--app-active-text-color);--text-hover-color:var(--app-active-text-color)}`,
	`<div id="pult_header">
	<div class="pult_split">
		<div id="buttons" class="pult_buttons pult_sep"></div>
		<a-input clear_button=1 debounce=300 placeholder=${$filter} id='filter'></a-input>
	</div>
</div>
<a-browser id='browser' empty_string="${$noobjects}"></a-browser>
<div id='empty' class="pult_empty" hidden>${$filter_empty}</div>
`,
);

PROPERTIES={
	filter:{
		type:'string',
	},
};



ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

let paths={};
let blink;

function create(){
	dom.filter.onchange=function(e){
		self.filter=e.detail;
    }
	pult.events.listen('user_alarms',update_user_alarms);
	pult.metronom.listen(onMetronom);
	
}

function destroy(){
	pult.unsubscribeStatusVar(self);
	pult.events.unlisten('user_alarms',update_user_alarms);
	pult.metronom.unlisten(onMetronom);
}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path')		update_path(changes[k]);
		if(k==='filter')	update_filter(changes[k]);
	}
}


function update_filter(){

	let brw=dom.browser;
    let f=self.__filter;
    dom.filter.value=f;
    
    let count=0;
    let visible=0;
    
    for(let n of brw.childNodes){
        count++;
        if(Util.match(f,n.title)){
            n.hidden=false;
            visible++;
        }else{
            n.hidden=true;
        }
    }

    if(count>0 && visible==0){
		dom.browser.hidden=true;
        dom.empty.hidden=false;
    }else{
		dom.browser.hidden=false;
        dom.empty.hidden=true;
    }

    if(f){
        pult.showCount(self,visible,$count_filter);
    }else{
        pult.showCount(self,visible);
    }
}


function update_path(path){

	//self.clear();

	
	pult.showLoading(self);
	pult.unsubscribeStatusVar(self);

	pult.loadObject(self,{
		path:path,
		docs:'@prop.json',
		unpack:'@prop.json',
		parent:true,
		cache:true,
		children:true,
		interface:true,
		inactive:false,
		access:pult.ACS_TYPE_EDIT,
	},function (o){

		

		pult.hideLoading(self);
		pult.showObjectPath(self,o);
		pult.selectMenuItem(self,path);
		pult.showHeader(self,o.show_header);
		pult.showEditorLink(self,o);
		pult.showAlarms(self,!o.hide_alarm_panel && !!o._alarms);
		
		dom.buttons.classList.remove('pult_sep');
		dom.buttons.innerHTML='';		
		
		pult.subscribeStatusVar(self,o._status_var,function (v){self.status=v;});

		let p=o._parent;
		if(p._type==='project'){
			pult.showName(self,p._title,p._icon);
			pult.showCaption(self,o._title);
		}else{
			pult.showName(self,o._title,o._icon);
			let ct=schema.types.common;
			let st=schema.types[o._type];
			pult.showCaption(self,st.objects_title ?? ct.objects_title);
		}

		let sv=[];
		for(let i=0; i<o._children?.length; i++){
			let ch=o._children[i];
			if(ch._status_var) sv.push([ch._status_var,i]);
		}

		let brw=dom.browser;
		pult.subscribeStatusVar(self,sv,function (v,i){
			let bi=brw.children[i];
			if(bi){
				let status=pult.nodeStatuses[v];
				if(status){
					bi.style.setProperty('--text-color',status.color);
					bi.style.setProperty('--icon-color',status.color);
				}else{
					bi.style.setProperty('--text-color','');
					bi.style.setProperty('--icon-color','');
				}
				// bi.classList.toggle('online',v!==0);
				// bi.classList.toggle('offline',v===0);
			}
		});

		drawList(o._children);
		

	});
}

function drawList(list){
	let brw=dom.browser;
	brw.innerHTML='';

	paths={};

	if(list){
		for(let i=0; i<list.length; i++){
			let o=list[i];
			if(o){
				let bi=Util.create(brw,{
					tag:"a-browser-item",
					title:o._title,
					icon_size:32,
					href:pult.getResourceFileLink(o),
					icon_src:o._icon,
				});
				paths[o._path]=bi;
			}
		}	
	}
	update_filter();
	updateBages(paths);

}

function update_user_alarms(){
	updateBages(pult.userAlarms.changes);
}


function onMetronom(m){
	
	blink=m;
	let upd;
	upd={};
	for(let k in paths){
		let o=pult.userAlarms?.objects[k];
		if(o) upd[k]=o;
	}
	updateBages(upd,upd);

}

function updateBages(keys,objects){
		
	if(!objects) objects=pult.userAlarms.objects;

	for(let k in keys){
		let bi=paths[k];
		if(bi){
			let o=objects[k];
			if(o){
				let s=o.au[0]+o.aa[0]+o.iu[0];
				if(s){

					let cls=-1;
					if(o.aa[0]) cls=o.aa[1];
					if(o.iu[0]) cls=o.iu[1];
					if(o.au[0]) cls=o.au[1];

					if(cls===3) clr='var(--app-alm-alarm-text-color)';
					if(cls===2) clr='var(--app-alm-fault-text-color)';
					if(cls===1) clr='var(--app-alm-warning-text-color)';
					if(cls===0) clr='var(--app-alm-notice-text-color)';

					let brd,bg;
					if(o.au[0]){
						if(blink){
							bg=clr;
						}else{
							bg='var(--app-control-color)';
						}
					}else if(o.iu[0]){
						if(blink){
							brd=clr;
						}else{
							brd='var(--app-control-color)';
						}
					}else if(o.aa[0]){
						bg=clr;
					}
					bi.showBadge(bg,brd);
				}else{
					bi.hideBadge(k);
				}
			}else{
				bi.hideBadge(k);
			}
		}
	}

}