/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="Календарь";
  var $import="Импорт";
  var $export="Экспорт";
  var $cancel="Отменить";
  var $save="Сохранить";
  var $cancel_changes="Отменить изменения?";
  var $copy="Копировать в буфер";
  var $dump="Дамп календаря";
  var $import_hint="Вставьте дамп календаря из буфера обмена";
  
  var $info=`Информация о рабочих и выходных днях используется в событиях, где время указано в формате CRON (расписания, скрипты, опрос переменных).<br><br>Для редактирования календаря выберите год, затем нажмите на день месяца, чтобы переключить его статус из рабочего в выходной и обратно.`;
  var $sync_ok="Календарь синхронизируется<br> по серверу %s";
  var $sync_error="Ошибка синхронизации<br> с %s:<br>%s";
  var $edit_not_allowed="Редактирование недоступно";
  var $disable_sync="Редактирование календаря недоступно, пока включена опция синхронизации календаря с удаленным сервером.<br><br>Отключите синхронизацию в <a href='#interface/settings'>настройках сервера</a>, чтобы редактировать календарь.";
}else{
  var $title="Calendar";
  var $import="Import";
  var $export="Export";
  var $cancel="Cancel";
  var $save="Save";  
  var $cancel_changes="Cancel changes?";
  var $copy="Copy to clipboard";
  var $dump="Calendar dump";
  var $import_hint="Paste the calendar dump from the clipboard";

  var $info=`Information about working and weekend days is used in events using the CRON format (schedules, scripts, variable polling).<br><br>To edit the calendar, select a year, then click on the day of the month to switch its status from working to weekend and back.`;
  var $sync_ok="The calendar is being synchronized<br> by server %s";
  var $sync_error="Error synchronizing<br> with %s:<br>%s";
  var $edit_not_allowed="Editing is not available";
  var $disable_sync="Editing the calendar is not available while the option to synchronize the calendar with the remote server is enabled.<br><br>Disable synchronization in the <a href='#interface/settings'>server settings</a> to edit the calendar.";
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#_interface_content{flex-direction:row!important}#_content.mobile #_interface_content{flex-direction:column!important}#info{padding:40px;max-width:300px;color:var(--app-comment-color)}#sync_error{color:var(--app-error-color)}#sync_ok{color:var(--app-online-color)}#years a-button+a-button{margin-left:10px}#months{display:flex;flex-direction:row;flex-wrap:wrap;max-width:1000px;padding:40px;user-select:none;justify-content:space-around;border-right:solid 1px var(--app-control-color);min-height:100%;overflow:auto}#_content.mobile #months{display:block;min-height:none;border-right:none;border-bottom:solid 1px var(--app-control-color)}#months>.mon{flex-grow:0;flex-shrink:0;width:240px;margin-bottom:30px;margin-right:10px;margin-left:10px;line-height:18px}#_content.mobile #months>.mon{min-width:200px;max-width:320px;width:100%;margin-left:0;padding-bottom:30px}#months>.mon>.title{text-align:center;margin-bottom:10px;text-transform:uppercase;color:var(--app-calendar-month-title-color);font-size:14px;letter-spacing:2px}#_content.mobile #months>.mon>.title{font-size:20px}#months>.mon>.weeks>.title{display:flex;flex-direction:row;color:var(--app-calendar-week-title-color)}#_content.mobile #months>.mon>.weeks>.title{padding:10px 0}#months>.mon>.weeks .wd{cursor:default;flex-grow:1;flex-shrink:0;text-align:center;box-sizing:border-box;width:32px;margin-right:1px;margin-top:1px;border:3px solid transparent}#_content.mobile #months>.mon>.weeks .wd{padding:4px}#months>.mon>.weeks .wd.now{border:3px solid var(--app-calendar-today-border-color)!important}#months>.mon>.weeks .wd.hd{color:var(--app-calendar-holiday-text-color);background-color:var(--app-calendar-holiday-background-color)}#months>.mon>.weeks .wd.day:hover{outline:var(--app-selected-color) solid 1px}#months>.mon>.weeks .wl{display:flex;flex-direction:row;padding-left:1px}`,
	`<div id="pult_header">
	<div class="pult_split"  id="buttons_bar">
		<div class="pult_buttons">
			<div class="pult_buttons pult_sep" id="years">years</div>
			<div class="pult_buttons pult_sep" id="dump">
				<a-button id="btn_import" icon="/images/import.svg" caption="${$import}"></a-button>
				<a-button id="btn_export" icon="/images/export.svg" caption="${$export}"></a-button>
			</div>
		</div>
		<div class="pult_buttons">
			<a-button id='btn_save' disabled="1" hotkey="Ctrl+S" palette="anode-button-active" caption='${$save}'></a-button>
			<a-button id='btn_cancel' disabled="1"  caption='${$cancel}'></a-button>
		</div>
	</div>
</div>
<div id="months"></div>
<div id="info">
	<div> ${$info}</div>
	<br>
	<div id="sync_ok"></div>
	<div id="sync_error"></div>
</div>`,
);

ONCREATE=create;
ONDESTROY=destroy;

let yearsCount=3;
let calendarData;
let selectedYear=Time.timestampToYear();
let sync=false;

function create(){

    pult.showPath(self,[
        [$system,'#interface/system'],
        [$title,'#interface/calendar'],
    ]);
    pult.showHeader(self,true);
    pult.showName(self,$title,"/images/calendar.svg");
    pult.showCaption(self,null);
    pult.selectMenuItem(self,'/system/calendar');

    dom.btn_cancel.onclick=function (e){
        pult.showConfirm(self,$cancel_changes,function (e){
            pult.needSave=false;
            pult.reloadWidget();
        });
    }
    
    dom.btn_save.onclick=save;
    dom.btn_export.onclick=showExport;
    dom.btn_import.onclick=showImport;

    drawYears();
    updateYear();


}


function destroy(){
    
}


function updateYear(){

    for(let i=0; i<dom.years.children.length; i++){
        let yb=dom.years.children[i];
        if(Number(yb.caption)===Number(selectedYear)){
            yb.palette='anode-button-checked';
        }else{
            yb.palette='';
        }
    }

    function f(){
        drawMonths(Number(selectedYear),calendarData);
    }

    if(calendarData){
        f();
    }else{
        pult.request(self,'system_get_calendar',null,function (req,res,err){
            if(err){
                pult.showModalError(self,err);
            }else{
                
                dom.sync_error.innerHTML='';
                dom.sync_ok.innerHTML='';

                calendarData=getCalendarData(yearsCount,res.calendar);
                f();
                if(res.sync_url){
                    sync=true;
                    let [proto,server]=res.sync_url.split('://');
                    if(res.sync_last_error){
                        dom.sync_error.innerHTML=Util.format($sync_error,server,pult.errstr(res.sync_last_error));
                    }else{
                        dom.sync_ok.innerHTML=Util.format($sync_ok,server);
                    }
                }
            }
        });
    }

    
}

function needSave(need){
    pult.needSave=need;
    dom.btn_save.disabled=!need;
    dom.btn_cancel.disabled=!need;
}



function fromHexString(str) {
    if(!str) return undefined;
    let buffer = new ArrayBuffer(str.length/2);
    let data=new Uint8ClampedArray(buffer);
    for (let i = 0; i < str.length; i+=2) {
        data[i/2]=parseInt(str.substr(i, 2), 16);
    }
    return data;
}

function getCalendarData(yearsCount,hexString) {

    let curYear=Time.timestampToYear();
    let YSZ=48;
    // let d=fromHexString(hexString);
    let d=Util.hex2buf(hexString);

    let sz=yearsCount*YSZ;
    let buffer = new ArrayBuffer(sz);
    let data=new Uint8ClampedArray(buffer);

    for(let i=0;i<yearsCount;i++){

        let y=curYear+i;
        let off=i*YSZ;
        data[off]=y-2000;

        off+=2;

        let wd=getStartDay(y);

        for (let j = 0; j < 366; j++) {

            let byte=Math.floor(j/8);
            let bit=j % 8;


            let h=isHoliday(y,j,d);

            if(h===undefined){
                if(wd>5){
                    data[off+byte] |= (1 << bit);
                }
            }else if(h){
                data[off+byte] |= (1 << bit);
            }


            wd++;
            if(wd>7) wd=1;
        }
    }

    return data;

}

function drawYears(){

    let y0=Time.timestampToYear();

    dom.years.innerHTML='';
    for(let i=0; i<yearsCount; i++){
        let y=y0+i;
        let yb=document.createElement('a-button');
        yb.caption=y;
        yb.onclick=function (){
            selectedYear=y;
            updateYear();
        }
        dom.years.appendChild(yb);
    }

}

function getStartDay(year) {
    let t=new Date(year, 0, 1).getTime()/1000+86400/2;
    let d=new Date(t*1000);
    let wd=d.getDay(); if(wd==0) wd=7;
    return wd;
}

function isHoliday(year,dayIndex, calendarData) {
    let YSZ=48;
    if(!calendarData) return undefined;

    if(dayIndex>=0 && dayIndex<366){
        var yc=calendarData.length/YSZ;
        for (var i = 0; i < yc; i++) {
            var y=calendarData[i*YSZ]+2000;
            if(y==year){
                var off=i*YSZ+2;
                var byte=Math.floor(dayIndex/8);
                var bit=dayIndex % 8;
                var h=!!(calendarData[off+byte] & (1 << bit));
                return h;
            }
        }
    }
}

function drawMonths(year,calendarData){
    
    let months=dom.months;
    let curDay=Time.timestampToMonthDay();
    let curMonth=Time.timestampToMonth();
    let curYear=Time.timestampToYear();
    
    months.innerHTML="";

    let WD=getStartDay(year);
    let N=0;

    for(let m=1; m<=12; m++){
        let mon=Util.create(months,".mon");
        let ttl=Util.create(mon,".title");
        ttl.innerHTML=Time.months[m];

        let weeks=Util.create(mon,".weeks");
        let wttl=Util.create(weeks,".title");

        for(let d=1; d<=7; d++){
            let wd=Util.create(wttl,".wd");
            let di=d==7?0:d;
            wd.innerHTML=Time.weekDaysShort[di];
        }

        let day=1;
        let days=new Date(year, m, 0).getDate();

        let dn;

        while(day<=days){
            let wl=Util.create(weeks,".wl");
            for(let j=1; j<=7; j++){
                let wd=Util.create(wl,".wd");
                if(j>=WD){
                    if(day<=days){

                        wd.classList.add('day');
                        wd.innerHTML=day;

                        dn=N;
                        WD++; if(WD>7) WD=1;
                        N++;

                        wd.addEventListener("click",function (e) {
                            toggleHoliday(this,calendarData);
                        });

                        if(curMonth===m && curDay===day && curYear===year){
                            wd.classList.add("now");
                        }

                        wd.dn=dn;
                        wd.year=year;

                        if(isHoliday(year,dn,calendarData)){
                            wd.hld=true;
                            wd.classList.add("hd");
                        }

                    }
                    day++;
                }
            }
        }
    }
}

function toggleHoliday(wd,calendarData){

    if(sync){
        pult.showInfo(self,{
            caption: $edit_not_allowed,
            html: $disable_sync,
            alignButtons:'center',
            width:450,
        });
        return;
    }

    wd.hld=!wd.hld;
    if(wd.hld){
        wd.classList.add("hd");
    }else{
        wd.classList.remove("hd");
    }
    setHoliday(wd.year,wd.dn,wd.hld,calendarData);
}



function setHoliday(year,dayIndex,isHoliday,calendarData) {

    

    let YSZ=48;
    if(dayIndex<0 || dayIndex>365) return false;

    var yc=calendarData.length/YSZ;
    for (var i = 0; i < yc; i++) {
        var y=calendarData[i*YSZ]+2000;
        if(y===year){
            var off=i*YSZ+2;
            var byte=Math.floor(dayIndex/8);
            var bit=dayIndex % 8;
            var mask= 1 << bit;
            if(isHoliday){
                calendarData[off+byte] |= mask;
            }else{
                calendarData[off+byte] &= ~mask;
            }
            needSave(true);
            return isHoliday;
        }
    }
}

function save(){
    let str=Util.buf2hex(calendarData);
    pult.request(self,'system_set_calendar',{
        calendar:str,
    },function (req,res,err){
        if(err){
            pult.showError(self,err);
        }else{
            needSave(false);
        }
    });

}

function showExport(){
    let str=Util.buf2hex(calendarData);
    let curYear=Time.timestampToYear();
    pult.showForm(self,{
        caption:`${$export} ${curYear}-${curYear+yearsCount-1}`,
        submit:$copy,
        width:400,
        onsubmit:function (){
            Util.copyText(str);
        },
        html:[
            {
                tag:'div',
                class:'comment',
                html:`${$dump}:<br><br>`,
            },
            {
                tag:'div',
                style:{
                    overflowWrap:'break-word'
                },
                html:str,
            },
        ]
    });
}

function showImport(){
    pult.showForm(self,{
        caption:$import,
        width:400,
        submitFocus:false,
        onsubmit:function (e){
            calendarData=getCalendarData(yearsCount,e.detail.calendar);
            updateYear();
            needSave(true);
        },
        html:{
            tag:'a-textarea',
            height:150,
            name:'calendar',
            placeholder:$import_hint,
            validation:['notEmpty','len:288'],
            validation_events:'submit',
            set_focus:true,
        },
    });
}

