/*--PSEUDO-CODE--*/


if(locale('ru')){
    var $title="Сменить пароль";
    var $must_change_password="Необходимо сменить временный пароль";
    var $cur_password="Текущий пароль";
    var $new_password="Новый пароль";
    var $cnf_password="Повторите пароль";
    var $gen_password="Сгенерировать пароль";
    var $change_password="Сменить пароль";
    var $wrong_confirm="Неверный повтор";
    var $weak_password="Пароль недостаточно надежный";
    var $password_changed="Пароль изменен";
}else{
    var $title="Change password";
    var $must_change_password="You must change your temporary password before continuing";
    var $cur_password="Current password";
    var $new_password="New password";
    var $cnf_password="Confirm password";
    var $gen_password="Generate password";
    var $change_password="Change password";
    var $wrong_confirm="Password confirmation does not match";
    var $weak_password="Password too weak";
    var $password_changed="Password changed";
  }
  

PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<div id="form"></div>
`,
);

ONCREATE=create;
PROPERTIES=['back'];

let menus=[];
let form;

function create(){

	dom._interface_content.classList.add('pult_small_form');

	pult.showHeader(self);
	pult.showPath(self,[
		[$profile,'#interface/profile'],
		[$title,'#interface/changepass'],
	]);
	pult.showName(self,$title,'/images/user.svg');
	pult.selectMenuItem(self,'/profile');

	form=draw(pult.user);
}


function draw(user){

	dom.form.innerHTML='';

	let s=[

		{
			tag:'a-form-row',
			caption:$cur_password,
			hidden:user.changepass,
			html:{
				tag:'a-password',
				name:'cur_password',
				validation:['notEmpty','maxLen:64'],
				width:350,
				new_password:true,
				set_focus:!user.changepass,
			},
		},

		{
			tag:'a-form-row',
			caption:$new_password,
			html:{
				tag:'a-password',
				name:'new_password',
				validation:['notEmpty','maxLen:64','minLen:'+pult.config.password_min_size],
				validation_events:'submit',
				width:350,
				show_meter:true,
				new_password:true,
				set_focus:user.changepass,
			},
		},
		{
			tag:'a-form-row',
			caption:$cnf_password,
			html:{
				tag:'a-password',
				name:'rep_password',
				width:350,
				new_password:true,
			},
		},
		{
			tag:'a-form-row',
			caption:"",
			html:{
				tag:'a-link',
				onclick:generate,
				html:$gen_password,
				underline:'dashed',
			}
		},

	];

	let params={
		submit:$change_password,
		cancel:false,
		onsubmit:function (v) {
			if(form.dom.new_password.level<1){
				form.raiseValidation(form.dom.new_password,$weak_password);
				form.reset();
				return false;
			}else if(v.new_password!==v.rep_password){
				form.raiseValidation(form.dom.rep_password,$wrong_confirm);
				form.reset();
				return false;
			}else{
				pult.request(self,'user_changepass',v,function(req,res,err){
					if(err){
						pult.showError(self,err);
						form.reset();
					}else{
						form.complete();
						pult.needSave=false;
						if(self.back){
							setTimeout(function (){
								pult.navigate(self.back);
							},1000);
						}
					}
				});
			}
		}
	}	

	return pult.drawForm(dom.form,s,params);
}



function generatePassword(len) {
	let charset = "2345679abcdefghijkmnopqrstuvwxyz2345679ACDEFGHJKLMNPQRSTUVWXYZ2345679";
		let retVal = "";
		for (var i = 0; i < len; i++) {
			retVal += charset.charAt(Math.floor(Math.random() * charset.length));
		}
		return retVal;
}

function generate() {
	var p=generatePassword(pult.config.password_min_size*1.5);
	form.dom.new_password.value=p;
	form.dom.rep_password.value=p;
	form.dom.new_password.show_password=true;
	form.dom.rep_password.show_password=true;
	pult.needSave=true;
}
