/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="DDoS-фильтр";
  var $status="Статус";
  var $authorized="Авторизован";
  var $blocked="Заблокирован до";
  var $accepted="Акт. подкл.";
  var $accepts="Новые подкл.";
  var $sent="SRV->IP, B";
  var $recv="IP->SRV, B";
  var $disabled="DDoS-фильтр отключен в настройках сервера";
  var $avg="Общий трафик (ск. среднее за %s с)";

  var $http="HTTP-запросы";
  var $ws="WS-фреймы";

  var $http_req="IP->SRV";
  var $http_res="SRV->IP";
  var $ws_inc="IP->SRV";
  var $ws_out="SRV->IP";

  var $status_blocked="Заблокирован";
  var $status_online="Онлайн";
  var $status_offline="Офлайн";

  var $cancel="Отмена";
  var $filter="Фильтр";
  var $selected="Выбрано";
  var $delete="Удалить";

  var $copied="Скопировано в буфер";
  var $copy="Копировать IP";
  var $forget="Забыть";
  var $block="Заблокировать";
  var $unblock="Разблокировать";

  $forget_caption="Забыть выбранные IP?";
  $forget_text="Выбранные IP-адреса будут удалены из базы данных DDoS-фильтра. При последующем подключении данных адресов они будут обрабатываться как незнакомые.";

  $block_caption="Заблокировать выбранные IP?";
  $block_text="Выбранные IP-адреса будут заблокированы на период блокировки (%s секунд) и записаны в базу данных DDoS-фильтра. <br><br> Все соединения с данных адресов будут разорваны, а последующие попытки соединения будут отклоняться до прекращения блокировки.";

  $unblock_caption="Разблокировать выбранные IP?";
  $unblock_text="Выбранные IP-адреса будут разблокированы.";
  
}else{
  var $title="DDoS-filter";
  var $status="Status";
  var $authorized="Authorized";
  var $blocked="Blocked until";
  var $accepted="Act. con.";
  var $accepts="New con.";
  var $sent="SRV->IP, B";
  var $recv="IP->SRV, B";
  var $disabled="DDoS-filter disabled in server settings";
  var $avg="Common traffic (mv. average by %s s)";
  
  var $http="HTTP-requests";
  var $ws="WS-frames";
 
  var $http_req="IP->SRV";
  var $http_res="SRV->IP";
  var $ws_inc="IP->SRV";
  var $ws_out="SRV->IP";

  var $status_blocked="Blocked";
  var $status_online="Online";
  var $status_offline="Offline";

  var $cancel="Cancel";
  var $filter="Filter";
  var $selected="Selected";
  var $delete="Delete";

  var $copied="Copied to Clipboard";
  var $copy="Copy IP";
  var $forget="Forget";
  var $block="Block";
  var $unblock="Unblock";

  $forget_caption="Forget selected IPs?";
  $forget_text="The selected IP addresses will be removed from the DDoS filter database. When these addresses are connected again, they will be treated as unknown.";

  $block_caption="Block selected IPs?";
  $block_text="The selected IP addresses will be blocked for the blocking period (%s seconds) and recorded in the DDoS filter database. <br><br> All connections from these addresses will be terminated, and subsequent connection attempts will be rejected until the blocking is lifted.";

  $unblock_caption="Unblock selected IPs?";
  $unblock_text="The selected IPs will be unblocked.";

}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<div id="pult_header">
	<div class="pult_split" id="filter_bar">
		<a-input class="pult_filter" clear_button=1 debounce=300 id='filter' placeholder=${$filter}></a-input>
	</div>
	<div class="pult_split pult_sep"  id="buttons_bar">
		<div class="pult_buttons">
			<div class="pult_buttons">
				<a-button id='btn_copy' caption="${$copy}"></a-button>
		    </div>
 
			<div class="pult_buttons pult_sep">
			  <a-button id='btn_forget' caption="${$forget}"></a-button>
			  <a-button id='btn_block' caption="${$block}"></a-button>
			  <a-button id='btn_unblock' caption="${$unblock}"></a-button>
			</div>
		</div>
	  <a-button id='btn_clear' class="pult_cancel"  icon='/images/clear.svg' caption="${$cancel}"></a-button>
	</div>
</div>
  
<a-grid id="grid"></a-grid>`,
);


PROPERTIES=[
	'filter'
];

ONCREATE=create;
ONDESTROY=destroy;
ONUPDATE=update;

let sub;
let records=[];
let index={};
let grid;

function create(){

    pult.showPath(self,[
        [$system,'#interface/system'],
        [$title,'#interface/ddos'],
    ]);
    pult.showHeader(self,true);
    pult.showName(self,$title,"/images/ddos.svg");
    pult.showCaption(self,null);
    pult.selectMenuItem(self,'/system/ddos');

    subscribe();

    grid=dom.grid;
    if(config.ddos_enabled){
        drawTable();
    }else{
        grid.table_empty=$disabled;
    }

    dom.filter.onchange=function(e){
		self.filter=e.detail;
	}

    dom.btn_forget.onclick=function (){
        pult.showConfirm(self,{
            caption:$forget_caption,
            html:$forget_text,
            submit:$forget,
            width:500,
        },function (e){
            let ip=[];
            let rr=grid.getSelectedRecords();
            for(let i=0; i<rr.length; i++){
                let r=rr[i];
                ip.push(r.ip);
            }
            pult.request(self,'ddos_forget',{
                ip:ip,
            },function (req,res,err){
                if(err){
                    pult.showModalError(self,err);
                }
            });
        });
    }

    dom.btn_block.onclick=function (){
        pult.showConfirm(self,{
            caption:$block_caption,
            html:Util.format($block_text,config.ddos_block_time),
            submit:$block,
            width:500,
        },function (e){
            let ip=[];
            let rr=grid.getSelectedRecords();
            for(let i=0; i<rr.length; i++){
                let r=rr[i];
                ip.push(r.ip);
            }
            pult.request(self,'ddos_block',{
                ip:ip,
            },function (req,res,err){
                if(err){
                    pult.showModalError(self,err);
                }
            });
        });
    }

    dom.btn_unblock.onclick=function (){
        pult.showConfirm(self,{
            caption:$unblock_caption,
            html:Util.format($unblock_text,config.ddos_unblock_time),
            submit:$unblock,
            width:500,
        },function (e){
            let ip=[];
            let rr=grid.getSelectedRecords();
            for(let i=0; i<rr.length; i++){
                let r=rr[i];
                ip.push(r.ip);
            }
            pult.request(self,'ddos_unblock',{
                ip:ip,
            },function (req,res,err){
                if(err){
                    pult.showModalError(self,err);
                }
            });
        });
    }

    dom.btn_copy.onclick=function (){
        let ip=[];
        let rr=grid.getSelectedRecords();
        for(let i=0; i<rr.length; i++){
            let r=rr[i];
            ip.push(r.ip);
        }
        Util.copyText(ip.join('\r\n'));
        pult.showTooltip(self,$copied);
    }


}


function destroy(){
    unsubscribe();
}

function update(changes){
	for(let k in changes){
		if(k==='filter') update_filter();
	}
};

function update_filter(){
	let f=self.filter;
    dom.filter.value=f;
    dom.grid.filter = [f];
    refreshButtons();
}


function subscribe(){
    sub=pult.subscribe('ddos',null,function (s,p){
        if(p.data){
            //let update=pult.jkr(p.data);
            let update=pult.jkr(p.data.keys,p.data.rows);

            //console.log(update);

            for(let i=0; i<update.length; i++){
                let d=update[i];
                let ri=index[d.ip];
                if(ri===undefined){
					formatRecord(d);
					ri=grid.addRecord(d);
					index[d.ip]=ri;
				}else{			
                    formatRecord(d);
					records[ri]=d;
					grid.refreshRow(ri);
				}
                if(d.deleted){
                    //console.log('delete ',ri,d);
                    grid.deleteRecords([ri]);
                    delete index[d.ip];
                    for(let k in index){
                        let i=index[k];
                        if(i>ri){
                            index[k]=index[k]-1;
                        }
                    }
                }
            }

            grid.update_sort();
            refreshButtons();

        }
    })
}

function unsubscribe(){
    pult.unsubscribe(sub);
}

function formatRecord(r){
    if(r.blocked){
        r._status=2;
    }else if(r.accepted){
        r._status=0;
    }else{
        r._status=1;
    }

    if(r.authorized){
        r._icon='/images/checkmark.svg';
    }else if(r.blocked){
        r._icon='/images/crossmark.svg';
    }else{
        r._icon='/images/question.svg';
    }

    r._authorized = !r.authorized;

}

function refreshButtons(){
    if(grid.selection.length){
		pult.showCount(self,grid.selection.length,$selected);
		dom.buttons_bar.style.display='';
		dom.filter_bar.style.display='none';
	}else{
		if(dom.filter.value){
			pult.showCount(self,dom.grid.filter_count,$filter);
		}else{
			pult.showCount(self,dom.grid.filter_count,"IP");
		}
		dom.buttons_bar.style.display='none';
		dom.filter_bar.style.display='';
	}
}

function drawTable(){

	let columns=[
		{
			key:'ip',
			caption:'IP',
            onrender:function (value,record,column,index,row,cell,refresh) {
				let r=record;
				row.classList.toggle("blocked",!!r.blocked);
				row.classList.toggle("online",!r.blocked && r.accepted);
				row.classList.toggle("offline",!r.blocked && !r.accepted);
			},
            format:grid.getIconFormat('${_icon}','${ip}'),
		},    
		{
			key:'_status',
			caption:$status,
            sort_cols:['_status','_authorized'],
            sort_by_format:false,
            format:[$status_online,$status_offline,$status_blocked],
		},
        {
			key:'authorized',
			caption:$authorized,
            sort_by_format:false,
            sort_order:'desc',
            format:'$datetimelong',
		},
		{
            key:'blocked',
            format:'$datetimelong',
            caption:$blocked,
		},
        {
            key:'accepted',
            caption:$accepted,
		},    
		{
            key:'accepts',
            caption:$accepts,
            group:Util.format($avg,config.ddos_period),
		},    
		{
            key:'recv',
            caption:$recv,
            group:Util.format($avg,config.ddos_period),
		}, 
		{
            key:'sent',
            caption:$sent,
            group:Util.format($avg,config.ddos_period),
		},
        {
            key:'http_req',
            caption:$http_req,
            group:$http,
		},
        {
            key:'http_res',
            caption:$http_res,
            group:$http,
		}, 
        {
            key:'ws_inc',
            caption:$ws_inc,
            group:$ws,
		},
        {
            key:'ws_out',
            caption:$ws_out,
            group:$ws,
		}, 
	];
	
	grid.checkbox=1;
	grid.store_key="interface_ddos";
	grid.export_title=$title;
	grid.sort_column=2;
	grid.columns=columns;
	grid.css=`.row.blocked .cell,.row.blocked a{color:var(--app-error-color)!important}.row.blocked .cell a-icon,.row.blocked a a-icon{--color:var(--app-error-color)!important}.row.online .cell,.row.online a{color:var(--app-online-color)}.row.online .cell a-icon,.row.online a a-icon{--color:var(--app-online-color)}.row.offline .cell,.row.offline a{color:var(--app-offline-color)}.row.offline .cell a-icon,.row.offline a a-icon{--color:var(--app-offline-color)}`;
	grid.records=[];
	
	grid.drawColumns();
	grid.records=records;
	grid.onselect=refreshButtons;
    
}
