/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $title="Шлюзы";
  var $connected="Подключен";
  var $disconnected="Отключен";
  var $status="Статус";
  var $time="Время";
  var $version_number="Версия";
  var $remote_ip="Удаленный IP";
  var $local_ip="Локальные IP";
  var $status="Статус";
  var $error="Ошибка";
  var $filter="Фильтр";
  var $selected="Выбрано";
  var $select_node="Выберите узел";
  var $nodes="Узлы";

  var $cancel="Отмена";
  var $exec="Выполнить";
  var $reboot_gateway="Перезагрузить шлюз";
  var $reboot="Перезагрузить";
  var $reboot_help="На выбранные шлюзы (%s) будет отправлена команда 'reboot' для перезагрузки устройств";
  var $reset_secret="Сбросить секретный ключ";
  var $reset_secret_help="У выбранных шлюзов (%s) будут сброшены секретные ключи.<br><br>Секретный ключ не позволяет подключаться шлюзам под чужим MAC-ом. Если у шлюза изменился секретный ключ (например, после переустановки), ключ необходимо сбросить на сервере.";

  var $exec_command="Выполнить команду";
  var $exec_help="На выбранные шлюзы (%s) будет отправлена указанная команда командной строки:";

}else{
  var $title="Gateways";
  var $connected="Connected";
  var $disconnected="Disconnected";
  var $status="Status";
  var $time="Time";
  var $version_number="Version";
  var $remote_ip="Remote IP";
  var $local_ip="Local IP";
  var $status="Status";
  var $error="Error";
  var $filter="Filter";
  var $selected="Selected";
  var $select_node="Select node";
  var $nodes="Nodes";

  var $cancel="Cancel";
  var $exec="Execute";
  var $reboot_gateway="Reboot gateway";
  var $reboot="Reboot";
  var $reboot_help="'Reboot' command will be sent to the %s selected gateways";
  var $reset_secret="Reset secret key";
  var $reset_secret_help="The selected gateways (%s) will have their secret keys reset.<br><br>The secret key prevents gateways from connecting under someone else's MAC address. If a gateway has changed its secret key (for example, after reinstallation), the key must be reset on the server.";

  var $exec_command="Execute command";
  var $exec_help="The specified command line command will be sent to the %s selected gateways:";
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<div id="pult_header">
	<div class="pult_split" id="filter_bar">
		<a-input class="pult_filter" clear_button=1 debounce=300 id='filter' placeholder=${$filter}></a-input>
	</div>
	<div class="pult_split"  id="buttons_bar">
		<div class="pult_buttons">
		  <a-button id='btn_reset_secret' icon='/images/reset_secret.svg' title=${$reset_secret} ></a-button>
		  <a-button id='btn_reboot' caption=${$reboot} ></a-button>
		  <a-button id='btn_exec' caption=${$exec} title=${$exec_help} ></a-button>
		</div>
		<a-button id='btn_clear' class="pult_cancel"  icon='/images/clear.svg' caption=${$cancel}></a-button>
	</div>
</div>

<div id="pult_content">
	<a-grid id='grid' class="pult_grid"></a-grid>
</div>


`,
);

PROPERTIES=[
	'filter'
];

ONCREATE=create;
ONDESTROY=destroy;
ONUPDATE=update;

let sub;
let grid;
let index={};
let records=[];

function create(){

	pult.showHeader(self);
	pult.showPath(self,[
		[$system,'#interface/system'],
		[$title,'#interface/gateways'],
	]);
	pult.showName(self,$title,"/images/gateway.svg");
	pult.showCaption(self,null);
	pult.selectMenuItem(self,'/system/gateways');

	grid=dom.grid;

	dom.btn_clear.onclick=clear;
	dom.btn_reset_secret.onclick=show_form_reset_secret;
	dom.btn_exec.onclick=show_form_exec;
	dom.btn_reboot.onclick=show_form_reboot;

	sub=pult.subscribe('gateway_info',null,function (s,p){
		
		if(p.error){
			pult.showModalError(self,p.error);
		}else{
			for(let i=0; i<p?.data?.length; i++){
				let g=p.data[i];
				let ri=index[g.mac];
				if(ri===undefined){
					formatGateway(g);
					ri=grid.addRecord(g);
					index[g.mac]=ri;
				}else{			
					let r=records[ri];
					Util.merge(r,g);
					formatGateway(r);
					grid.refreshRow(ri);
				}
			}
			refreshButtons();
		}
	});

	dom.buttons_bar.style.display='none';
	dom.filter_bar.style.display='';

	dom.filter.onchange=function(e){
		self.filter=e.detail;
	}

	drawTable();
	refreshButtons();

}

function destroy(){
	pult.unsubscribe(sub);
}

function update(changes){
	for(let k in changes){
		if(k==='filter') update_filter();
	}
};

function update_filter(){
	let f=self.filter;
    dom.filter.value=f;
    dom.grid.filter = [f];
    refreshButtons();
}

function refreshButtons(){
  
	if(grid.selection.length){
		pult.showCount(self,grid.selection.length,$selected);
		dom.buttons_bar.style.display='';
		dom.filter_bar.style.display='none';
	}else{
		if(dom.filter.value){
			pult.showCount(self,dom.grid.filter_count,$filter);
		}else{
			pult.showCount(self,dom.grid.filter_count);
		}
		dom.buttons_bar.style.display='none';
		dom.filter_bar.style.display='';
	}
  
}


function clear(){
	grid.unselect();
}

function formatGateway(g){
	g._status=g.online?$connected:$disconnected;
	g._error=pult.errstr(g.error);
	g._time=g.online?g.online:g.offline;
	console.log(g);
	if(g.local_ip) g._local_ip=g.local_ip.join(", ");

	if(g.paths){
		let a=[];
		for(let i=0; i<g.paths.length; i++){
			let p=g.paths[i];			
			a.push(`<a href='#interface/gateway?path=${p}'>${pult.getPseudoPath(p)}</a>`);
		}
		g._paths=a.join(", ");
	}
	return g;
}


function drawTable(){


	let grid=dom.grid;

	let columns=[
		{
			key:'mac',
			caption:'MAC',
			//format:grid.getIconFormat('/images/gateway.svg','${mac}','${_node_link_href}','${_node_link_onclick}'),
			onrender:function (value,record,column,index,row,cell,refresh) {
				
				let r=record;

				row.classList.toggle("online",!!r.online);
				row.classList.toggle("offline",!r.online);
				row.classList.toggle("error",!!r.error);

				
				if(r.paths.length===1){	
					cell.innerHTML=`<a href="#interface/gateway?path=${r.paths[0]}"><a-icon src="/images/gateway.svg"></a-icon><span class='_nodecor'> </span>${r.mac}</a>`;
				}else if(r.paths.length>1){
					cell.innerHTML=`<a href="javascript:void(0)" onclick="show_node_links(${index})"><a-icon src="/images/gateway.svg"></a-icon><span class='_nodecor'> </span>${r.mac}</a>`;
				}else{
					cell.innerHTML=`<a-icon src="/images/gateway.svg"></a-icon><span class='_nodecor'> </span>${r.mac}`;
				}

			},
		}, 
		{
			key:'version_number',
			caption:$version_number,
		},    
		{
			key:'remote_ip',
			caption:$remote_ip,
		},    
		{
			key:'_local_ip',
			caption:$local_ip,
		},    
		{
			key:'_status',
			caption:$status,
		}, 
		{
			key:'_time',
			caption:$time,
			format:'$datetimelong',
			sort_by_format:false,
		}, 
		{
			key:'_error',
			caption:$error,
		},    
		{
			key:'_paths',
			caption:$nodes,
		},

	];
	
	grid.checkbox=1;
	grid.store_key="interface_gateways";
	grid.export_title=$title;
	grid.sort_column=1;
	grid.columns=columns;
	grid.css=`.row.error .cell,.row.error a{color:var(--app-error-color)!important}.row.error .cell a-icon,.row.error a a-icon{--color:var(--app-error-color)!important}.row.online .cell,.row.online a{color:var(--app-online-color)}.row.online .cell a-icon,.row.online a a-icon{--color:var(--app-online-color)}.row.offline .cell,.row.offline a{color:var(--app-offline-color)}.row.offline .cell a-icon,.row.offline a a-icon{--color:var(--app-offline-color)}`;
	grid.records=[];
	
	grid.drawColumns();
	grid.records=records;
	grid.onselect=refreshButtons;
    
}



function show_node_links(i){

	let g=records[i];

	let nodes=[];
	for(let i=0; i<g.paths.length; i++){
		let p=g.paths[i];
		let pp=pult.getPseudoPath(p);
		nodes.push(`<div><a href='#interface/gateway?path=${p}'>${pp}</a></div>`);
	}

	pult.showInfo(self,{
    
		caption:$select_node,
		html:nodes.join(''),
	
	});

}


function show_form_reset_secret(){

	let f=pult.showBatchForm(self,{
    
		caption:$reset_secret,
		html:Util.format($reset_secret_help,grid.selection.length),
		submit: $reset_secret,
	
		onsubmit:function(data){
					
			let rr=[];
			let gg=[];
			for(let i=0; i<grid.selection.length; i++){
				let g=grid.records[grid.selection[i]];  
				gg.push(g);
				rr.push(['gateway_reset_secret',{
					mac:g.mac
				}]);
			}
		
			pult.rpc.requests(rr,function(reqs,ress,errs){
				for(let i=0; i<reqs.length; i++){
					if(!errs[i]){
						let g=gg[i];
						g.error=undefined;
						g._error=undefined;
					}
					f.result(reqs[i][1].mac,errs[i]);
				}
				grid.refresh();
				f.hideSubmit();
			});
	
		}
	
	});
	
}

function show_form_reboot(){

	let f=pult.showBatchForm(self,{
    
		caption:$reboot_gateway,
		html:Util.format($reboot_help,grid.selection.length),
		submit: $reboot,
	
		onsubmit:function(data){
					
			let rr=[];
			for(let i=0; i<grid.selection.length; i++){
				let r=grid.records[grid.selection[i]];  
				rr.push(['gateway_reboot',{
					mac:r.mac
				}]);
			}
		
			pult.rpc.requests(rr,function(reqs,ress,errs){
				for(let i=0; i<reqs.length; i++){
					f.result(reqs[i][1].mac,errs[i]);
				}
				f.hideSubmit();
			});
	
		}
	
	});
	
}
  

function show_form_exec(){

	let f=pult.showBatchForm(self,{
    
		caption:$exec_command,
		submit: $exec,
		width:600,
		submitFocus:false,
		html:[
			{
				tag:'div',
				html:Util.format($exec_help,grid.selection.length),
			},
			{
				tag:'br',
			},
			{
				tag:'a-textarea',
				name:'command',
				background_color:'black',
				text_color:'#CCC',
				width:'100%',
				height:100,
				set_focus:true,
				validation:['notEmpty'],
				validation_events:'submit',
			},
		],
	
		onsubmit:function(data){
					
			let rr=[];
			for(let i=0; i<grid.selection.length; i++){
				let r=grid.records[grid.selection[i]];  
				rr.push(['gateway_exec',{
					mac:r.mac,
					command:data.command,
				}]);
			}
	
			pult.rpc.requests(rr,function(reqs,ress,errs){
				console.log(ress);
				for(let i=0; i<reqs.length; i++){
					let result;
					let error;
					let code;
					let output;
					let item=reqs[i][1].mac;
					if(errs[i]){
						error=errs[i];
					}else{
						result=ress[i];
						code=ress[i].code;
						output=ress[i].output;
					}
					f.result(item,error,result,
						'<div><error><b>${item}</b>: <br>${error}</error></div><br>',
						`<div><div><b>${item} (code ${code})</b>:</div><div><code style='white-space: pre;'>${output}</code></div><br>`
					);
				}
			});
	
		}
	
	});
	
}
  

