/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $title="Лицензия";
  var $lic_vars="Количество физических переменных, доступных по лицензии:";
  var $ttl_vars="Количество физических переменных, используемых в проектах:";
  var $buy_keys="Купить ключи";
  var $add_keys="Добавить ключи";
  var $delete_keys="Удалить ключи";
  var $add="Добавить";
  var $delete="Удалить";
  var $hint="Лицензируются только физические переменные. Чтобы увеличить количество доступных переменных необходимо добавить один или несколько лицензионных ключей.";
  var $key="Ключ";
  var $vars="Переменные";
  var $status="Статус";
  var $active="Активный";
  var $added="Добавлен";
  var $cancel="Отмена";
  var $enter_keys='Введите построчно один или несколько ключей';
  var $delete_help="Выбранные ключи (%s) будут удалены";
}else{
  var $title="License";
  var $lic_vars="Number of physical variables available under license:";
  var $ttl_vars="Number of physical variables used in projects:";
  var $buy_keys="Buy keys";
  var $add_keys="Add keys";
  var $delete_keys="Delete";
  var $add="Add";
  var $delete="Delete";
  var $added="Added";
  var $cancel="Cancel";
  var $hint="Only physical variables are licensed. To increase the number of available variables, you must add one or more license keys.";
  var $key="Key";
  var $vars="Variables";
  var $status="Status";
  var $active="Active";
  var $enter_keys='Enter one or more keys line by line';
  var $delete_help='Selected keys (%s) will be deleted';
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#info{padding:20px;background-color:var(--app-form-color);margin-bottom:1px}table{border-spacing:0;border-collapse:separate}table tr.error{color:var(--app-error-color)}#hint{margin-top:20px;max-width:500px;color:var(--app-comment-color)}#lic_vars,#ttl_vars{font-size:16px;font-weight:700;padding-left:20px}#error{padding:20px;background-color:var(--app-error-color);color:var(--app-error-text-color);text-align:center;text-transform:uppercase;display:none}`,
	`<div id="pult_header">
  <div class="pult_split pult_sep" id="filter_bar">
    <div>
      <a-button id='btn_buy' caption=${$buy_keys} hidden="1"></a-button>
      <a-button id='btn_add' caption=${$add_keys}></a-button>
    </div>
    <span>&nbsp;</span>
  </div>
  <div class="pult_split pult_sep"  id="buttons_bar">
    <div class="pult_buttons">
      <a-button id='btn_delete' caption=${$delete}></a-button>
    </div>
    <a-button id='btn_clear' class="pult_cancel"  icon='/images/clear.svg' caption=${$cancel}></a-button>
  </div>
</div>
<div id="info">
  <table>
    <tr><td>${$lic_vars}</td><td id="lic_vars"></td></tr>
    <tr><td>${$ttl_vars}</td><td id="ttl_vars"></td></tr>
  </table>  
  <div id="hint">${$hint}</div>
</div>
<a-grid id='grid' class="pult_grid"></a-grid>`,
);

ONCREATE=create;
ONDESTROY=destroy;

let grid;
let ttl_vars=0;
let lic_vars=0;

function create(){

    pult.showPath(self,[
        [$system,'#interface/system'],
        [$title,'#interface/license'],
    ]);
    pult.showHeader(self,true);
    pult.showName(self,$title,"/images/license.svg");
    pult.showCaption(self,null);
    pult.selectMenuItem(self,'/system/license');

    grid=dom.grid;

    drawTable();
	loadLicense();

	if(pult.config.buy_license_link){
		dom.btn_buy.hidden=false;
		dom.btn_buy.href=pult.config.buy_license_link;
		dom.btn_buy.target='_blank';
	}else{
		dom.btn_buy.hidden=true;
	}

	dom.btn_clear.onclick=function (){
        grid.unselect();
    }

	dom.btn_delete.onclick=function (){
		let f=pult.showBatchForm(self,{
			caption:$delete_keys,
			width:550,
			submitFocus:false,
			submit:$delete,
			html:Util.format($delete_help,grid.selection.length),
			onsubmit:function (){
				
				let kk=grid.selection;
				let rr=[];
				for(let i=0; i<kk.length; i++){
					let key=grid.records[kk[i]].key;
					rr.push(['license_delete',{
						key:key
					}]);
				}

				pult.requests(self,rr,function (reqs,ress,errs){
                    if(errs.count){
                        for(let i=0; i<reqs.length; i++){
                            let k=reqs[i][1].key;
                            let kk=k.split('-');
                            k=kk[0]+'...'+kk[kk.length-1];
                            f.result(k,errs[i]);
                        }
                        f.hideSubmit();
                    }else{
                        f.hide();
                    }
                    loadLicense();
				});

			}
		});
	}

	dom.btn_add.onclick=function (){

		let f=pult.showBatchForm(self,{
			caption:$add_keys,
			width:450,
			submitFocus:false,
			submit:$add,
			html:[
				{
					tag:'a-textarea',
					placeholder:$enter_keys,
					height:200,
					set_focus:1,
					name:'keys',
					validation:['notEmpty']
				}
			],
			onsubmit:function (data){
				
				let kk=data.keys.split('\n');
				let rr=[];
				for(let i=0; i<kk.length; i++){
					let k=Util.trim(kk[i].toUpperCase());
					if(k) rr.push(['license_add',{
						key:k
					}]);
				}

				pult.requests(self,rr,function (reqs,ress,errs){
                    if(errs.count){
                        for(let i=0; i<reqs.length; i++){
                            let k=reqs[i][1].key;
                            let kk=k.split('-');
                            k=kk[0]+'...'+kk[kk.length-1];
                            f.result(k,errs[i]);
                        }
                        f.hideSubmit();
                    }else{
                        f.hide();
                    }
					loadLicense();
				});

			}
		});
	}

	refreshButtons();

}


function destroy(){

}



function loadLicense(){
	pult.request(self,'license_keys',null,function (req,res,err){
		if(err){
			pult.showModalError(self,err);
		}else{

            grid.unselect();

			ttl_vars=res.ttl_vars;
			lic_vars=res.lic_vars;

			grid.records=res.keys;

			dom.ttl_vars.innerHTML=ttl_vars;
			dom.lic_vars.innerHTML=lic_vars;

			dom.ttl_vars.parentNode.classList.toggle("error",ttl_vars>lic_vars);
			if(ttl_vars>lic_vars){
				//dom.error.style.display='block';
			}else{
				//dom.error.style.display='';
			}

		}
	});
}

function refreshButtons(){
	if(grid.selection.length){
		dom.buttons_bar.style.display='';
      	dom.filter_bar.style.display='none';
	}else{
		dom.buttons_bar.style.display='none';
      	dom.filter_bar.style.display='';
	}
}

function drawTable(){
	let grid=dom.grid;

	grid.columns=[
		{
			key:'key',
			caption:$key,
			format:grid.getIconFormat('/images/key.svg','${key}'),
		},
		{
			key:'vars',
			caption:$vars,
		},
		{
			key:'added',
			caption:$added,
			format:'$datetimelong'
		},
		{
			key:'status',
			caption:$status,
			format:{
				"active":$active,
			}
		},
	];

	grid.checkbox=true;
	grid.records=[];
	grid.sort_column=3;
	grid.row_height=32;
	grid.drawColumns();

	grid.onselect=function (e){
		refreshButtons();
	}
	
}