/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $title="Логи сервисов";
  var $system="Система";
  var $filter="Фильтр";
  var $settings="Настройки";
  var $preset="Пресеты";
  var $services="Сервисы";
  var $levels="Уровни";
  var $select_service="Сервис не выбран";
  var $restart_service="Перезапустить сервис";
  var $apply="Применить";
  var $select_preset="- Предустановленные настройки логов -";
  var $scrollup="Прокрутить вверх";
  var $scrolldown="Прокрутить вниз";
  var $clear="Очистить";
  var $search="Найти";
  var $clear_search="Очистить";
  var $nodata="Нет данных";
  var $copy="Копировать выделенные записи";
  var $selectall="Выделить все";
  var $not_found="Записи, удовлетворяющие условиям фильтра, не найдены";
  var $filter_help="Фильтр с поддержкой Regexp | Например: 192.168.0.123 .* error";
  var $main_status="Всего: %s | Выбрано: %s";
  var $filter_status="Фильтр: %s | Выбрано: %s";
  var $hlerr="Подсветка ошибок";
  var $buffer="Размер буфера, кол-во записей";
  var $save="Сохранить выделенные записи в файл";
}else{
  var $title="Service Logs";
  var $system="System";
  var $filter="Filter";
  var $settings="Settings";
  var $preset="Presets";
  var $services="Services";
  var $levels="Levels";
  var $select_service="Service not selected";
  var $restart_service="Restart service";
  var $apply="Apply";
  var $select_preset="- Preset log settings -";
  var $scrollup="Scroll up";
  var $scrolldown="Scroll down";
  var $clear="Clear";
  var $search="Search";
  var $clear_search="Clear";
  var $nodata="No data";
  var $copy="Copy selected records";
  var $selectall="Select all";
  var $filter_help="Filter with Regexp support | For example: 192.168.0.123 .* error";
  var $not_found="Records that match the filter conditions were not found";
  var $main_status="Total: %s | Selected: %s";
  var $filter_status="Filter: %s | Selected: %s";
  var $hlerr="Error highlighting";
  var $buffer="Buffer size, records count";
  var $save="Save selected records to file";
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#pult_content{display:flex;flex-direction:column}#pult_header a-button{flex-shrink:0}#config_panel{border-left:solid 1px #CCC}#settings_panel{display:flex;flex-direction:column;overflow:hidden;align-items:stretch;height:100%}#inp_buffer{width:80px}.block{overflow:hidden;flex-shrink:1;display:flex;flex-direction:column}#services_content>div{color:var(--app-offline-color);padding:3px 10px;cursor:pointer}#services_content>div>a-icon{width:14px;height:14px;--color:var(--app-offline-color);vertical-align:middle;position:relative;top:-1px;margin-right:5px}#services_content>div.selected{background-color:var(--app-selected-color)}#services_content>div.enabled{color:var(--app-text-color)}#services_content>div.enabled>a-icon{--color:var(--app-text-color)}#levels_content{display:flex;flex-direction:column;padding:10px}#levels_content a-label{cursor:pointer;margin-bottom:3px}#log{padding:10px;overflow:auto;height:100%;margin:0;display:block;white-space:nowrap}#log>div{height:18px}#filter_header{font-size:inherit}#filter_header .pult_split{height:26px}#filter_header a-edit{height:24px;width:100%;max-width:none}#filter_header a-button{position:relative;top:4px;flex-shrink:0}#filter_header .pult_buttons{flex-shrink:0}.log_error{color:var(--app-error-color)}.monitored span{color:var(--app-active-text-color)}.monitored a-icon{--color:var(--app-active-text-color)!important}.pult_buttons{flex-shrink:0}.shrink{flex-shrink:1}.header{padding:10px;background-color:var(--app-header-color);font-size:16px}.header a-button{margin-top:-4px}.content{overflow:auto;height:100%;min-height:50px}#status{padding:5px 10px;color:var(--app-comment-color);background-color:var(--app-form-color);display:flex;flex-direction:row;justify-content:space-between}`,
	`<div id="pult_header">
	<div class="pult_split">
		<div class="pult_hor">
			<div class="pult_buttons pult_sep shrink">
				<a-select id="sel_preset" undefined="${$select_preset}"></a-select>
				<a-button id="btn_apply" disabled="1" palette="anode-button-active" caption="${$apply}"></a-button>
			</div>
			<div class="pult_buttons pult_sep">
				<a-button id="btn_play" icon="/images/play.svg"></a-button>
				<a-button id="btn_pause"  icon="/images/pause.svg"></a-button>
			</div>
			<div class="pult_buttons pult_sep">
				<a-button id="btn_clear" disabled="1" icon="/images/clear.svg" caption="${$clear}"></a-button>
			</div>	
			<div class="pult_buttons pult_sep">
				<a-button id="btn_scrollup" disabled="1" icon="/images/scrollup.svg" title="${$scrollup}"></a-button>
				<a-button id="btn_scrolldown" disabled="1" icon="/images/scrolldown.svg" title="${$scrolldown}"></a-button>
				<a-edit id="inp_buffer" title="${$buffer}"></a-edit>
			</div>
			<div class="pult_buttons pult_sep">
				<a-button id="btn_err" caption="ERR"  title="${$hlerr}" ></a-button>
				<a-button id="btn_selectall" disabled="1" title="${$selectall}" icon="/images/selectall.svg"></a-button>
				<a-button id="btn_copy"  disabled="1" title="${$copy}" icon="/images/copy.svg"></a-button>
				<a-button id="btn_save"  disabled="1" title="${$save}" icon="/images/export_txt.svg"></a-button>
			</div>
		</div>
		<div class="pult_buttons">
			<a-button id="btn_toggle_filter" icon="/images/log_filter_panel.svg" caption="${$filter}"></a-button>
			<a-button id="btn_toggle_settings" icon="/images/log_settings_panel.svg" caption="${$settings}"></a-button>
		</div>			
    </div>
</div>

<div id="pult_content">
	<a-layout orientation="horizontal" stretch="slot1"  size2="200" closed=2 store="1" id="logs_layout1">
		<div slot="1" class="block">
			<a-layout orientation="vertical" stretch="slot1"  size2="200" store="1"  id="logs_layout2">
				<div id="log_panel" slot="1">
					<a-log id="main_log"></a-log>
				</div>
				<div id="filter_panel"  class="block" slot="2">
					<div class="header" id="filter_header">
						<div class="pult_split">
							<a-edit id="filter" placeholder="${$filter_help}"></a-edit>
							<a-button id="btn_search" caption="${$search}" disabled="1" palette="anode-button-active" ></a-button>
							&nbsp;
							<a-button id="btn_clear_search" disabled="1" icon="/images/clear.svg" caption="${$clear_search}"></a-button>
	
							<div class="pult_buttons pult_sep">
								<a-button id="btn_filter_scrollup" disabled="1"  icon="/images/scrollup.svg" title="${$scrollup}"></a-button>
								<a-button id="btn_filter_scrolldown" disabled="1"  icon="/images/scrolldown.svg" title="${$scrolldown}"></a-button>
							</div>
							<div class="pult_buttons pult_sep">
								<a-button id="btn_filter_selectall" disabled="1"  title="${$selectall}" icon="/images/selectall.svg"></a-button>
								<a-button id="btn_filter_copy" disabled="1" title="${$copy}" icon="/images/copy.svg"></a-button>
								<a-button id="btn_filter_save"  disabled="1" title="${$save}" icon="/images/export_txt.svg"></a-button>
							</div>
	
						</div>
					</div>
					<div  class="content" id="filter_content">
						<a-log id="filter_log"></a-log>
					</div>
				</div>
			</a-layout>
			<div id="status">
				<div id="main_status">main status</div>
				<div id="filter_status">filter status</div>
			</div>
		</div>

		<a-layout orientation="vertical" store="1" slot="2" stretch="slot1"  size2="400" id="logs_layout3">
			<div id="services" slot=1  class="block">
				<div class="header pult_split" id="services_header">
					<div>${$services}</div>
					<div><a-button id="btn_restart" icon="/images/reboot.svg" title="${$restart_service}" disabled="1"></a-button></div>
				</div>
				<div class="content" id="services_content"></div>
			</div>
			<div id="levels" slot="2" class="block">
				<div class="header" id="levels_header">${$levels}</div>
				<div class="content" id="levels_content">
					<div class="pult_empty">${$select_service}</div>
				</div>
			</div>
		</a-layout>

	</a-layout>
</div>
`,
);

PROPERTIES=[
	{
		key:'path',
		default:'/system'
	},
	'filter'
];

ONCREATE=create;
ONDESTROY=destroy;
ONUPDATE=update;

let sub;
let config,schema;
let service;
let config_copy={};
let data=[];
let mail_log;
let filter_log;
let filter;
let id=0;
let interval;
let error_hl;
let filter_list=[];

let templates={
	empty:{
		name:{ru:'Отключение всех логов',en:'Disable all logs'},
		config:{}
	},
	modbus_rtu:{
		name:{ru:'Коммуникация драйвера Modbus-RTU с узлами',en:'Communication of the Modbus-RTU driver with nodes'},
		config:{
			drv_mbrtu:{
				log_app:true,
				log_mb:true,
			}
		}
	},
	modbus_tcp:{
		name:{ru:'Коммуникация драйвера Modbus-TCP с узлами',en:'Communication of the Modbus-TCP driver with nodes'},
		config:{
			drv_mbtcp:{
				log_app:true,
				log_mb:true,
			}
		}
	}
};

// enabled
// ENABLED
// logger_enabled
// logger_write
// LOG_ENABLED

function create(){

	pult.showHeader(self);



	main_log=dom.main_log;
	filter_log=dom.filter_log;

	let list=[];
	for(let k in templates){
		let t=templates[k];
		list.push([k,t.name]);
	}

	interval=setInterval(function (){
		dom.main_status.innerHTML=Util.format($main_status,main_log._records.length,main_log._selection.length);
		dom.filter_status.innerHTML=Util.format($filter_status,filter_log._records.length,filter_log._selection.length);

		dom.btn_filter_scrolldown.disabled=!filter_log._records.length;
		dom.btn_filter_scrollup.disabled=!filter_log._records.length;
		dom.btn_filter_selectall.disabled=!filter_log._records.length;

		dom.btn_clear.disabled=!main_log._records.length;
		dom.btn_scrolldown.disabled=!main_log._records.length;
		dom.btn_scrollup.disabled=!main_log._records.length;
		dom.btn_selectall.disabled=!main_log._records.length;

	},100);

	dom.sel_preset.list=list;
	
	dom.btn_toggle_settings.onclick=function (){
		if(dom.logs_layout1.closed){
			dom.logs_layout1.close(0);
		}else{
			dom.logs_layout1.close(2);
		}
	}

	dom.btn_toggle_filter.onclick=function (){
		if(dom.logs_layout2.closed){
			dom.logs_layout2.close(0);
		}else{
			dom.logs_layout2.close(2);
		}
	}

	dom.btn_restart.onclick=function (){
		let method;
		let params;
		if(self.path==='/system'){
			method='system_restart_service';
			params={
				service:service,
			}
		}else{
			method='gateway_restart_service';
			params={
				service:service,
				path:self.path,
			}
		}
		pult.request(self,method,params,function (req,res,err){
			if(err){
				pult.showModalError(self,err);
			}else{
				//console.log(res);
			}
		});

	}

	dom.btn_clear.onclick=function(){
		main_log.clear();
	}
	
	dom.btn_scrollup.onclick=function(){
		main_log.scroll(main_log.firstIndex);
	}

	dom.btn_scrolldown.onclick=function(){
		main_log.scroll(main_log.lastIndex);
	}

	dom.btn_filter_scrollup.onclick=function(){
		filter_log.scroll(filter_log.firstIndex);
	}

	dom.btn_filter_scrolldown.onclick=function(){
		filter_log.scroll(filter_log.lastIndex);
	}
	
	dom.btn_pause.onclick=function(){
		pult.unsubscribe(sub);
		sub=undefined;
		refreshButtons();
	}

	dom.btn_play.onclick=function(){
		main_log.scroll(main_log.lastIndex);
		filter_log.scroll(filter_log.lastIndex);
		
		if(self.path){
			subscribeGatewayLog(self.path);
		}else{
			subscribeServerLog();
		}
		refreshButtons();
	}

	filter_list=JSON.parse(localStorage.logs_filter_list||'[]');

	dom.btn_search.onclick=function(){
		filter = undefined;
		let v=dom.filter.value;
		if(v){
			try{
				let i=filter_list.indexOf(v);
				if(i>=0) filter_list.splice(i,1);
				filter_list.unshift(v);
				if(filter_list.length>30) filter_list.pop();
				localStorage.logs_filter_list=JSON.stringify(filter_list);
				dom.filter.list=Util.clone(filter_list);
				filter = new RegExp(v, "i");
			}catch(e){};
		}
		search();
		dom.btn_search.disabled=true;
	}

	dom.filter.onenter=function (e){
		dom.btn_search.onclick();
	}
	
	dom.filter.onchange=function (e){
		dom.btn_search.disabled=false;
	}
	
	dom.filter.list=filter_list;

	dom.btn_clear_search.onclick=function(){
		dom.filter.value=undefined;
		dom.btn_search.disabled=true;
		filter = undefined;
		search();
	}

	dom.btn_selectall.onclick=function(){
		main_log.select_all();
	}

	dom.btn_copy.onclick=function(){
		let text=main_log.getSelectedText();
		Util.copyText(text);
	}

	dom.btn_save.onclick=function(){
		let text=main_log.getSelectedText();
        saveAs(new Blob([text], {type: "text/plain; charset=utf-8"}), 'log.txt');
	}

	dom.btn_filter_save.onclick=function(){
		let text=filter_log.getSelectedText();
        saveAs(new Blob([text], {type: "text/plain; charset=utf-8"}), 'log.txt');
	}

	dom.btn_filter_selectall.onclick=function(){
		filter_log.select_all();
	}

	dom.btn_filter_copy.onclick=function(){
		let text=filter_log.getSelectedText();
		Util.copyText(text);
	}
	
	dom.btn_err.onclick=function(){
		if(localStorage.logs_error_hl_off){
			localStorage.logs_error_hl_off='';
		}else{
			localStorage.logs_error_hl_off=1;
		}
		refreshButtons();
	}

	dom.btn_apply.onclick=function (){
		let changes={};
		for(let k in config){
			let s=config[k];
			let sc=config_copy[k];
			for(let p in s){
				if(!p.startsWith('_')){
					let vc=sc[p];
					let v=s[p];
					if(v!==vc){
						if(!changes[k]) changes[k]={};
						changes[k][p]=v;
					}
				}
			}
		}
		let method;
		let params;

		if(self.path && self.path.endsWith('.gateway')){
			method='log_set_gateway_config';
			params={
				path:self.path,
				config:changes,
			};
		}else{
			method='log_set_server_config';
			params={
				config:changes,
			};
		}

		pult.request(self,method,params,function (req,res,err){
			if(err){
				pult.showModalError(self,err);
			}else{
				config_copy=Util.clone(config);
				dom.btn_apply.disabled=true;
			}
		});
	}

	dom.inp_buffer.placeholder=main_log.__capacity;
	dom.inp_buffer.list=[10000,20000,50000,100000,200000,500000,1000000];
	dom.inp_buffer.undefined=true;
	dom.inp_buffer.onchange=function (){
		main_log.capacity=this.value;
		filter_log.capacity=this.value;
	}

	dom.sel_preset.onchange=function (e){

		for(let k in config){
			let s=config[k];
			for(let p in s){
				if(p.startsWith('log_')){
					setConfig(k,p,0);
				}
			}
		}


		let v=e.detail;
		let t=templates[v];

		if(t){
			for(let k in t.config){
				let s=t.config[k];
				for(let p in s){
					let v=s[p];
					setConfig(k,p,v);
				}
			}
		}

		//console.log('template',config);
		refreshCounter();
		showLevels(service);


	}

	main_log.css=`:host(.error_hl) .error{color:var(--app-error-color)}:host(.error_hl) .error.selected{color:var(--app-error-text-color);background-color:var(--app-error-color)}`;
	main_log.empty=$nodata;
	
	filter_log.css=`:host(.error_hl) .error{color:var(--app-error-color)}:host(.error_hl) .error.selected{color:var(--app-error-text-color);background-color:var(--app-error-color)}`;
	filter_log.empty=$nodata;

	main_log.onselect=function (e){
		if(main_log.selection.length){
			dom.btn_copy.disabled=false;
			dom.btn_save.disabled=false;
		}else{
			dom.btn_copy.disabled=true;
			dom.btn_save.disabled=true;
		}
	}

	filter_log.onselect=function (e){

		if(filter_log.selection.length){
			dom.btn_filter_copy.disabled=false;
			dom.btn_filter_save.disabled=false;
		}else{
			dom.btn_filter_copy.disabled=true;
			dom.btn_filter_save.disabled=true;
		}

		let rr=[];
		for(let i=0; i<filter_log.selection.length; i++){
			let ri=filter_log.selection[i];
			let r=filter_log.getRecord(ri);
			if(r) rr.push(r.payload);
		}
		highlight(rr);
		
	}

	

}

function destroy(){
	pult.unsubscribe(sub);
	clearInterval(interval);
}

function update(changes){
	for(let k in changes){
		if(k==='path') update_path();
		if(k==='filter') update_filter();
	}
};

function update_path(){
	
	data=[];
	main_log.clear();

	if(self.path){

		pult.loadObject(self,{
			path:self.path,
			docs:'@prop.json',
			unpack:'@prop.json',
			parent:true,
			cache:true,
			interface:true,
		},function (o){
			pult.showObjectPath(self,o);
			pult.selectMenuItem(self,self.path);
			pult.showHeader(self,true);
			pult.showName(self,o._title,o._icon);
			pult.showCaption(self,$title);
		});

		loadGatewayConfig(self.path);

	}else{
		
		pult.showPath(self,[
			[$system,'#interface/system'],
			[$title,'#interface/logs'],
		]);
		pult.showHeader(self,true);
		pult.showName(self,$title,"/images/log.svg");
		pult.showCaption(self,null);
		pult.selectMenuItem(self,'/system/logs');
		
		loadServerConfig();

	}
}


function subscribeGatewayLog(path){
	pult.unsubscribe(sub);
	sub=pult.subscribe("gateway_log",{
		path:path,
	},function (s,p){
		if(p.error){
			pult.showError(self,p.error);
			//pult.resubscribe();
		}else if(p.data){
			drawLogData(p.data);
		}
	});
	refreshButtons();
}


function subscribeServerLog(){
	pult.unsubscribe(sub);
	sub=pult.subscribe("log",null,function (s,p){
		if(p.error){
			pult.showError(self,p.error);
		}else if(p.data){
			drawLogData(p.data);
		}
	});
	refreshButtons();
}

function drawLogData(logData){
	let data=[];
	for(let i=0; i<logData.length; i++){
		data.push([++id,logData[i]]);
	}
	drawLines(data,main_log);
	if(filter) drawLines(data,filter_log,filter);
}

function drawLines(data,log,filter){
	let rr=[];
	for(let i=0; i<data.length; i++){
		let id=data[i][0];
		let line=data[i][1];

		let s=Util.trim(line.split('|')[0]).toLowerCase();
		if(config[s]){ // check if service present in config

			if(!filter || line.match(filter)){
				let err=0;
				if(line.indexOf('error')>=0) err=true;
				if(line.indexOf('ERROR')>=0) err=true;
				if(line.indexOf('Error')>=0) err=true;
				log.addRecord(line,id,err?'error':'');
			}
		}
	}
}

function refreshButtons(){
  
	error_hl=!localStorage.logs_error_hl_off;
	dom.btn_err.palette=error_hl?'anode-button-checked':undefined;
	main_log.classList.toggle('error_hl',error_hl);
	filter_log.classList.toggle('error_hl',error_hl);

	if(sub){
		dom.btn_play.palette='anode-button-checked';
		dom.btn_pause.palette=undefined;
	}else{
		dom.btn_pause.palette='anode-button-checked';
		dom.btn_play.palette=undefined;
	}
}



function highlight(id){

	if(id){

		console.time('select');

		if(!Array.isArray(id)) id=[id];

		let map={};
		for(let i=0; i<main_log._records.length; i++){
			let r=main_log._records[i];
			map[r.payload]=r.index;
		}
		
		let rr=[];
		for(let i=0; i<id.length; i++){
			let x=id[i];
			let ri=map[x];
			if(ri!==undefined){
				rr.push(ri);
			}
		}
		main_log.select(rr);
		main_log.scroll(rr[0]);

		console.timeEnd('select');
		console.log('selected',rr.length,main_log._records.length);



	}else{
		main_log.unselect();
	}
	
}

function search(){
	filter_log.clear();
	if(filter){
		for(let i=0; i<main_log._records.length; i++){
			let r=main_log._records[i];
			if(r.record.match(filter)){
				filter_log.addRecord(r.record,r.payload,r.class);
			}
		}
		if(!filter_log.records.length){
			filter_log.empty=$not_found;
		}
	}else{
		filter_log.empty=undefined;
		highlight();
	}
	dom.btn_clear_search.disabled=!filter;
}

function loadServerConfig(){
	Util.promises(function (resolve){
		pult.request(self,'log_get_server_config',null,function (req,res,err){
			if(err){
				pult.showModalError(self,err);
			}else{
				config=res;
				resolve();
			}
		});
	},function (resolve){
		pult.request(self,'log_get_server_schema',null,function (req,res,err){
			if(err){
				pult.showModalError(self,err);
			}else{
				schema=res;
				resolve();
			}
		});	
	},function (){
		showConfig(config,schema);
		subscribeServerLog();
	});
}


function loadGatewayConfig(path){

	

	Util.promises(function (resolve){
		pult.request(self,'log_get_gateway_config',{path:path},function (req,res,err){
			if(err){
				pult.showModalError(self,err);
			}else{
				config=res;
				resolve();
			}
		});
	},function (resolve){
		pult.request(self,'log_get_gateway_schema',{path:path},function (req,res,err){
			if(err){
				pult.showModalError(self,err);
			}else{
				schema=res;
				resolve();
			}
		});	
	},function (){
		showConfig(config,schema);
		subscribeGatewayLog(path);
	});
}

function showConfig(config,schema){

	for(let s in config){
		let service=config[s];
		for(let p in service){
			let v=service[p];
			service[p]=(v==="1" || v===1) ? 1 : 0;
		}
	}

	config_copy=Util.clone(config);
	dom.services_content.innerHTML='';

	let services=Util.ota(config,'_key');
	Util.keySort(services,'_key');

	for(let i=0; i<services.length; i++){
		let s=services[i];
		let enabled=s.enabled || s.ENABLED;
		
		let cls='';
		if(enabled) cls+='enabled';

		Util.create(dom.services_content,{
			tag:'div',
			properties:{
				service:s._key,
			},
			class:enabled?'enabled':'',
			html:[
				{
					tag:'a-icon',
					src:enabled?'/images/service_running.svg':'/images/service_stopped.svg',
				},
				{
					tag:'span',
					html:s._key,
				}
			],
			onclick:function (){
				for(let i=0; i<dom.services_content.children.length; i++){
					let n=dom.services_content.children[i];
					n.classList.remove('selected');
				}
				this.classList.add('selected');
				service=this.service;
				dom.btn_restart.disabled=false;
				showLevels(service);
			}
		});
	}

	refreshCounter();
}

function showLevels(service){
	
	if(!service) return;
	console.log(service);
	dom.levels_content.innerHTML='';
	
	let s=config[service];
	let logenabled=getEnabled(s);

	for(let k in s){
		if(k.startsWith('log_')){
			let sh=schema[service]?.[k];
			if(!sh) sh=schema['server']?.[k];
			if(!sh) sh=schema['gateway_setup']?.[k];
			
			let caption=k;
			let desc='';
			let h=sh?.help;
			if(h){
				if(h[0]==='{') h=JSON.parse(h);
				desc=locale_string(h);
			}
			Util.create(dom.levels_content,{
				tag:'a-label',
				caption:caption,
				title:desc,
				html:{
					tag:'a-checkbox',
					value: logenabled?(s[k]!==0):0,
					properties:{
						service:service,
						param:k,
					},
					onchange:function (){
						setConfig(service,this.param,this.value);
						refreshCounter();
						dom.sel_preset.value=undefined;
					}
				}
			});
		}
	}

}

function setConfig(service,param,value){

	dom.btn_apply.disabled=false;

	let s=config[service];
	
	let e=getEnabled(s);

	if(value){
		if(s.logger_enabled!==undefined) s.logger_enabled=1;
		if(s.logger_write!==undefined) s.logger_write=1;
		if(s.LOG_ENABLED!==undefined) s.LOG_ENABLED=1;

		if(!e){
			for(let k in s){
				if(k.startsWith('log_')){
					s[k]=0;
				}
			}
		}
		s[param]=value?1:0;
	}else{
		s[param]=value?1:0;
		let n=0;
		for(let k in s){
			if(k.startsWith('log_')){
				if(s[k]) n++;
			}
		}
		if(!n){
			if(s.logger_enabled!==undefined) s.logger_enabled=0;
			if(s.LOG_ENABLED!==undefined) s.LOG_ENABLED=0;
		}
	}

	

	//console.log(s);
}

function refreshCounter(){
	
	for(let i=0; i<dom.services_content.children.length; i++){
		let d=dom.services_content.children[i];
		let s=d.service;
		let c=config[s];

		let logenabled=(c.logger_enabled && c.logger_write) || c.LOG_ENABLED;
		let monitored=0;

		if(logenabled){
			for(let k in c){
				if(k.startsWith('log_')){
					if(c[k]!==0){
						monitored++;
					}
				}
			}
		}

		let span=d.querySelector('span');

		d.classList.toggle('monitored',monitored);
		if(monitored){
			span.innerHTML=`${s} (${monitored})`
		}else{
			span.innerHTML=`${s}`
		}

	}
}

function getEnabled(s){
	return (s.logger_enabled && s.logger_write) || s.LOG_ENABLED;
}