/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="Узел";
  var $noproto="К узлу не привязан прототип";
  var $noproto_desc="Укажите прототип в свойствах узла в редакторе проектов";
  var $noproto_link="Редактировать узел";
  var $reports="Отчеты";
}else{
  var $title="Node";
  var $noproto="There is no prototype associated with the gateway";
  var $noproto_desc="Specify the prototype in the gateway properties in the project editor";
  var $noproto_link="Edit node";
  var $reports="Reports";
}

PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<a-layout id="gateway_layout" orientation="horizontal" size1="400" stretch="slot2" store="true" slot="2">
	<a-widget id="params"  prefix="params" slot="1"></a-widget>
	<a-widget id="vars"  prefix="vars" slot="2"></a-widget>
</a-layout>
`,
);

PROPERTIES={
	path:{
		type:'string',
		propagate:false,
	},
};


ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

function create(){
	
}

function destroy(){
	pult.unsubscribeStatusVar(self);
}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path')		update_path(changes[k]);
	}
}


function update_path(path){

	pult.unsubscribeStatusVar(self);

	pult.showObject(self,self.path,null,function (o){

		pult.subscribeStatusVar(self,o._status_var,function (v){self.status=v});

		if(o.prototype){

			pult.showAlarms(self,!o.hide_alarm_panel && !!o._alarms);
			dom.params.src=`#interface/node_params?path=${o._path}&show_name=false&caption_link=%self_path%`;
			dom.vars.src=`#interface/vars?path=${o._path}&show_name=false&caption_link=%self_path%`;
			
			pult.loadObject(self,{
				path:`${pult.getProjectPath(o._path)}/prototypes/${o.prototype}`,
				docs:'@content.json'
			},function (p){
				let content=p?.['@content.json'].data;
				let reports=content?.reports;

				let menu=[];

				menu.push({
					text:$vars,
					icon:'/images/var.svg',
					href:'#interface/vars?path='+self.path,
				});
				
				if(reports?.length){

					let active=0;
					for(let i=0; i<reports.length; i++){
						let r=reports[i];
						if(!r.inactive) active++;
					}

					if(active){
						menu.push({
							text:$reports,
							icon:'/images/report.svg',
							href:'#interface/node_report?path='+self.path,
						});
					}
				}

				pult.showTopMenu(self,menu);

			});




		}else{
			pult.showModalError(self,$noproto,$noproto_desc,$noproto_link,o._editor,'editor');
		}
	});


}
