/*--PSEUDO-CODE--*/

if(locale("ru")){
    var $title="Отчеты";
    var $noproto="К узлу не привязан прототип";
    var $load="Загрузить";
    var $expression_error="Некорректное выражение";
    var $notrends_error="Нет трендов для указанных переменных";
    
    var $indicator="Показатель";
    var $begin_period="Начало периода";
    var $end_period="Конец периода";
    var $time="Время";
    var $value="Значение";
    var $error="Ошибка";
    var $total="Итог";
    var $unit="Ед. изм.";
    var $diff="Разница";
    var $comment="Комментарий";
    var $formula="Формула";
    var $source_data="Исходные данные";
    var $tariff="Тариф";
    
}else{
    var $title="Reports";
    var $noproto="There is no prototype associated with the node";
    var $load="Load";
    var $expression_error="Invalid expression";
    var $notrends_error="There are no trends for the specified variables";
    
    var $indicator="Indicator";
    var $begin_period="Beginning of period";
    var $end_period="Ending of period";
    var $time="Time";
    var $value="Value";
    var $error="Error";
    var $total="Total";
    var $unit="Unit";
    var $diff="Difference";
    var $comment="Comment";
    var $formula="Formula";
    var $source_data="Source data";
    var $tariff="Tariff";
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#content{height:100%}`,
	`<div id="pult_header">
  <div class="pult_split">
    <div class="pult_buttons" id="buttons">
      <a-time-span id='time' show_clock_button="0"></a-time-span>
      <a-button id='btn_load' caption=${$load}></a-button>
    </div>
  </div>
</div>

<a-tabs id="tabs" hidden=1></a-tabs>

<div id="content">
  <a-layout orientation="vertical" store="true" size2="400" stretch="slot1">
    <a-grid id="grid"   slot="1"></a-grid>
    <a-layout-window caption="${$source_data}" slot="2">
      <a-widget id="source" prefix="source"></a-widget>
    </a-layout-window>
  </a-layout>
</div>`,
);

PROPERTIES=[
	{
		key:'path',
		default:'/system'
	},
	{
		key:'time1',
		type:'number'
	},
	{
		key:'time2',
		type:'number'
	},
	{
		key:'report',
		type:'string'
	},
];

let records=[];
let reports;
let vars;
let grid;
let node;


ONCREATE=create;
ONDESTROY=destroy;
ONUPDATE=update;

function create(){

	dom.tabs.tabs=[];

    let r=dom.time.getRange('yesterday');
    dom.time.time1=r[0];
    dom.time.time2=r[1];

    dom.tabs.onchange=function (e){
        let t=e.detail;
        self.report=t;
		console.log(t);
    }

    dom.btn_load.onclick=function (){
        self.time1=dom.time.time1
        self.time2=dom.time.time2;
	};

    grid=dom.grid;

}

function destroy(){
	
}

function update(changes){
	
	if(self.time1 && self.time2){
        dom.time.time1=self.time1;
        dom.time.time2=self.time2;
    }
    
    if(self.path){
		pult.showObject(self,self.path,$title,function (o){
			node=o;
			loadNode();    
		});
    }

    if(self.report || self.time1 || self.time2){
        selectReport();
    }

}

function loadNode(){
	pult.loadObject(self,{
		path:`${pult.getProjectPath(node._path)}/prototypes/${node.prototype}`,
		docs:'@content.json'
	},function (p){
		let content=p?.['@content.json'].data;
		let rr=content?.reports;

		reports=[];
		for(let i=0; i<rr.length; i++){
			let r=rr[i];
			if(!r.inactive){
				reports.push(r);
			}
		}

		vars={};
		for(let k in content.drivers){
			let d=content.drivers[k];
			for(let i=0; i<d.length; i++){
				vars[d[i].name]=d[i].name;
			}
		}
		
		let tabs=[];
		for(let i=0; i<reports.length; i++){
			let r=reports[i];
			tabs.push({
				caption:r.name,
				key:r.name,
			});
		}
		dom.tabs.hidden=0;
		dom.tabs.tabs=tabs;
		selectReport();

	});
}

function selectReport(){
	
    
    if(reports && reports.length){
        let report;
        for(let i=0; i<reports.length; i++){
            let r=reports[i];
            if(!report) report=r;
            if(r.name===self.report) report=r;
        }
        dom.tabs.value=self.report;

        if(!self.time1 || !self.time2){
            let r=dom.time.getRange(report.period || 'yesterday');
            dom.time.time1=r[0];
            dom.time.time2=r[1];
        }
		

        loadReport(report);
    }
}



function loadReport(report){

	//console.log(report);

	report.total_caption = report.total_caption || locale_string(schema.types.prototype_report._properties.total_caption.def);
	report.diff_caption = report.diff_caption || locale_string(schema.types.prototype_report._properties.diff_caption.def);
	report.volume_caption = report.volume_caption || locale_string(schema.types.prototype_report._properties.volume_caption.def);
	report.tariff_caption = report.tariff_caption || locale_string(schema.types.prototype_report._properties.tariff_caption.def);


	let prefix=node._prefix;
	let mat=new math();
	let indicators=report.indicators || [];
	
	let vv={};
	let vi={};

	for(let i=0; i<indicators.length; i++){
		let ind=indicators[i]; 
		ind.vars=[];
		let expr=ind.expr.split('$').join('');       
		ind._expr=mat.parse(expr);
		if(ind._expr){
			for(let i=0; i<ind._expr.tokens.length; i++){
				let t=ind._expr.tokens[i];
				let v=t.index_;
				if(t.type_===3 && !mat.functions[v]){
					vv[v]=v;
					ind.vars.push(v);
				}
			}
		}
	}

	let rvars=[];
	

	for(let v in vv){
		let rv;
		if(vars[v]){
			rv=prefix+'_'+v;
		}else{
			rv=v;
		}
		vi[rv]=v;
		rvars.push(rv);
	}

	
	let t1=dom.time.time1 * 1000;
	let t2=dom.time.time2 * 1000;

	dom.source.src='#interface/trendreport?path='+self.path+'&show_header=false&hide_total=true&time1='+t1+'&time2='+t2+'&vars='+rvars.join(',');

	pult.requests(self,[
		['trends_slice',{time:t1,vars:rvars}],
		['trends_slice',{time:t2,vars:rvars}],
	],function (reqs,ress,errs){
		if(errs[0] || errs[1]){
			pult.showModalError(self,errs[0] || errs[1]);
		}else{
			let data1=ress[0];
			let data2=ress[1];

			let vars={};
			let errvars=[];

			for(let i=0; i<rvars.length; i++){
				let rv=rvars[i];
				let v=vi[rv];
				let d1=data1[i];
				let d2=data2[i];
				vars[v]={
					data1:{
						time:d1[0],
						value:d1[1],
						error:d1[2],
					},
					data2:{
						time:d2[0],
						value:d2[1],
						error:d2[2],
					},
				};

				if(!d1[0] && !d2[0]){
					//errvars.push(v);
				} 

			}

			if(errvars.length){

				pult.showModalError(self,$notrends_error,errvars.join(', '));

			}else{

				let records=[];
				let total=0;
				let unit;
				let volume=0;
				let volume_unit;

				for(let i=0; i<indicators.length; i++){
					let r={};
					let ind=indicators[i];
					
					r.indicator=ind.name;
					r.unit=ind.unit;
					r.comment=ind.comment;
					r.expr=ind.expr;
					r.volume_tariff=ind.volume_tariff || 1;
					r.volume_unit=ind.volume_unit || locale_string(schema.types.prototype_report_indicator._properties.volume_unit.def);

					unit=r.unit;
					volume_unit=r.volume_unit;

					let expr1={};
					let expr2={};
					
					r.time1=0;
					r.time2=0;

					r.value1=undefined;
					r.value2=undefined;

					r.error1=undefined;
					r.error2=undefined;

					for(let i=0; i<ind.vars.length; i++){
						let v=ind.vars[i];
						let rv=vars[v];

						expr1[v]=rv.data1.value;
						expr2[v]=rv.data2.value;
						
						if(!r.error1 && rv.data1.time > r.time1) r.time1=rv.data1.time;
						if(!r.error2 && rv.data2.time > r.time2) r.time2=rv.data2.time;

						if(!r.error1 && rv.data1.error){
							r.error1=pult.errstr(rv.data1.error);
							r.time1=rv.data1.time;
						}
						if(!r.error2 && rv.data2.error){
							r.error2=pult.errstr(rv.data2.error);
							r.time2=rv.data2.time;
						}
					}

					try{
						r.value1 = ind._expr.evaluate(expr1);
					}catch(e){
						r.error1 = $expression_error;
						r.time1 = undefined;
					};

					try{
						r.value2 = ind._expr.evaluate(expr2);
					}catch(e){
						r.error2 = $expression_error;
						r.time2 = undefined;
					};
				
					if(r.value1!==undefined && r.value2!==undefined){
						r.diff = r.value2 - r.value1;
					}

					if(r.value1!==undefined && r.value1.toFixed && ind.round!==undefined){
						r.value1 = r.value1.toFixed(ind.round);
					}

					if(r.value2!==undefined && r.value2.toFixed && ind.round!==undefined){
						r.value2 = r.value2.toFixed(ind.round);
					}

					if(r.diff!==undefined && r.diff.toFixed && ind.round!==undefined){
						r.diff = r.diff.toFixed(ind.round);
						if(Util.isNumeric(r.diff)){
							total+=(r.diff*1);
							r.volume=(r.diff*1)*r.volume_tariff;
						}
					}

					if(r.volume!==undefined && r.volume.toFixed && ind.round!==undefined){
						r.volume = r.volume.toFixed(ind.round);
						volume+=(r.volume*1);
					}

					records.push(r);

				}

				if(!report.total_hide){

					if(total!==undefined && total.toFixed && report.total_round!==undefined){
						total = total.toFixed(report.total_round);
					}
					
					if(volume!==undefined && volume.toFixed && report.volume_round!==undefined){
						volume = volume.toFixed(report.volume_round);
					}

					records.push({
						indicator:report.total_caption,
						diff:total,
						unit:unit,
						volume:volume,
						volume_unit:volume_unit,
						total:true,
					});
				}

				drawTable(report);
				grid.records=records;

				// console.log($source_data);

				// dom.source.src='#interface/trendreport?path='+self.path+'&show_header=false&time1='+t1+'&time2='+t2+'&vars='+rvars.join(',');


			}

		}
	});
}




function drawTable(report){
	let columns=[];

	let diff=report.diff_caption || $diff;

	columns.push(
		
		{
			key:'indicator',
			group:$indicator,
			caption:$indicator,
			onrender:function (value,record,column,index,row,cell,refresh) {
				row.classList.toggle("error",!!(record.error1 || record.error2));
				row.classList.toggle("total",!!(record.total));
			}
		},
		{
			key:'time1',
			group:$begin_period,
			format:'$datetimelong',
			caption:$time,
		},
		{
			key:'value1',
			group:$begin_period,
			caption:$value,
			align:'right',
		},
		{
			key:'error1',
			caption:$error,
			group:$begin_period,
		},
		{
			key:'time2',
			group:$end_period,
			format:'$datetimelong',
			caption:$time,
		},
		{
			key:'value2',
			group:$end_period,
			caption:$value,
			align:'right',
		},
		{
			key:'error2',
			group:$end_period,
			caption:$error,
		},
		
	);

	if(!report.diff_hide){
		columns.push(
			{
				key:'diff',
				group:diff,
				caption:diff,
				align:'right',
			},
		);

		if(!report.diff_hide_unit){
			columns.push(
				{
					key:'unit',
					group:diff,
					caption:$unit,
				},
			);
		}

		if(!report.diff_hide_formula){
			columns.push(
				{
					key:'expr',
					group:diff,
					caption:$formula,
				},
			);
		}

	}
	
	if(!report.volume_hide){

		if(!report.tariff_hide){
			columns.push(
				{
					key:'volume_tariff',
					group:report.volume_caption,
					caption:report.tariff_caption,
					align:'right',
				},
			);
		}

		columns.push(
			{
				key:'volume',
				group:report.volume_caption,
				caption:report.volume_caption,
				align:'right',
			},
		);

		if(!report.volume_hide_unit){
			columns.push(
				{
					key:'volume_unit',
					group:report.volume_caption,
					caption:$unit,
				},
			);
		}

	}

	columns.push(
		{
			key:'comment',
			group:$comment,
			caption:'',
		},
	);

	grid.columns=columns;
	grid.css=`.row.error{color:var(--app-error-color)}.row.total{color:var(--app-active-text-color);background-color:var(--app-form-color)}`;
	grid.drawColumns();
}