/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $title="Профиль";
  var $login='Логин';
  var $name='Имя';
  var $photo='Фото';
  var $phone='Телефон';
  var $email='Email';
  var $change_password='Сменить пароль';
  var $select='Выбрать фото';
  var $delete='Удалить';
  var $admin='Администратор системы';
  var $receive_email='Получать уведомления по Email';
  var $receive_telegram='Получать уведомления по Telegram';
  var $receive_sms='Получать уведомления по SMS';
  var $sessions='Сессии';
  var $logout='Выход';
  var $language='Язык';
  var $by_default='По умолчанию';
  var $home_url="URL";
  var $home_page="Главная страница";
  var $project="Проект";
  var $projects="Проекты";
  var $first_project="Первый проект";
  var $specified_project="Указанный проект";
  var $specified_url="Указанный URL";
  var $clear_cache="Очистить кэш";
}else{
  var $title="Profile";
  var $login='Login';
  var $name='Name';
  var $photo='Photo';
  var $phone='Phone';
  var $email='Email';
  var $change_password='Change password';
  var $select='Select photo';
  var $delete='Delete';
  var $admin='System administrator';
  var $receive_email='Receive notification via Email';
  var $receive_telegram='Receive notification via Telegram';
  var $receive_sms='Receive notification via SMS';
  var $sessions='Sessions';
  var $logout='Logout';
  var $language='Language';
  var $by_default='By default';
  var $home_url="URL";
  var $home_page="Home page";
  var $projects="Projects";
  var $project="Project";
  var $first_project="First project";
  var $specified_project="Specified project";
  var $specified_url="Specified URL";
  var $clear_cache="Clear cache";
}

PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`._photo>*{vertical-align:top}._photo div{padding-left:10px;display:inline-block}._photo div a-link{display:block}._photo div a-link+a-link{margin-top:7px}._info{margin:10px 0}`,
	`<div id="form"></div>
`,
);

ONCREATED=created;

let form;

function created(){


	pult.showHeader(self);
	pult.showPath(self,[
		[$title,'#interface/profile'],
	]);
	pult.showName(self,$title,'/images/user.svg');
	//console.log('sel prof',self.__main);
	pult.selectMenuItem(self,'/profile');
	

    pult.showTopMenu(self,[
        {
            text:$clear_cache,
            icon:'/images/clear_cache.svg',
            onclick:function (e){
				pult.resetCache();
				setTimeout(function (){
					let a={};
					for(let k in localStorage){
						if(k.startsWith('auth')){
							a[k]=localStorage[k];
						}
					}
					localStorage.clear();
					for(let k in a){
						localStorage[k]=a[k];
					}
					location.reload();
				},500);
			}
        },
		{
            text:$sessions,
            icon:'/images/sessions.svg',
            href:'#interface/sessions?login=%profile%',
        },
        {
            text:$logout,
            icon:'/images/logout.svg',
            onclick:function (){
                pult.showLogout();
            },
        }
    ]);

	draw(pult.user);

}




function draw(u){

	let s=[

		{
			tag:'a-form-row',
			caption:$login,
			html:{
				disabled:true,
				tag:'a-input',
				name:'login',
				value:u.login,
				validation:['latinNum','maxLen:64','notEmpty'],
			}
		},

		
		{
			tag:'a-form-row',
			html:[
				{
					tag:'a-link',
					html:$change_password,
					underline:'dashed',
					href:'#interface/changepass'
				}
			]
		},


		'---',


		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$admin,
				disabled:true,
				html:{
					tag:'a-checkbox',
					name:'admin',
					value:u.admin,
				}
			}

		},
	 
		'---',

		{
			tag:'a-form-row',
			caption:$home_page,
			html:{
				tag:'a-select',
				name:'home_page',
				value:u.home_page,
				placeholder:$projects,
				undefined:'-',
				list:[
					['projects',$projects],
					['first_project',$first_project],
					['specified_project',$specified_project],
					['specified_url',$specified_url],
				]
			}
		},

		{
			tag:'a-form-row',
			caption:$project,
			visibleIf:'home_page=specified_project',
			html:{
				tag:'a-select',
				name:'home_project',
				value:u.home_project,
				undefined:'-',
				list:u.projects
			}
		},

		{
			tag:'a-form-row',
			caption:$home_url,
			visibleIf:'home_page=specified_url',
			html:{
				tag:'a-input',
				name:'home_url',
				value:u.home_url,
				width:400,
			}
		},

		{
			tag:'a-form-row',
			caption:$language,
			html:{
				tag:'a-select',
				name:'language',
				undefined:`-${$by_default}-`,
				value:u.language,
				list:pult.languageList,
			}
		},


		'---',


		{
			tag:'a-form-row',
			class:'_photo',
			caption:$photo,
			nomobile_width:true,
			html:[
				{
					tag:'a-image',
					name:'icon',
					value:u.icon,
					width:64,
					height:64,
					border_radius:5,
					placeholder:'/images/user.svg',
				},
				{
					tag:'div',
					html:[
						{
							tag:'a-link',
							html:$select,
							underline:'dashed',
							onclick:function () {
								form.dom.icon.select();
								form.dom.del_icon.disabled=false;
							},
						},
						{
							tag:'a-link',
							html:$delete,
							id: "del_icon",
							disabled:!u.icon,
							underline:'dashed',
							onclick:function () {
								form.dom.icon.delete();
								form.dom.del_icon.disabled=true;
							},
						},
					],
				},
			]
		},

		'---',

		{
			tag:'a-form-row',
			caption:$name,
			html:{
				tag:'a-input',
				name:'name',
				value:u.name,
				width:250,
				validation:['maxLen:64'],
			}
		},


		{
			tag:'a-form-row',
			caption:$phone,
			html:{
				tag:'a-input',
				name:'phone',
				value:u.phone,
				validation:['maxLen:30','phone'],
			}
		},
		{
			tag:'a-form-row',
			caption:$email,
			html:{
				tag:'a-input',
				name:'email',
				value:u.email,
				validation:['maxLen:128','email'],
				validation_events:'submit',
			}
		},

		'---',


		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$receive_email,
				disabled:true,
				html:{
					tag:'a-checkbox',
					name:'receive_email',
					value:u.receive_email,
				}
			}

		},

		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$receive_telegram,
				disabled:true,
				html:{
					tag:'a-checkbox',
					name:'receive_telegram',
					value:u.receive_telegram,
				}
			}

		},
	 
		
		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$receive_sms,
				disabled:true,
				html:{
					tag:'a-checkbox',
					name:'receive_sms',
					value:u.receive_sms,
				}
			}

		},

	];


	form=pult.drawForm(dom.form,s,{
		cancelButton:true,
		submitButton:true,
		passwordConfirmation:true,
		onchange:function(){
			pult.needSave=true;
		},
		oncancel:function(){
			pult.needSave=false;
			pult.reloadWidget();
		},
		onsubmit:function(data){       
			pult.request(self,'user_save_profile',data,function(req,res,err){
				if(err){
					pult.showError(self,err);
					form.reset();
				}else{
					form.complete();
					pult.needSave=false;
					pult.reload(true);
				}
			});
		}
	});
}
