/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $title="Информация";
  var $actual_alarms="Актуальные тревоги";
  var $nodes_vars="Узлы и переменные";
  var $phis_vars="Физические переменные";
  var $virt_vars="Виртуальные переменные";
  var $total_vars="Всего переменных";
  var $total_nodes="Всего узлов";
}else{
  var $title="Information";
  var $actual_alarms="Actual alarms";
  var $nodes_vars="Nodes and vars";
  var $phis_vars="Physical variables";
  var $virt_vars="Virtual variables";
  var $total_vars="Total variables";
  var $total_nodes="Total nodes";
}

PROTO=widgetInterfaceProtoCommon;

PROPERTIES={
	path:{
		type:'string',
		propagate:false,
	},
};

TEMPLATE = createTemplate(
	`#_interface_content{padding:20px;max-width:600px}#description{margin-bottom:20px;padding-bottom:20px;font-size:14px;line-height:20px;border-bottom:solid 1px var(--app-header-color);white-space:break-spaces}h4{color:var(--app-comment-color);font-weight:700}`,
	`<div id="description"></div>
<h4>${$actual_alarms}</h4>
<a-alarm-informer id="alarm_informer"></a-alarm-informer>

<h4 class="mt20">${$nodes_vars}</h4>
<div class="pult_infoline"><span>${$phis_vars}</span> <span>&nbsp;</span> <span id="phis_vars"></span></div>
<div class="pult_infoline"><span>${$virt_vars}</span> <span>&nbsp;</span> <span id="virt_vars"></span></div>
<div class="pult_infoline"><span>${$total_vars}</span> <span>&nbsp;</span> <span id="total_vars"></span></div>
<div class="pult_infoline"><span>${$total_nodes}</span> <span>&nbsp;</span> <span id="total_nodes"></span></div>`,
);
	


ONCREATE=create;
ONUPDATE=update;


function create(){

}


function update(changes){
	for(let k in changes){
		let v=changes[k];
		if(k==='path')	update_path(v);
	}
}

function update_path(path){
	//self.clear();

	

	pult.loadObject(self,{
		path:path,
		docs:'@prop.json',
		unpack:'@prop.json',
		parent:true,
		cache:true,
		children:true,
	},function (o){
		pult.showObjectPath(self,o);
		pult.selectMenuItem(self,path);
		pult.showHeader(self,o.show_header);
		pult.showName(self,o._title,o._icon);
		pult.showCaption(self,$title);

		pult.request(self,'project_info',{
			path:path,
		},function (req,res,err){
			if(err){
				pult.showModalError(self,err);
			}else{
				//console.log(res);
				dom.phis_vars.innerHTML=res.stat_phis_vars;
				dom.virt_vars.innerHTML=res.stat_virt_vars;
				dom.total_vars.innerHTML=res.stat_vars;
				dom.total_nodes.innerHTML=res.stat_nodes;
			}
		});

		dom.description.innerHTML=o.description;
		dom.description.style.display = !!o.description ? 'block' : 'none';
		dom.alarm_informer.path=path;
		
	});
}
