/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $title="Проекты";
  var $editor="Редактор";
  var $empty="Нет проектов";
  var $export="Экспорт";
}else{
  var $title="Projects";
  var $editor="Editor";
  var $empty="No projects";
  var $export="Export";
}

PROTO=widgetInterfaceProtoCommon;

PROPERTIES={
	path:{
		type:'string',
		propagate:false,
	},
};

TEMPLATE = createTemplate(
	`#bg {
  padding: 20px;
  overflow: auto;
  gap: 20px;
}
#bg:not(.mobile) {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
}
#bg.mobile {
  gap: 10px;
  padding: 10px;
  grid-template-columns: repeat(auto-fit, minmax(min(100%, 320px), 1fr));
  display: grid;
}
#bg.mobile .project {
  width: auto;
  min-width: 320px;
}
#bg.mobile .project:only-child {
  width: 100%;
}
#bg .project {
  width: 420px;
  background-color: #1e2533;
  padding: 20px;
  border-radius: 5px;
}
#_interface_content {
  background-position: bottom;
  background-repeat: repeat-x;
}
.title {
  display: inline-flex;
  flex-direction: row;
  font-size: 24px;
  line-height: 32px;
  color: var(--app-text-color);
}
.title a-icon {
  --color: var(--app-text-color);
  flex-shrink: 0;
  margin-right: 10px;
  position: relative;
  top: -2px;
  width: 32px;
  height: 32px;
}
a-alarm-informer {
  margin-top: 20px;
}
.links {
  margin-top: 30px;
}
.link {
  display: inline-flex;
  flex-direction: row;
  margin-right: 20px;
  margin-bottom: 10px;
  align-items: center;
}
.link a-icon {
  width: 16px;
  height: 16px;
  margin-right: 6px;
  position: relative;
  top: -2px;
}
@keyframes blinker {
  50% {
    opacity: 0.5;
  }
}
`,
	``,
);
	


ONCREATE=create;
ONDESTROY=destroy;

let interval;
let projects;

function create(){

	pult.showLoading(self);

	dom._interface_content.style.backgroundImage=`url(${config.brand_project_back_image})`;

	pult.loadObject(self,{
		path:'/projects',
		docs:'@prop.json',
		unpack:'@prop.json',
		children:2,
		interface:true,
		inactive:false,
		access:pult.ACS_TYPE_EDIT
	},function (o){
		
		pult.hideLoading(self);

		projects=o;
		let title=locale_string(o._title);

		pult.showHeader(self);
		pult.showPath(self,[
			[title,'#interface/projects'],
		]);
		pult.showName(self,title,o._icon);
		pult.showEditorLink(self,o);
		//pult.showAlarms(self);
		pult.selectMenuItem(self,'/projects');
		drawProjects();

	});

}

function destroy(){

}


function drawProjects(){

	let o=projects;

	dom._interface_content.innerHTML='<div id="bg"></div>';
	dom.bg.classList.toggle('mobile',Util.isMobile);
	
	if(o._children && o._children.length){
		for(let i=0; i<o._children.length; i++){
			let p=o._children[i];

			let links=[];
			for(let i=0; i<p._children.length; i++){
				let pl=p._children[i];
				let lnk=`<a class='link' href='${pl._interface}'>
					<a-icon src='${pl._icon}'></a-icon>
					<div>${pl._title}</div>
				</a>`;
				links.push(lnk);
			}

			let lnk=`<a target='_blank' class='link' href='${p._editor}'>
				<a-icon src='/images/editor.svg'></a-icon>
				<div>${$editor}</div>
			</a>`;
			links.push(lnk);

			
			let prj=document.createElement('div');
			
			prj.className='project';
			prj.innerHTML=`
				<a class='title' href='${p._interface}'>
					<a-icon src='${p._icon}'></a-icon>
					<div>${p._title}</div>
				</a>		
				<a-alarm-informer path='${p._path}'></a-alarm-informer>
				<div class='links'>${links.join('')}</div>
			`
			dom.bg.appendChild(prj);

			if(config.demo_mode){
				let links=prj.querySelector('.links');
				let a=document.createElement('a');
				a.className='link';
				a.href='javascript:void(0)';
				a.innerHTML=`
				<a-icon src='/images/export.svg'></a-icon>
				<div>${$export}</div>`;
				a.onclick=function (){
					pult.exportObjects(self,p._path);
				}
				links.appendChild(a);
			}	

			//console.log(prj.offsetHeight);
		}
	}else{
		dom._interface_content.innerHTML=`<div class="pult_empty">${$empty}</div>`;
	}

}