/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="Перезагрузка";
  var $reboot="Перезагрузить";
  var $text=`Перезагрузить устройство?`;
}else{
  var $title="Reboot";
  var $reboot="Reboot";
  var $text=`Reboot device?`;
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#_interface_content{justify-content:center;align-items:center}#info{text-align:center;font-size:16px;line-height:24px}#info a-icon{--color:var(--app-comment-color);margin-bottom:40px;opacity:.5}#reboot{margin-top:40px;--text-color:var(--app-active-text-color);--background-color:var(--app-red-color);height:40px;padding:0 20px}`,
	`<div id="info">
	<a-icon src="/images/reboot.svg" width="128"></a-icon>
	<div>
		${$text}
	</div>
	<a-button id="reboot" caption="${$reboot}"></a-button>
</div>`,
);

ONCREATE=create;
ONDESTROY=destroy;

let reboot=false;
let disconnected=false;
let time=0;
let int;

function create(){

    pult.showPath(self,[
        [$system,'#interface/system'],
        [$title,'#interface/reboot'],
    ]);
    pult.showHeader(self,true);
    pult.showName(self,$title,"/images/reboot.svg");
    pult.showCaption(self,null);
    pult.selectMenuItem(self,'/system/reboot');


    dom.reboot.onclick=function (){

        

        pult.request(self,'system_reboot',null,function (req,res,err){
            if(err){
                pult.showModalError(self,err);
            }else{
                time=Time.timestamp;
                pult.workspace.widget.showLoading($title);
                reboot=true;
            }
        });

    }
    
    int=setInterval(function (){
        if(reboot){
            if(!pult.rpc.connected) disconnected=true;
            if(disconnected && pult.rpc.connected && (Time.timestamp - time > 15)){
                reboot=false;
                disconnected=false;
                pult.workspace.widget.hideLoading($title);
                location.hash='#interface/system';
            }
        }
    },1000);
}


function destroy(){
    clearInterval(int);
}
