/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="Удаленный доступ";
  var $enable="Включить удаленный доступ";
  var $info="Функция удаленного доступа позволяет работать с локальным сервером через интернет. Ваш сервер будет доступен по&nbsp;адресу:";
  var $warning="ВНИМАНИЕ!<br>Перед включением удаленного доступа убедитесь, что пароли достаточно надежны.";
  var $access_enabled="Включен";
  var $access_disabled="Отключен";
  var $disable_access="Отключить удаленный доступ?";
  var $disable="Отключить";
  var $disable_access_text="Если вы подключены к серверу через удаленный доступ, его отключение приведет к разрыву связи с сервером. Снова включить удаленный доступ можно будет только при локальном подключении к серверу!";
}else{
  var $title="Remote access";
  var $enable="Enable remote access";
  var $info="The remote access function allows you to work with local server via the Internet. Your server will be available&nbsp;at:";
  var $warning="ATTENTION!<br>Before enabling remote access, make sure that your passwords are strong enough.";
  var $access_enabled="Enabled";
  var $access_disabled="Disabled";
  var $disable_access="Disable remote access?";
  var $disable="Disable";
  var $disable_access_text="If you are connected to the server via remote access, disabling it will break the connection with the server. You can only enable remote access again by connecting locally to the server!";
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`control-common-switch1{--on-color:var(--app-success-color);--handle-on-color:var(--app-active-text-color);--handle-off-color:var(--app-comment-color);vertical-align:bottom;margin-right:5px;cursor:pointer}#switch{font-size:16px}#switch span{cursor:pointer}#info{max-width:500px;margin-top:20px;padding-top:20px;border-top:solid 1px var(--app-control-color)}#address{margin-top:20px;display:inline-block;font-size:16px}#warning{max-width:500px;margin-top:20px;padding-top:20px;border-top:solid 1px var(--app-control-color);color:var(--app-warning-color)}`,
	`<div id="content">
	<div id="switch">
		<control-common-switch1 id="switch_control" radius="20" padding="0" width="40" height="20"></control-common-switch1> <span id="switch_label">${$enable}</span>
	</div>
	
	<div id="info">${$info}</div>
	<a id="address" href="/">https://myserver.pult.host</a>
	<div id="warning">${$warning}</div>
</div>`,
);

ONCREATE=create;
ONDESTROY=destroy;

function create(){

    dom._interface_content.classList.add('pult_small_form');

    pult.showPath(self,[
        [$system,'#interface/system'],
        [$title,'#interface/remote'],
    ]);
    pult.showHeader(self,true);
    pult.showName(self,$title,"/images/remote.svg");
    pult.selectMenuItem(self,'/system/remote');

    dom.switch_label.onclick=function (e){
        dom.switch_control.value=!dom.switch_control.value;
        dom.switch_control.fire('change');
    }

    dom.switch_control.onchange=function (e){
        
        pult.needSave=true;

        let enabled;
        let port;
        let ssl;

        enabled=dom.switch_control.value ? 1 : 0;
        if(location.port){
            port = Number(location.port);
        }else{
            port = location.protocol==='https:' ? 443 : 80;
        }
        ssl = location.protocol==='https:' ? 1 : 0;

        let f=function (){
    
            pult.request(self,'system_set_config',{
                config:{
                    hostclient:{
                        ENABLED: enabled,
                        target_port: port,
                        target_ssl: ssl,
                    }
                }
            },function (req,res,err){
                if(err){
                    pult.showModalError(self,err);
                }else{
                    pult.needSave=false;
                    pult.showCaption(self, enabled ? $access_enabled : $access_disabled); 
                }
            });
        }

        if(enabled){
            f();
        }else{
            pult.showConfirm(self,{
                caption:$disable_access,
                html:$disable_access_text,
                width: 400,
                submit:$disable,
                submitPalette:'anode-button-warning',
                oncancel:function (){
                    pult.reloadWidget();
                },
                onsubmit:function (){
                    f();
                }
            });
        }

    }

    pult.request(self,'system_config_data',{
        service:'hostclient',
    },function (req,res,err){
        if(err){
            pult.showModalError(self,err);
        }else{

            let enabled = Number(res.ENABLED);
            let protocol = res.server_ssl ? 'https' : 'http';
            let domain = res.client_domain;
            let host = res.server_host;

            dom.switch_control.value=enabled;
            pult.showCaption(self, enabled ? $access_enabled : $access_disabled); 

            let address=`${protocol}://${domain}.${host}`;
            dom.address.innerHTML=address;
            dom.address.href=address;

        }
    });

}


function destroy(){
    
}

