/*--PSEUDO-CODE--*/

if(locale("ru")){
  var $title="Расписания";
  var $filter="Фильтр";
  var $filter_empty="Нет объектов, удовлетворяющих фильтру";
  var $count_filter="Фильтр";
  var $noobjects="Нет объектов";
  var $objects="Объекты";
  var $schedule='Расписание';
  var $add_schedule='Добавить расписание';
  var $schedule_name='Расписание';
  var $simple_format="Почасовой формат";
  var $universal_format="Универсальный формат";
}else{
  var $title="Schedules";
  var $filter="Filter";
  var $filter_empty="No objects matching the filter";
  var $count_filter="Filter";
  var $noobjects="No objects";
  var $objects="Objects";
  var $schedule='Schedule';
  var $add_schedule='Add schedule';
  var $schedule_name='Schedule';
  var $simple_format="Hourly format";
  var $universal_format="Universal format";
}
(function (){
    
    window.base64_decode=function(base64string) { // base64 string to arrayBuffer
        var binaryString = (base64string!==null && base64string!=='') ? atob(base64string) : '';
        var bytes = new Uint8Array(binaryString.length);
        for (var i = 0; i < binaryString.length; i++) {
            bytes[i] = binaryString.charCodeAt(i);
        }
        return bytes.buffer;
    }


    window.base64_encode=function(arrayBuffer) { // arrayBuffer to base64 string
        
        var base64    = ''
        var encodings = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
      
        var bytes         = new Uint8Array(arrayBuffer)
        var byteLength    = bytes.byteLength
        var byteRemainder = byteLength % 3
        var mainLength    = byteLength - byteRemainder
      
        var a, b, c, d
        var chunk
      
        // Main loop deals with bytes in chunks of 3
        for (var i = 0; i < mainLength; i = i + 3) {
          // Combine the three bytes into a single integer
          chunk = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2]
      
          // Use bitmasks to extract 6-bit segments from the triplet
          a = (chunk & 16515072) >> 18 // 16515072 = (2^6 - 1) << 18
          b = (chunk & 258048)   >> 12 // 258048   = (2^6 - 1) << 12
          c = (chunk & 4032)     >>  6 // 4032     = (2^6 - 1) << 6
          d = chunk & 63               // 63       = 2^6 - 1
      
          // Convert the raw binary segments to the appropriate ASCII encoding
          base64 += encodings[a] + encodings[b] + encodings[c] + encodings[d]
        }
      
        // Deal with the remaining bytes and padding
        if (byteRemainder == 1) {
          chunk = bytes[mainLength]
      
          a = (chunk & 252) >> 2 // 252 = (2^6 - 1) << 2
      
          // Set the 4 least significant bits to zero
          b = (chunk & 3)   << 4 // 3   = 2^2 - 1
      
          base64 += encodings[a] + encodings[b] + '=='
        } else if (byteRemainder == 2) {
          chunk = (bytes[mainLength] << 8) | bytes[mainLength + 1]
      
          a = (chunk & 64512) >> 10 // 64512 = (2^6 - 1) << 10
          b = (chunk & 1008)  >>  4 // 1008  = (2^6 - 1) << 4
      
          // Set the 2 least significant bits to zero
          c = (chunk & 15)    <<  2 // 15    = 2^4 - 1
      
          base64 += encodings[a] + encodings[b] + encodings[c] + '='
        }
        
        return base64
    }
})();



PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`a-browser-item{--icon-hover-color:var(--app-active-text-color);--text-hover-color:var(--app-active-text-color)}`,
	`<div id="pult_header">
	<div class="pult_split">
		<div id="buttons" class="pult_buttons pult_sep"></div>
		<a-input clear_button=1 debounce=300 placeholder=${$filter} id='filter'></a-input>
	</div>
</div>
<a-browser id='browser' empty_string="${$noobjects}"></a-browser>
<div id='empty' class="pult_empty" hidden>${$filter_empty}</div>
`,
);

PROPERTIES={
	filter:{
		type:'string',
	},
};



ONCREATE=create;
ONUPDATE=update;
ONDESTROY=destroy;

let paths={};
let blink;

function create(){
	dom.filter.onchange=function(e){
		self.filter=e.detail;
    }
}

function destroy(){

}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path')		update_path(changes[k]);
		if(k==='filter')	update_filter(changes[k]);
	}
}


function update_filter(){

	let brw=dom.browser;
    let f=self.__filter;
    dom.filter.value=f;
    
    let count=0;
    let visible=0;
    
    for(let n of brw.childNodes){
        count++;
        if(Util.match(f,n.title)){
            n.hidden=false;
            visible++;
        }else{
            n.hidden=true;
        }
    }

    if(count>0 && visible==0){
		dom.browser.hidden=true;
        dom.empty.hidden=false;
    }else{
		dom.browser.hidden=false;
        dom.empty.hidden=true;
    }

    if(f){
        pult.showCount(self,visible,$count_filter);
    }else{
        pult.showCount(self,visible);
    }
}


function update_path(path){

	pult.showObject(self,self.path,$title,function (o){
		
		pult.loadObject(self,{
			path:path,
			docs:'@prop.json',
			unpack:'@prop.json',
			parent:true,
			cache:false,
			children:true,
			interface:true,
			inactive:false,
			access:pult.ACS_TYPE_EDIT,
		},function (o){
			
			Util.create(dom.buttons,{
				tag:'a-button',
				caption:$schedule,
				icon:'/images/add.svg',
				onclick:function (){
	
					let name=$schedule_name;
					let path=o._path + '/' + name + '.schedule';
	
					pult.request(self,'fdb_nextname',{
						path:path
					},function (req,res,err){
						if(err){
							pult.showError(self,err);
						}else{
							path=res;
							let name=Util.getFileTitle(path);
							let f=pult.showForm(self,{
								caption:$add_schedule,
								width:400,
								submitFocus:false,
								html:[
									{
										tag:'a-input',
										value:name,
										width:'100%',
										name:'name',
										set_focus:true,
										validation:['fileName'],
									},
									{
										tag:'a-options',
										class:'mt10',
										value:ls.get('default_schedule_format','simple'),
										name:'format',
										list:[
											['simple',$simple_format],
											['universal',$universal_format],
										]
									}
								],
								onsubmit:function (e){
									let name=e.detail.name;
									let format=e.detail.format;
									let path=o._path + '/' + name + '.schedule';
									ls.set('default_schedule_format',format)
									
									let params={
										path:path,
									}
									pult.fdb.create(self,params,function (req,res,err){
										if(err){
											pult.showError(self,err);
											f.show();
										}else{
											let schedule=Util.def({format:format},pult.defaultSchedule);
											let text=JSON.stringify(schedule);
											let buf=(new TextEncoder("utf-8").encode(text)).buffer;
											let b64=base64_encode(buf);
	
											pult.fdb.saveDoc(self,path,{
												file:'@content.json',
												format:'base64',
												data: b64,
											},function (req,res,err){
												if(err){
													pult.showError(self,err);
													f.show();
												}else{
													pult.navigate(`#interface/${format}_schedule?path=${path}`);
												}
											});
										}
									});
								}
							});
						}
					});
	
				}
			});

			drawList(o._children);
		});

		

	});

}

function drawList(list){
	let brw=dom.browser;
	brw.innerHTML='';

	paths={};

	if(list){
		for(let i=0; i<list.length; i++){
			let o=list[i];
			if(o){
				
				// if(o._interface.startsWith('#interface/universal_schedule')){
				// 	o._icon='/images/uschedule.svg';
				// }

				let color;
				if(o._status==='enabled'){
					color='var(--app-status-work-color)';
				}else{
					color='var(--app-status-offline-color)';
				}

				let bi=Util.create(brw,{
					tag:"a-browser-item",
					title:o._title,
					icon_size:32,
					href:pult.getResourceFileLink(o),
					icon_src:o._icon,
					icon_color:color,
					text_color:color,
				});
				paths[o._path]=bi;
			}
		}	
	}
	update_filter();

}
