/*--PSEUDO-CODE--*/

PROTO=widgetInterfaceProtoCommon;

PROPERTIES={
	mimic:{
		type:'string',
		propagate:false,
	},
	params:{
		type:'object',
		propagate:false,
	},
	show_menu:{
		type:'boolean',
		propagate:false,
	},
	scale:{
		type:'number',
		propagate:false,
	},
	mobile:{
		type:'boolean',
		propagate:false,
	},
};

TEMPLATE = createTemplate(
	`#_mimic{flex-shrink:0}#_mimic_container{width:100%;height:100%}#_mimic_container.hor_align_center{display:flex;justify-content:center}#_mimic_container.hor_align_right{display:flex;justify-content:right}#_mimic_container.ver_align_center{display:flex;align-items:center}#_mimic_container.ver_align_bottom{display:flex;align-items:end}`,
	``,
);
	
if(locale("ru")){
  var $title="Экран";
  var $mimic="Мнемосхема";
  var $node="Узел";
  var $gateway="Шлюз";
  var $reports="Отчеты";
  var $load_mimic="Загрузка мнемосхемы";
  var $fit='Масштаб';
  var $vars='Переменные';
  var $trends='Тренды';
  var $alarms='Тревоги';
  var $nodes='Узлы';
  var $mimic_settings='Настройки мнемосхемы';
  var $scale='Масштабирование';
  var $by_mimic_settings='По настройкам мнемосхемы';
  var $by_width='Вписать по ширине';
  var $by_height='Вписать по высоте';
  var $by_width_and_height='Вписать по ширине и высоте';
  var $none='Не масштабировать (прокрутка)';
  var $apply='Применить';

  var $menu_settings='Настройки';
  var $menu_nodes='Узлы';
  var $menu_node='Узел';
  var $menu_group='Меню';
  var $menu_vars='Переменные';
  
  var $edit_prototype='Редактировать прототип';
  var $edit_screen='Редактировать экран';
  var $mimic_params='Параметры мнемосхемы: %s';
  // var $errors_header='Ошибки в редакторе проекта:';
  // var $errors_link='Редактировать';
  // var $error_mimic_not_defined='в свойствах экрана не привязана мнемосхема';
  // var $error_node_not_defined='в свойствах экрана не привязан узел (%s)';
  // var $error_node_not_found='в свойствах экрана привязан несуществующий узел (%s); возможно, требуется сборка проекта';
  // var $error_bad_mimic='мнемосхема не содержит параметра с прототипом, подходящим к данному узлу; требуемый прототип: %s';

}else{
  var $title="Screen";
  var $mimic="Mimic";
  var $node="Node";
  var $gateway="Gateway";
  var $reports="Reports";
  var $load_mimic="Load mimic";
  var $fit='Fit';
  var $none='None';
  var $vars='Variables';
  var $trends='Trends';
  var $alarms='Alarms';
  var $nodes='Nodes';
  var $settings='Settings';
  var $mimic_settings='Mimic settings';
  var $scale='Scaling';
  var $by_mimic_settings='By mimic settings';
  var $by_width='Fit width';
  var $by_height='Fit height';
  var $by_width_and_height='Fit width and height';
  var $none='No scaling';
  var $apply='Apply';

  var $menu_settings='Settings';
  var $menu_nodes='Nodes';
  var $menu_node='Node';
  var $menu_group='Menu';
  var $menu_vars='Variables';

  var $edit_prototype='Edit prototype';
  var $edit_screen='Edit screen';
  var $mimic_params='Mimic parameters: %s';
  // var $errors_header='Errors in project editor:';
  // var $errors_link='Edit';
  // var $error_mimic_not_defined='no mimic is bound in the screen properties';
  // var $error_node_not_defined='no node is bound in the screen properties';
  // var $error_node_not_found='a non-existent node (%s) is bound in screen properties; project build may be required';
  // var $error_bad_mimic='the mimic does not contain a parameter with a prototype matching this node; required prototype: %s';
}
let screenLastJsFile;

function screenLoad(o,handler){
	if(o.content==='html'){		
		screenLoadHTML(o,handler);
	}else{
		screenLoadMimic(o,handler);
	}
}

function screenDestroy(){
	if(screenLastJsFile){
		if(screenLastJsFile.destroy) screenLastJsFile.destroy();
		screenLastJsFile=null;
	}
}

function screenLoadMimic(o,handler){

	let params={};
	for(let k in o){
		if(k.startsWith('param_')){
			let v=o[k];
			let kk=k.split('_');
			kk.shift();
			let t=kk.shift();
			k=kk.join('_');
			params[k]=v;
		}
	}

	if(self.mimic){

		mimicShow({
			desktop:o.desktop_mimic,
			mobile:o.mobile_mimic,
		},{
			desktop:self.mimic,
			mobile:self.mimic,
		},params,undefined,o._alarms,handler);

	}else{

		if(!o.desktop_mimic && !o.mobile_mimic){
			pult.showModalError(self,WEBAPP_ERROR_SCREEN_MIMIC_NOT_DEFINED,undefined,$edit_screen,`#editor/screen?path=${self.path}`);
			return;
		}
		mimicShow({
			desktop:o.desktop_mimic,
			mobile:o.mobile_mimic,
		},undefined,params,undefined,o._alarms,handler);
	}
}

function screenLoadHTML(o,handler){
	
	pult.showHeader(self,true);
	pult.showAlarms(self,!o.hide_alarm_panel && !!o._alarms);

	Util.promises(function (resolve){
		screenLoadCSSFile(o,resolve);
	},function (resolve){
		screenLoadHTMLFile(o,function (){
			screenLoadJSFile(o,resolve);
		})
	},function (){
		datareceived=true;
		handler();
	});

}

function screenLoadHTMLFile(object,handler){
	let file=object._html_file;
	if(file){
		pult.loadBundle(self,file,['html','HTML','htm','HTM'],function (bundle){

			let mc=document.createElement("div");
			mc.id='_mimic_container';
			mc.innerHTML=bundle;
			//mc.innerHTML=bundle+'<widget-interface-alarms></widget-interface-alarms>';
			dom._interface_content.appendChild(mc);
			self.checkWebComponentComplete();
			//self.append(bundle);
			handler();
		});
	}else{
		handler();
	}
}

function screenLoadCSSFile(object,handler){
	let file=object._css_file;
	if(file){
		pult.loadBundle(self,file,'css',function (bundle){
			self.append('<style>'+bundle+'</style>');
			handler();
		});
	}else{
		handler();
	}
}

function screenLoadJSFile(object,handler){
	let file=object._js_file;
	if(file){
		pult.loadBundle(self,file,'js',function (bundle){
			let className='js_file_'+Util.crc32(file);
			if(!window[className]){
				let tmp=`function $name(self,object,container){

function create(){};
function destroy(){};

$code

this.create=create;
this.destroy=destroy;

};`;
				tmp=tmp.split('$name').join(className);
				tmp=tmp.split('$code').join(bundle);
				let e = window.document.createElement('script');
				e.setAttribute('data-src',file);
				e.innerHTML = tmp;
				document.head.appendChild(e);
			}

			screenLastJsFile=new window[className](self,object,dom._interface_content);
			if(screenLastJsFile.create) screenLastJsFile.create();
			handler();
		});
	}else{
		handler();
	}

}
function mimicLoad(o,handler){
	let params=self.__params;
	let shortPath=pult.shortPath(o._path);
	mimicShow(shortPath,null,params,o,0,handler);
}

function mimicShow(mainMimicPaths,subMimicPaths,params,mimicObject=undefined,alarms=0,handler){

    mimicParams=params;

	let main_path;
	let sub_path;

	if(self.mobile===undefined){
		main_path=pult.selectMimicForDevice(mainMimicPaths);
		sub_path=pult.selectMimicForDevice(subMimicPaths);
	}else if(self.mobile){
		main_path=pult.selectMimicForDevice(mainMimicPaths,'mobile');
		sub_path=pult.selectMimicForDevice(subMimicPaths,'mobile');
	}else{
		main_path=pult.selectMimicForDevice(mainMimicPaths,'desktop');
		sub_path=pult.selectMimicForDevice(subMimicPaths,'desktop');
	}

	let path = sub_path || main_path;

	let tag=pult.getMimicTag(self,path);
	let url=pult.getMimicContentURL(self,tag);

	Util.promises(function (resolve){
		pult.loadMimics(self,[[tag,url]],function (err){
			if(err){
				pult.showError(widget,err);
			}else{
				resolve();
			}
		});
	},function (resolve){
		if(path===main_path){
			resolve();
		}else{
			let tag=pult.getMimicTag(self,main_path);
			pult.loadObject(self,{
				path:pult.getMimicPath(self,tag),
				docs:'@prop.json',
				unpack:'@prop.json',
				cache:true,
				interface:true,
				inactive:false,
				access:pult.ACS_TYPE_EDIT
			},function (o){
				mainMimicObject=o;
				resolve();
			});
		}
	},function (resolve){
		if(mimicObject){
			resolve();
		}else{
			pult.loadObject(self,{
				path:pult.getMimicPath(self,tag),
				docs:'@prop.json',
				unpack:'@prop.json',
				cache:true,
				interface:true,
				inactive:false,
				access:pult.ACS_TYPE_EDIT
			},function (o){
				mimicObject=o;
				resolve();
			});
		}		
	},function (){

		if(path===main_path) mainMimicObject=mimicObject;

		mimic=mimicObject;
		clearMimic();
		

		pult.applySchemaDefaults(mimicObject,'mimic');

		let m=document.createElement(tag);
		m.id='_mimic';
		mimicProps=window[tag].properties;
		prefixes=[];
		let toprefix=[];

		if(params){
			let xnode=params["%node%"];
			if(xnode){
				for(let k in mimicProps){
					let p=mimicProps[k];
					if(p.type==='object' && p.own){
						params[k]=xnode;
						delete params["%node%"];
						break;
					}
				}
			}

			

			let projectPath=pult.getProjectPath(self.path);
			for(let k in params){
				let p=mimicProps[k];
				let v=params[k];				
				if(v!==undefined){
					if(p && p.type==='object' && p.own){
						if(v.endsWith('.node') || v.endsWith('.gateway')){
							toprefix.push([k,`${projectPath}/nodes/${v}`]);
						}
					}
				}
			}	
		}	

		Util.promises(function (resolve){
			
			if(toprefix.length){
				let paths=[];
				for(let i=0; i<toprefix.length; i++){
					paths.push(toprefix[i][1]);
				}
				pult.request(self,'node_prefixes',{
					paths:paths
				},function (req,res,err){
					if(err){
						pult.showModalError(self,err);
					}else{
						for(let i=0; i<res.length; i++){
							let param=toprefix[i][0];
							let prefix=res[i];
							params[param]=prefix?prefix:undefined;
						}					
						resolve();
					}
				},false,true);
			}else{
				resolve();
			}

		},function (){


			let totalnodes=0;
			let emptynodes=[];
			for(let k in mimicProps){
				let v=params?.[k];
				let p=mimicProps[k];
				if(p && p.type==='object' && p.own){
					totalnodes++;
					if(v===undefined){
						emptynodes.push(k);
					}
				}
			}

			if(emptynodes.length && pult.getTypeDef(mimic,'option_unlinked_nodes')==='error'){
				pult.showModalError(self,WEBAPP_ERROR_NODE_NOT_DEFINED,Util.format($mimic_params,emptynodes.join(', ')),$edit_screen,`#editor/screen?path=${self.path}`);
				return;
			}

			for(let k in params){
				let v=params[k];
				let p=mimicProps[k];
				let val;
				if(v!==undefined){
					if(p && p.type==='object' && p.own){
						val='$'+v;
						if(!prefixes.includes(v)) prefixes.push(v);
					}else{
						val=v;
					}
					m.setAttribute(k,val);
				}
			}

			if(!mimicContainer){
				mimicContainer=document.createElement("div");
				mimicContainer.id='_mimic_container';
				mimicContainer.appendChild(m);
				dom._interface_content.appendChild(mimicContainer);
			}
	
			mimicRefreshOptions(alarms);
			mimicRefreshScale();
			//mimicRefreshMenu();
	
			handler();
	
			self.checkWebComponentComplete();
		});

	});
}

function mimicRefreshScale(o){

	if(!mimic) return;

	scale=self.getAttribute('scale');
	if(scale===null) scale=getUserScale();
	if(scale===undefined) scale=pult.getTypeDef(mimic,'option_scale');

	let m=dom._mimic;
	let parent=m?.parentNode;

	if(m){
		let sx, sy;
		if(scale==1){  // X
			sx='true';
			sy='false';
		}else if(scale==2){ // Y
			sx='false';
			sy='true';
		}else if(scale==3){ // XY
			sx='true';
			sy='true';
		}else{ // None
			sx='false';
			sy='false';
		}

		let sw=m.scrollWidth;
        let sh=m.scrollHeight;
        let ow=m.parentNode.offsetWidth-10;
        let oh=m.parentNode.offsetHeight-10;

        let kw=1;
        let kh=1;
        
        if(sw>ow) kw=ow/sw;
        if(sh>oh) kh=oh/sh;

		if(scale!==m._last_scale || m._last_kh!==kh || m._last_kw!==kw){
            
            m._last_scale=scale;
            m._last_kh=kh;
            m._last_kw=kw;

			//console.log(sw,sh,ow,oh,sx,sy,kw,kh);

            if(sx=='true' && sy=='true' && (kw<1 || kh<1)){
                let k=Math.min(kw,kh);
                m.style.transformOrigin='0% 0%';
                m.style.transform=`scale(${k})`;
            }else if(sx=='true' && kw<1){
				m.style.transformOrigin='0% 0%';
                m.style.transform=`scale(${kw})`;
            }else if(sy=='true' && kh<1){
				m.style.transformOrigin='0% 0%';
                m.style.transform=`scale(${kh})`;
            }else{
                m.style.transformOrigin='';
                m.style.transform='';
            }
        }

	}


}


function mimicRefreshOptions(alarms){

	let show_header = self.getAttribute('show_header') ?? pult.getTypeDef(mainMimicObject,'option_show_header');
	let show_alarms = self.getAttribute('show_alarms') ?? pult.getTypeDef(mainMimicObject,'option_show_alarms');
	let show_menu =   self.getAttribute('show_menu')   ?? pult.getTypeDef(mainMimicObject,'option_show_menu');

	if(show_header==='hide' || show_header==='false')	{self.hideHeader();}else{self.showHeader();}
	if(show_alarms==='hide' || show_alarms==='false' || !alarms)	{self.hideAlarms();}else{self.showAlarms();}
	if(show_menu==='hide' || show_menu==='false')  	{hideMenu();}else{showMenu();}

	let ha=pult.getTypeDef(mimic,'option_hor_align');
	mimicContainer.classList.add('hor_align_'+ha);
	
	let va=pult.getTypeDef(mimic,'option_ver_align');
	mimicContainer.classList.add('ver_align_'+va);
	

}


function mimicRefreshMenu(){

	let data={
		path:self.path,
	};
	
	for(let k in nodes){
		data[k]=nodes[k];
	}
	
	let m=dom._mimic;

	for(let k in mimicProps){
		let p=mimicProps[k];
		if(p.own){
			let a=m.getAttribute(k);
			if(a!==null) data[k]=a;
		}
	}

	let premenu=[];
	let menu=[];
	
	let mimicMenu;
	let show_menu=pult.getTypeDef(mainMimicObject,'option_show_menu');
	if(show_menu==='main'){
		mimicMenu=mainMimicObject.menu;
	}else{
		mimicMenu=mimic?.menu;
	}	
	
	if(mimicMenu && mimicMenu.length){

		let bind=new Bind(data,100);

		let st=schema.types.mimic_menu;
		let stp=st._properties;
		let group=null;
		
		for(let i=0; i<mimicMenu.length; i++){
			
			let m=Util.clone(mimicMenu[i]);
			for(let k in stp){
				let p=stp[k];
				if(m[k]===undefined && p.def!==undefined) m[k]=p.def;
			}

			if(m.type==='settings'){
			
				let def={
					text:$menu_settings,
					icon:'/images/settings.svg',
				};
				m=Util.def(m,def);
				m.onclick=showSettings;
			
			}else if(m.type==='nodes'){

			
				let count=Object.keys(nodes).length;
				let text;
				let disabled;
				let popmenu;
				let href;
				let icon;

				if(count>1){
					text=$menu_nodes;
					disabled=false;
					popmenu=[];
					let nn=Util.ota(nodes);
					Util.keySort(nn,'title');
					for(let i=0; i<nn.length; i++){
						let n=nn[i];
						let icon=pult.fdb.parseIcons(n.icon,mimic._path);
						let href;
						if(Util.getFileExt(n.path)==='gateway'){
							href=`#interface/gateway?path=${n.path}`;
						}else{
							href=`#interface/node?path=${n.path}`;
						}
						popmenu.push({
							caption: n.title,
							href:href,
							icon: icon || '/images/node.svg',
						});
					}
				}else if(count===1){
					let n=nodes[Object.keys(nodes)[0]];
					if(Util.getFileExt(n.path)==='gateway'){
						href=`#interface/gateway?path=${n.path}`;
					}else{
						href=`#interface/node?path=${n.path}`;
					}
					icon=pult.fdb.parseIcons(n.icon,mimic._path);
					text=$menu_node;
					disabled=false;
				}else{
					text=$menu_nodes;
					disabled=true;
				}

				let def={
					text: text,
					href: href,
					popmenu: popmenu,
					disabled: disabled,
					icon:icon || '/images/node.svg',
				};
				m=Util.def(m,def);
			
			}else if(m.type==='vars'){

				let vv=Object.keys(vars);
				let def={
					text:$menu_vars,
					icon:'/images/var.svg',
					href:`#interface/vars?path=${self.path}&list=${vv.join(',')}`
				};
				m=Util.def(m,def);
			
			}else if(m.type==='group'){

				let def={
					text:$menu_group,
					icon:'/images/dotmenu.svg',
				};
				m=Util.def(m,def);

				group=m.popmenu=[];
			
			}else if(m.type==='submimic'){

				let def={
					text:Util.getFileTitle(m.submimic),
					icon:'/images/screen.svg',
					href:`#interface/screen?path=${self.path}&mimic=${m.submimic}`
				};
				m=Util.def(m,def);

				group=m.popmenu=[];
			
			}

			if(m.format==='icon_text'){
				if(!m.text) m.text='MenuItem'+(i+1);
				if(!m.icon) m.icon='/images/fallback.svg';
			}else if(m.format==='icon'){
				m.text=undefined;
				if(!m.icon) m.icon='/images/fallback.svg';
			}else if(m.format==='text'){
				if(!m.text) m.text='MenuItem'+(i+1);
				m.icon=undefined;
			}

			if(group && m.type!=='group'){
				if(m.group){
					if(m.type==='separator'){
						group.push('-');
					}else{
						group.push(m);
						m.caption=m.text;
						m.text=undefined;
					}
					m._ingroup=true;
				}else{
					group=null;
				}
			}
			
			for(let k in m){
				let v=m[k];
				if(v && v.split){
					for(let k in mimicProps){
						let p=mimicProps[k];
						let pv=mimicParams[k];
						if(p.type==='object' && p.own){
							v=v.split(`$${k}`).join(`$${pv}`);
						}
					}
				}
				m[k]=v;
				
				if(v?.indexOf?.('$')>=0){
					bind.bind(m,k,m[k]);
				}
			}

			if(m.visible && !m._ingroup){
				premenu.push(m);
			}
		}

		bind.update();

		for(let i=0; i<premenu.length; i++){
			
			let m=premenu[i];
			
			let menuPath=hash.getPath(m.href);
			let menuParams=hash.getParams(m.href);
			let hashPath=hash.getPath(location.hash);
			let hashParams=hash.getParams(location.hash);

			if(m.href){
				let active=false;
				if(hashPath===menuPath){
					active=true;
					for(let k in menuParams){
						let v=menuParams[k];
						if(v!==hashParams[k]){
							active=false;
							break;
						}
					}
				}

				if(active){
					m.className='active';
				}
			}

			m.icon=pult.fdb.parseIcons(m.icon,mimic._path);

			if(m.enabled!==undefined) m.disabled=!Util.toBoolean(m.enabled);
			if(m.visible!==undefined) m.hidden=!Util.toBoolean(m.visible);

			if(!m.hidden){
				if(m.type==='separator'){
					menu.push('-');
				}else{
					menu.push(m);
				}
			}

		}
		
		bind.destroy();

	}

	pult.showTopMenu(self,menu);
}
function nodeLoad(o,handler){

	if(!o._desktop_mimic && !o._mobile_mimic){
		let projectPath=pult.getProjectPath(self.path);
		pult.showModalError(self,WEBAPP_ERROR_PROTOTYPE_MIMIC_NOT_DEFINED,undefined,$edit_prototype,`#editor/prototype?path=${projectPath}/prototypes/${o.prototype}`);
		return;
	}

	if(self.mimic){

		mimicShow({
			desktop:o._desktop_mimic,
			mobile:o._mobile_mimic,
		},{
			desktop:self.mimic,
			mobile:self.mimic,
		},{
			"%node%":o._prefix,
		},undefined,o._alarms,handler);

	}else{

		mimicShow({
			desktop:o._desktop_mimic,
			mobile:o._mobile_mimic,
		},undefined,{
			"%node%":o._prefix,
		},undefined,o._alarms,handler);
	}


}


let scale;
let prefixes;
let mimic;
let datareceived;
let loadTimer;
let nodes;
let mimicParams;
let mimicProps;
let mimicContainer;
let mainMimicObject;
let vars;

ONCREATE=create;
ONDESTROY=destroy;
ONUPDATE=update;

function create(){
	dom._content._testcusto=true;
	pult.unsubscribeStatusVar(self);
	self.addEventListener('webcomponentcomplete',onwebcomponentcomplete);
	resizeObserver = new ResizeObserver(function(entries){
		window.requestAnimationFrame(function (){
			mimicRefreshScale();
		});
	});

	resizeObserver.observe(dom._interface_content);

	self.mimic_loading=document.createElement('a-modal-loading');
	self.dom._interface_content.appendChild(self.mimic_loading);
		
}

function destroy(){
	screenDestroy();
	self.removeEventListener('webcomponentcomplete',onwebcomponentcomplete);
	self.unbindData();
	resizeObserver.disconnect();
}

function update(changes){
	if(
		changes.hasOwnProperty('path') ||
		changes.hasOwnProperty('mimic') ||
		changes.hasOwnProperty('params')
	){
		
		if(self.path){
			pult.abort(self);
			pult.hideModalError(self);
			clear();
			self.unbindData();
			vars=Object.create(null);
			screenDestroy();
			loadObject();
		}
	}

	for(let k in changes){
		if(k==='show_menu') update_show_menu();
		if(k==='scale') update_scale();
	}
}

function clear(){
	dom._interface_header_content.innerHTML='';
	//self.dom._interface_content.innerHTML='';
}

function clearMimic(){
	if(mimicContainer){
		mimicContainer.remove();
		mimicContainer=null;
	}
}

function update_scale(){
	scale=self.__scale;
	mimicRefreshScale();
}

function update_show_menu(){
	if(self.show_menu){
		showMenu();
	}else{
		hideMenu();
	}
}

function showMenu(){
	dom._interface_header_menu.hidden=false;
}

function hideMenu(){
	dom._interface_header_menu.hidden=true;
}

function onwebcomponentcomplete(){
	if(mimicContainer){
		self.bindData(mimicContainer,prefixes,function (e,data){
			if(e==='onNodesLoaded'){
				nodes=Util.ato(data.nodes,'prefix');
				mimicRefreshMenu();
			}else if(e==='onSubscribe'){
				for(let i=0; i<data.vars.length; i++){
					let v=data.vars[i];
					vars[v]=true;
				}
				mimicRefreshMenu();
			}else if(e==='onUpdateValues'){
				if(!datareceived){
					datareceived=true;
					hideLoad();
				}
			}
		});

		if(!prefixes?.length){
			datareceived=true;
			hideLoad();
		}
	}
}

function showLoad(){
	clearTimeout(loadTimer);
	datareceived=false;
	self.mimic_loading.show($load_mimic);
}

function hideLoad(){
	if(datareceived){
		clearTimeout(loadTimer);
		self.mimic_loading.hide($load_mimic);
	}else{
		loadTimer=setTimeout(function (){
			datareceived=true;
			hideLoad();
		},500);
	}
}

function loadObject(){

	showLoad();
	
	requestAnimationFrame(function (){
		pult.unsubscribeStatusVar(self);
		pult.loadObject(self,{
			path:self.path,
			docs:'@prop.json',
			unpack:'@prop.json',
			parent:true,
			cache:true,
			access:pult.ACS_TYPE_EDIT,
		},function (o){
		
	
			pult.subscribeStatusVar(self,o._status_var,function (v){self.status=v});
			pult.showObjectPath(self,o);
			pult.showEditorLink(self,o);
			pult.selectMenuItem(self,self.path);
			pult.showName(self,o._title,o._icon,`#interface/screen?path=${o._path}`);
	
			if		(o._type==='screen') screenLoad(o,hideLoad);
			else if	(o._type==='mimic') mimicLoad(o,hideLoad);
			else if	(o._type==='node') nodeLoad(o,hideLoad);
			else if	(o._type==='gateway') nodeLoad(o,hideLoad);
			
		});
	});

}


function showSettings(){

	let scale=getUserScale();

    pult.showForm(self,{
        caption:$mimic_settings,
        width:400,
        submit:$apply,
        //height:300,

        html:[
            {
                tag:'a-form-row',
                caption:$scale,
                html:{
                    tag:'a-options',
                    name:'scale',
                    width:'100%',
                    list:[
						[undefined,$by_mimic_settings],
						[0,$none],
                        [3,$by_width_and_height],
                        [1,$by_width],
                        [2,$by_height],
                    ],
                    value:scale,
                },
            }
        ],   
    
        onchange:function(e){
            
        },
    
        onsubmit:function(e){
            let scale=e.detail.scale;
			setUserScale(scale);
			mimicRefreshScale();
        }
    });
}

function getUserScale(){
	return ls.get('screen_scale_'+ Util.crc32(self.path));
}

function setUserScale(scale){
	ls.set('screen_scale_'+ Util.crc32(self.path),scale);
}



