/*--PSEUDO-CODE--*/

if(locale('ru')){
	var $title="Отчет по трендам";
	var $notrends="Тренды не загружены";
	var $link="Ссылка";
	var $copy="Копировать";
	var $log="Лог";
	var $load="Загрузить";
	var $load_title="Повторный запрос данных за указанный период";
	var $filter="Фильтр";
	var $next="Далее";
	var $next_title="Загрузить следующие записи указанного периода";
	var $var="Переменная";
	var $time1="Время";
	var $value1="Значение";
	var $error1="Ошибка";
	var $time2="Время";
	var $value2="Значение";
	var $error2="Ошибка";
	var $description="Описание";
	var $unit="Ед.изм.";
	var $tags="Теги";
	var $comment="Комментарий";
	var $project="Проект";
	var $path="Путь";
	var $node="Узел";
	var $diff="Разница";
	var $indicator="Показатель";
	var $begin_period="Начало периода";
	var $end_period="Конец периода";
	var $total="Итог";
}else{
	var $title="Trend report";
	var $notrends="No trends loaded";
	var $link="Link";
	var $copy="Copy";
	var $log="Лог";
	var $load="Load";
	var $load_title="Repeated request for data for a specified period";
	var $filter="Filter";
	var $next="Next";
	var $next_title="Load the following records for the specified period";
	var $var="Variable";
	var $time1="Time";
	var $value1="Value";
	var $error1="Error";
	var $time2="Time";
	var $value2="Value";
	var $error2="Error";
	var $description="Description";
	var $unit="Unit";
	var $tags="Tags";
	var $comment="Comment";
	var $project="Project";
	var $path="Path";
	var $node="Node";
	var $trends="Trends";
	var $diff="Difference";
	var $indicator="Indicator";
	var $begin_period="Beginning of period";
	var $end_period="Ending of period";
	var $total="Total";
}
  


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<div id="pult_header">
  <div class="pult_split" id='tabs_bar' >
    <div class="pult_buttons" id="buttons">
      <a-time-span id='time' show_clock_button="0"></a-time-span>
      <a-button id='btn_load' title="${$load_title}"  caption=${$load}></a-button>
    </div>
  </div>
</div>

<a-grid id='grid'></a-grid>`,
);

PROPERTIES=[
	{
		key:'path',
		default:'/system'
	},
	{
		key:'time1',
		type:'number'
	},
	{
		key:'time2',
		type:'number'
	},
	{
		key:'reload',
		type:'boolean'
	},
	{
		key:'hide_total',
		type:'boolean',
		default:false,
	},
	'vars',
	'filter',
];

let records=[];
let grid;

ONCREATE=create;
ONDESTROY=destroy;
ONUPDATE=update;

function create(){

	dom.btn_load.onclick=function (){
		let t1=dom.time.time1*1000;
		let t2=dom.time.time2*1000;
		if(self.time1===t1 && self.time2===t2){
			reload(true);
		}else{
			self.time1=t1
			self.time2=t2;
		}
	};

}

function destroy(){
	
}

function update(changes){
	
	if(changes.hasOwnProperty('hide_total')){
		drawTable();
	}
	
	if(	changes.hasOwnProperty('vars') || 
	changes.hasOwnProperty('time1') || 
	changes.hasOwnProperty('time2') || 
	changes.hasOwnProperty('time2') || 
	changes.hasOwnProperty('reload')){
			reload();	
	}
	
	if(changes.hasOwnProperty('filter')){
		refreshFilter();
	}

	if(self.path){

		pult.showObject(self,self.path,$title);
		
	}else{

		pult.showPath(self,[
			[$system,'#interface/system'],
			[$title,'#interface/trendslice'],
		]);
		pult.showHeader(self,true);
		pult.showName(self,$title,"/images/report.svg");
		pult.showCaption(self,null);
		pult.selectMenuItem(self,'/system/trendslice');

	}
}



function reload(refresh){
	let time1=self.time1 || 0;
	let time2=self.time2 || 0;
	let vars=self.vars;

	if(!time1 && !time2){
		let r=dom.time.getRange('yesterday');
		time1=r[0]*1000;
		time2=r[1]*1000;
	}

	dom.time.time1=time1/1000;
	dom.time.time2=time2/1000;

	loadVars(vars,time1,time2,refresh);
}

function refreshButtons(){
	pult.showCount(self,records.length);
}


function loadVars(vars,time1,time2,refresh){

	

	if(vars){
		let list=vars.split(',');

		pult.loadVars(self,{
			list:list,
		},function(vars,nodes){

			nodes=Util.ato(nodes,'index');

			for(let i=0; i<vars.length; i++){
				let v=vars[i];
				let n=nodes[v.nodeindex];
				v._title=v.description || v.name;
				console.log(nodes,v);
				v._pseudo_path=pult.getPseudoPath(n.path,undefined,2);
				v._project=pult.getProjectName(n.path);
				v._project_path=pult.getProjectPath(n.path);
				v._ext=Util.getFileExt(n.path);
				v._path=n.path;
			}

			pult.requests(self,[

				['trends_slice',{time:time1,vars:list}],
				['trends_slice',{time:time2,vars:list}],

			],function (reqs,ress,errs){
			
				if(errs[0] || errs[1]){
					pult.showModalError(self,errs[0] || errs[1]);
				}else{
					
					let data1=ress[0];
					let data2=ress[1];

					records=[];
					
					for(let i=0; i<vars.length; i++){

						let v=vars[i];
						let vd1=data1[i];
						let vd2=data2[i];
						let value1=vd1[1];
						let value2=vd2[1];
						let diff;

						if(value1!==undefined && value2!==undefined){
							diff=value2-value1;
							if(v.round!==undefined) diff=diff.toFixed(v.round);	
						}
						
						if(v.round!==undefined && value1!==undefined) value1=value1.toFixed(v.round);
						if(v.round!==undefined && value2!==undefined) value2=value2.toFixed(v.round);

						let r=Util.clone(v);
						r.time1=vd1[0];
						r.value1=value1;
						r.error1=pult.errstr(vd1[2]);
						r.time2=vd2[0];
						r.value2=vd2[1];
						r.error2=pult.errstr(vd2[2]);
						r.diff=diff;

						records.push(r);

					}
				
					dom.grid.records=records;
					refreshButtons();

				}
			});
		});
	}else{
		dom.grid.records=[];
	}
}




function drawTable(){

	grid=dom.grid;
	let columns=[];

	columns.push(
		
		{
			key:'_project',
			group:$indicator,
			caption:$project,
			class:'project',
			onrender:function (value,record,column,index,row,cell,refresh) {
				row.classList.toggle("error",!!record.error);
				let r=record;
				cell.innerHTML=`<a href="#interface/project?path=${r._project_path}">${r._project}</a>`;
			}
		},
		{
			key:'_pseudo_path',
			group:$indicator,
			caption:$node,
			class:'path',
			sort_cols:['_project','_pseudo_path'],
			onrender:function (value,record,column,index,row,cell,refresh) {
				let r=record;
				if(r.ext==='gateway'){
					cell.innerHTML=`<a href="#interface/gateway?path=${r._path}">${r._pseudo_path}</a>`;
				}else{
					cell.innerHTML=`<a href="#interface/node?path=${r._path}">${r._pseudo_path}</a>`;
				}
			},
		},
		{
			key:'_title',
			group:$indicator,
			caption:$var,
			class:'_name',
			sort_cols:['_project','_pseudo_path','_title'],
		},
		{
			key:'time1',
			group:$begin_period,
			format:'$datetimelong',
			caption:$time1,
		},
		{
			key:'value1',
			group:$begin_period,
			caption:$value1,
			align:'right',
		},
		{
			key:'error1',
			caption:$error1,
			group:$begin_period,
		},
		{
			key:'time2',
			group:$end_period,
			format:'$datetimelong',
			caption:$time2,
		},
		{
			key:'value2',
			group:$end_period,
			caption:$value2,
			align:'right',
		},
		{
			key:'error2',
			group:$end_period,
			caption:$error2,
		},
	);

	if(!self.hide_total){

		columns.push(
			{
				key:'diff',
				group:$total,
				caption:$diff,
				align:'right',
			},
			{
				key:'unit',
				group:$total,
				caption:$unit,
			},
			{
				key:'comment',
				group:$total,
				caption:$comment,
			},
		);
	}

	grid.columns=columns;
	grid.sort_column=2;
	grid.css=``;
	grid.drawColumns();
}

