/*--PSEUDO-CODE--*/

if(locale('ru')){
	var $title="Срез трендов";
	var $notrends="Тренды не загружены";
	var $link="Ссылка";
	var $copy="Копировать";
	var $log="Лог";
	var $load="Загрузить";
	var $load_title="Повторный запрос данных за указанный период";
	var $filter="Фильтр";
	var $next="Далее";
	var $next_title="Загрузить следующие записи указанного периода";
	var $var="Переменная";
	var $value="Значение";
	var $description="Описание";
	var $unit="Ед.изм.";
	var $time="Время";
	var $error="Ошибка";
	var $tags="Теги";
	var $comment="Комментарий";
	var $project="Проект";
	var $path="Путь";
	var $node="Узел";
	var $trends="Тренды";
  }else{
	var $title="Trend slice";
	var $notrends="No trends loaded";
	var $link="Link";
	var $copy="Copy";
	var $log="Лог";
	var $load="Load";
	var $load_title="Repeated request for data for a specified period";
	var $filter="Filter";
	var $next="Next";
	var $next_title="Load the following records for the specified period";
	var $var="Variable";
	var $value="Value";
	var $description="Description";
	var $unit="Unit";
	var $time="Time";
	var $error="Error";
	var $tags="Tags";
	var $comment="Comment";
	var $project="Project";
	var $path="Path";
	var $node="Node";
	var $trends="Trends";
  
  }
  


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`#content{flex-grow:1;display:flex;flex-direction:column}#notrends{margin-top:20vh;text-align:center;color:var(--app-comment-color);font-size:16px}.pult_buttons a-button{flex-shrink:0!important}`,
	`
<div id="pult_header">

	<div class="pult_split pult_sep" id='tabs_bar' >
    <div class="pult_buttons">
      <div class="pult_buttons" id="buttons">
        <a-time-picker id='time1' show_clock_button="0"></a-time-picker>
        <a-button id='btn_load' title="${$load_title}"  caption=${$load}></a-button>
      </div>
    </div>
    <div class="pult_buttons">
      <a-input class="pult_filter" clear_button=1 debounce=300 id='filter' placeholder=${$filter}></a-input>
    </div>
  </div>
    
</div>

<a-grid id='grid'></a-grid>`,
);

PROPERTIES=[
	{
		key:'path',
		default:'/system'
	},
	{
		key:'time1',
		type:'number'
	},
	{
		key:'reload',
		type:'boolean'
	},
	'vars',
	'filter',
];


ONCREATE=create;
ONDESTROY=destroy;
ONUPDATE=update;

let records=[];
let total=0;
let lastTime;
let startTime;
let reload_counter=0;
let grid;


function create(){

	dom.btn_load.onclick=function (){
		let t1=dom.time1.value*1000;
		if(self.time1===t1 && self.time2===t2){
			reload(true);
		}else{
			self.time1=t1
		}
	};

	dom.filter.onchange=function (e){
		self.filter=e.detail;
	}

	drawTable();

}

function destroy(){
	
}

function update(changes){
	
	if(	changes.hasOwnProperty('vars') || 
		changes.hasOwnProperty('time1') || 
		changes.hasOwnProperty('reload')){
			reload();	
	}

	if(changes.hasOwnProperty('filter')){
		refreshFilter();
	}
	
	if(self.path){

		pult.showObject(self,self.path,$title);
		
	}else{

		pult.showPath(self,[
			[$system,'#interface/system'],
			[$title,'#interface/trendslice'],
		]);
		pult.showHeader(self,true);
		pult.showName(self,$title,"/images/report.svg");
		pult.showCaption(self,null);
		pult.selectMenuItem(self,'/system/trendslice');

	}
}


function refreshFilter(){
    let f=self.filter;
    dom.filter.value=f;
    dom.grid.filter = [f];
    refreshButtons();
}

function refreshButtons(){
	let filter;
	if(total > records.length){
		if(dom.filter.value){
			pult.showCount(self,`${dom.grid.filter_count}<small> / ${total}</small>`,$filter);
		}else{
			pult.showCount(self,`${records.length}<small> / ${total}</small>`);
		}
	}else{
		if(dom.filter.value){
			pult.showCount(self,dom.grid.filter_count,$filter);
		}else{
			pult.showCount(self,records.length);
		}
	}
}

function reload(refresh){
	let time1=self.time1 || 0;
	let vars=self.vars;

	if(!time1){
		time1=Time.timestampms;
	}

	dom.time1.value=time1/1000;

	loadVars(vars,time1,refresh);
}



function loadVars(vars,time1,refresh){

	if(vars){
		let list=vars.split(',');
		pult.loadVars(self,{
			
			list:list,

		},function(vars,nodes){
			
			nodes=Util.ato(nodes,'index');
			//console.log(vv,nn);
			for(let i=0; i<vars.length; i++){
				let v=vars[i];
				let n=nodes[v.nodeindex];
				v._title=v.description || v.name;
				v._pseudo_path=pult.getPseudoPath(n.path,undefined,2);
				v._project=pult.getProjectName(n.path);
				v._project_path=pult.getProjectPath(n.path);
				v._ext=Util.getFileExt(n.path);
				v._path=n.path;
			}


			pult.request(self,'trends_slice',{
				time:time1,
				vars:list,
			},function (req,res,err){
				
				if(err){
				
					pult.showModalError(self,err);
				
				}else{

					let data=res;
					records=[];
					
					for(let i=0; i<data.length; i++){

						let v=vars[i];

						let vd=data[i];
						let value=vd[1];
						if(v.round!==undefined && value!==undefined) value=value.toFixed(v.round);

						let time=vd[0];
						let r=Util.clone(v);
						
						r.time=time;
						r.value=value;
						r.error=pult.errstr(vd[2]);

						records.push(r);

						//console.log(v,dd.length);

					}

					Util.keySort(records,'time');
					startTime=req.params.time1;

					if(records.length){
						lastTime=records[records.length-1].time;
					}else{
						lastTime=res.time1;
					}
	
					//console.log(records);
					
					dom.grid.records=records;
					if(!refresh) grid.scroll(0);

					refreshButtons();
				}


			});


		});
	}
}



function drawTable(){

	grid=dom.grid;
	let columns=[];

	columns.push(
		{
			key:'time',
			format:'$datetimelongms',
			caption:$time,
		},
		{
			key:'_project',
			caption:$project,
			class:'project',
			onrender:function (value,record,column,index,row,cell,refresh) {
				row.classList.toggle("error",!!record.error);
				if(record.time < startTime)	row.classList.add("old");
				let r=record;
				cell.innerHTML=`<a href="#interface/project?path=${r._project_path}">${r._project}</a>`;
			}
		},
		{
			key:'_pseudo_path',
			caption:$node,
			class:'path',
			sort_cols:['_project','_pseudo_path'],
			onrender:function (value,record,column,index,row,cell,refresh) {
				let r=record;
				if(r.ext==='gateway'){
					cell.innerHTML=`<a href="#interface/gateway?path=${r._path}">${r._pseudo_path}</a>`;
				}else{
					cell.innerHTML=`<a href="#interface/node?path=${r._path}">${r._pseudo_path}</a>`;
				}
			},
		},
		{
			key:'_title',
			caption:$var,
			class:'_name',
			sort_cols:['_project','_pseudo_path','_title'],
		},
		{
			key:'value',
			caption:$value,
			align:'right',
		},
		{
			key:'unit',
			caption:$unit,
		},
		{
			key:'error',
			caption:$error,
		},
		{
			key:'comment',
			caption:$comment,
		},
	);

	grid.columns=columns;
	grid.sort_column=3;
	grid.css=`.row.error,.row.error .cell a{color:var(--app-error-color)}.row.old .cell{opacity:.5}@keyframes key_lamp_updated{0%{background:var(--app-active-text-color)}30%{background:var(--app-selected-color)}100%{background:0 0}}@keyframes key_text_updated{0%{color:var(--app-active-text-color)}}@keyframes key_updated{0%{background:var(--selected-color)}100%{background:0 0}}`;
	grid.drawColumns();
}

