/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $title="Пользователь";
  var $users="Пользователи";
  var $sessions="Сессии";
  var $journal="Журнал";
  var $new_user="Новый пользователь";
  var $edit="Редактирование";
  var $create="Создание";
  var $create_user="Создать пользователя";
  var $default='- По умолчанию -';
  var $menu='Меню';
  var $by_default='По умолчанию';
  var $login='Логин';
  var $password='Пароль';
  var $admin='Администратор системы';
  var $readonly='Только просмотр';
  var $name='Имя';
  var $access='Доступ';
  var $info='Информация';
  var $department='Отдел';
  var $position='Должность';
  var $photo='Фото';
  var $phone='Телефон';
  var $email='Email';
  var $language='Язык';
  var $dashboard='Панель управления';
  var $create_user='Создать пользователя';
  var $change_password='Сменить пароль';
  var $reset_password='Сбросить пароль';
  var $reset_password_text='Пользователю будет установлен новый пароль:';
  var $temppass='Временный пароль';
  var $temp_password='Временный пароль: <b>%s</b>';
  var $global_permissions='Глобальные разрешения';
  var $select='Выбрать фото';
  var $user_created='Пользователь создан';
  var $user_created_text='Логин:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;${login}<br/>Временный пароль: ${password}';
  var $copy='Копировать';
  var $delete='Удалить';
  var $delete_user='Удалить пользователя?';
  var $delete_user_text='Пользователь будет удален.<br>Действие невозможно будет отменить.';
  var $yes_delete='Да, удалить';
  var $user_deleted='Пользователь удален';
  var $generate_password='Сгенерировать пароль';
  var $receive_email='Получать уведомления по Email';
  var $receive_telegram='Получать уведомления по Telegram';
  var $receive_sms='Получать уведомления по SMS';
  var $request_changepass='Потребовать сменить пароль при входе';
  var $make_admin="Сделать пользователя администратором системы?";
  var $apikey="API-ключ";
  var $home_url="URL";
  var $kiosk_mode='Режим киоска';
  var $editor_access='Доступ к Редактору';
  var $done="Готово";
  var $active_account="Активный аккаунт";
  var $generate_apikey="Сгенерировать API-ключ";
  var $home_page="Главная страница";
  var $project="Проект";
  var $projects="Проекты";
  var $first_project="Первый проект";
  var $specified_project="Указанный проект";
  var $specified_url="Указанный URL";
  var $copied="Скопировано в буфер";
}else{
  var $title="User";
  var $users="Users";
  var $sessions="Sessions";
  var $journal="Journal";
  var $new_user="New user";
  var $create_user="Create user";
  var $edit="Edit";
  var $create="Create";
  var $default='- By default -';
  var $menu='Menu';
  var $by_default='By default';
  var $login='Login';
  var $password='Password';
  var $admin='System administrator';
  var $readonly='Read only';
  var $name='Name';
  var $access='Access';
  var $info='Information';
  var $department='Department';
  var $position='Position';
  var $photo='Photo';
  var $phone='Phone';
  var $email='Email';
  var $language='Language';
  var $dashboard='Dashboard';
  var $create_user='Create user';
  var $change_password='Change password';
  var $reset_password='Reset password';
  var $reset_password_text='Reset user password to temporary password?<br><br>Temporary password:';
  var $temppass='Temporary password';
  var $temp_password='Temporary password: %s';
  var $global_permissions='Global permissions';
  var $select='Select photo';
  var $user_created='User was created';
  var $user_created_text='Login: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;${login}<br/>Temp. password: ${password}';
  var $copy='Copy';
  var $delete='Delete';
  var $delete_user='Delete user?';
  var $delete_user_text='The user will be deleted.<br>The action cannot be undone.';
  var $yes_delete='Yes, delete';
  var $user_deleted='User deleted';
  var $generate_password='Generate password';
  var $receive_email='Receive notification via Email';
  var $receive_telegram='Receive notification via Telegram';
  var $receive_sms='Receive notification via SMS';
  var $request_changepass='Require a password change when logging in';
  var $make_admin="Make the user the system administrator?";
  var $apikey="API-key";
  var $home_url="URL";
  var $kiosk_mode='Kiosk mode';
  var $editor_access='Access to Editor';
  var $done="Готово";
  var $active_account="Active account";
  var $generate_apikey="Generate API-key";
  var $home_page="Home page";
  var $projects="Projects";
  var $project="Project";
  var $first_project="First project";
  var $specified_project="Specified project";
  var $specified_url="Specified URL";
  var $copied="Copied to clipboard";
}

PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	`._photo>*{vertical-align:top}._photo div{padding-left:10px;display:inline-block}._photo div a-link{display:block}._photo div a-link+a-link{margin-top:7px}._info{margin-top:10px;margin-bottom:10px}`,
	`<div id="pult_header">
</div>
<div id="pult_content">
  <div id="form"></div>
</div>`,
);

PROPERTIES={
	login:{
		default:null,
	}
};

ONUPDATE=update;
ONCREATE=create;


let login;
let newUser;
let form;
let projects;

function create(){
	pult.showHeader(self);
	pult.selectMenuItem(self,'/system/users');
}

function update(changes){

	if(changes.hasOwnProperty('login')){

		pult.request(self,'fdb_list',{

			path:'/projects',
			inactive:false,

		},function (req,res,err){
			
			//console.log(res);

			projects=[];
			for(let i=0; i<res.length; i++){
				let p=res[i];
				projects.push(Util.getFileTitle(p.name));
			}

			login=self.login;
			newUser=!login;
			
			if(login){

				pult.showPath(self,[
					[$system,'#interface/system'],
					[$users,'#interface/users'],
					[login,'#interface/user?login='+login]
				]);
				pult.showName(self,login,'/images/user.svg');

				pult.showTopMenu(self,[
					{
						text:$sessions,
						icon:'/images/sessions.svg',
						href:'#interface/sessions?login='+login,
					},
					{
						text:$journal,
						icon:'/images/journal.svg',
						href:'#interface/journal?user='+login,
					},
				]);

				
				loadUser();

			}else{
			
				pult.showPath(self,[
					[$system,'#interface/system'],
					[$users,'#interface/users'],
					[$new_user,'#interface/user']
				]);
				pult.showName(self,$new_user,'/images/user.svg');

				let u={
					password:aPassword.temppass(),
					changepass:true,
				};
				drawUser(u);
			}

		});
	}

}


//////////////////////////////////////////////////////////////////////


function loadUser(){
	pult.request(self,'user_get',{
		login:login
	},function (req,res,err){
		if(err){
			pult.showModalError(self,err);
		}else{
			drawUser(res);
		}
	});
}



function drawUser(u){
	

	dom.form.innerHTML='';

	let s=[

		{
			tag:'a-form-row',
			html:{
				tag:'a-input',
				name:'cur_login',
				value:u.login,
				hidden:true,
			}
		},

		{
			tag:'a-form-row',
			caption:$login,
			required:true,
			html:{
				tag:'a-input',
				name:newUser?'login':'new_login',
				value:u.login,
				validation:['latinNum','maxLen:64','notEmpty'],
				set_focus:newUser,
			}
		},
		
		{
			tag:'a-form-row',
			caption:$temppass,
			required:true,
			hidden:!newUser,
			html:[
				{
					tag:'a-password',
					name:'password',
					show_password:true,
					value:u.password,
					validation:['notEmpty','maxLen:64']
				}
			]
		},

		{
			tag:'a-form-row',
			hidden:!newUser,
			html:[
			{
				tag:'a-link',
				html:$generate_password,
				underline:'dashed',
				onclick:function () {
					form.dom['password'].value=aPassword.temppass();
				},
			}
			]
		},

		{
			tag:'a-form-row',
			hidden:newUser,
			html:[
			{
				tag:'div',
				class:'_info',
				id:'password_reseted',
				html:$temp_password,
				hidden:true,
			},
			{
				tag:'a-link',
				html:$reset_password,
				underline:'dashed',
				onclick: resetPassword,
			},
			]
		},


		{
			tag:'a-form-row',
			html:{
			tag:'a-label',
			hidden:!newUser,
			caption:$request_changepass,
			html:{
				tag:'a-checkbox',
				name:'changepass',
				value:u.changepass,
			}
			}
			
		},
		
		
		'---',
		
		{
			tag:'a-form-row',
			hidden:newUser,
			html:{
				tag:'a-label',
				caption:$active_account,
				disabled:u.login===pult.user.login,
				html:{
					tag:'a-checkbox',
					name:'blocked',
					value:!!u.blocked,
					value_on:false,
					value_off:true,
				}
			}

		},

		
		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$admin,
				disabled:u.login===pult.user.login,
				html:{
					tag:'a-checkbox',
					name:'admin',
					value:!!u.admin,
				}
			}

		},

		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$editor_access,
				id:'edacs',
				disabled:0,
				html:{
					tag:'a-checkbox',
					name:'editor_access',
					value:!!u.editor_access,
				}
			}

		},

		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$readonly,
				disabled:u.login===pult.user.login,
				html:{
					tag:'a-checkbox',
					name:'readonly',
					value:!!u.readonly,
				}
			}

		},

		'---',

		{
			caption:$apikey,
			tag:'a-form-row',
			html:{
				tag:'a-input',
				name:'apikey',
				value:u.apikey,
				width:400,
				validation:['latinNum','minLen:16'],
			}

		},

		{
			tag:'a-form-row',
			html:[
			{
				tag:'a-link',
				html:$generate_apikey,
				underline:'dashed',
				onclick:function () {
					form.dom['apikey'].value=Util.randhex(32);
				},
			}
			]
		},

		'---',

		

		{
			tag:'a-form-row',
			caption:$home_page,
			html:{
				tag:'a-select',
				name:'home_page',
				value:u.home_page,
				placeholder:$projects,
				undefined:'-',
				list:[
					['projects',$projects],
					['first_project',$first_project],
					['specified_project',$specified_project],
					['specified_url',$specified_url],
				]
			}
		},

		{
			tag:'a-form-row',
			caption:$project,
			visibleIf:'home_page=specified_project',
			html:{
				tag:'a-select',
				name:'home_project',
				value:u.home_project,
				undefined:'-',
				list:projects
			}
		},

		{
			tag:'a-form-row',
			caption:$home_url,
			visibleIf:'home_page=specified_url',
			html:{
				tag:'a-input',
				name:'home_url',
				value:u.home_url,
				width:400,
			}
		},


		{
			tag:'a-form-row',
			caption:$language,
			html:{
				tag:'a-select',
				name:'language',
				undefined:`-${$by_default}-`,
				value:u.language,
				list:pult.languageList,
			}
		},


		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$kiosk_mode,
				html:{
					tag:'a-checkbox',
					name:'kiosk_mode',
					value:u.kiosk_mode,
				}
			}

		},

		'---',

		
		{
			tag:'a-form-row',
			class:'_photo',
			caption:$photo,
			nomobile_width:true,
			html:[
				{
					tag:'a-image',
					name:'icon',
					value:u.icon,
					width:64,
					height:64,
					border_radius:5,
					placeholder:'/images/user.svg',
				},
				{
					tag:'div',
					html:[
						{
							tag:'a-link',
							html:$select,
							underline:'dashed',
							onclick:function () {
								form.dom.icon.select();
								form.dom.del_icon.disabled=false;
							},
						},
						{
							tag:'a-link',
							html:$delete,
							id: "del_icon",
							disabled:!u.icon,
							underline:'dashed',
							onclick:function () {
								form.dom.icon.delete();
								form.dom.del_icon.disabled=true;
							},
						},
					],
				},
			]
		},




		'---',

		{
			tag:'a-form-row',
			caption:$name,
			html:{
				tag:'a-input',
				name:'name',
				value:u.name,
				width:400,
				validation:['maxLen:64'],
			}
		},

		{
			tag:'a-form-row',
			caption:$phone,
			html:{
			tag:'a-input',
			name:'phone',
			value:u.phone,
			validation:['maxLen:30','phone'],
			}
		},
		{
			tag:'a-form-row',
			caption:$email,
			html:{
			tag:'a-input',
			name:'email',
			value:u.email,
			validation:['maxLen:128','email'],
			validation_events:'submit',
			}
		},

		'---',

		{
			tag:'a-form-row',
			caption:$department,
			html:{
			tag:'a-input',
			name:'department',
			value:u.department,
			width:350,
			validation:['maxLen:64'],
			}
		},

		{
			tag:'a-form-row',
			caption:$position,
			html:{
			tag:'a-input',
			name:'position',
			value:u.position,
			width:350,
			validation:['maxLen:64'],
			}
		},


		{
			tag:'a-form-row',
			caption:$info,
			html:{
				tag:'a-textarea',
				name:'info',
				value:u.info,
				height:150
			}
		},

		'---',


		{
			tag:'a-form-row',
			html:{
			tag:'a-label',
			disabled:true,
			caption:$receive_email,
				html:{
					tag:'a-checkbox',
					name:'receive_email',
					value:u.receive_email,
				}
			}

		},

		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$receive_telegram,
				disabled:true,
				html:{
					tag:'a-checkbox',
					name:'receive_telegram',
					value:u.receive_telegram,
				}
			}

		},
		
		
		{
			tag:'a-form-row',
			html:{
				tag:'a-label',
				caption:$receive_sms,
				disabled:true,
				html:{
					tag:'a-checkbox',
					name:'receive_sms',
					value:u.receive_sms,
				}
			}

		},

		// '---',
		// {
		// 	tag:'a-form-row',
		// 	caption:$menu,
		// 	html:{
		// 	tag:'a-select',
		// 	name:'menu',
		// 	list:menus,
		// 	sort:'asc',
		// 	undefined:$default,
		// 	value:u.menu,
		// 	}
		// },
		
	
	];


	form=pult.drawForm(dom.form,s,{
		cancel:!newUser,
		submit:newUser?$create_user:true,
		passwordConfirmation:true,
		convertUndefinedToNull:true,

		onchange:function(c){
			pult.needSave=true;
			if(c.name==='admin'){
				if(c.value){
					c.value=false;
					pult.showConfirm(self,$make_admin,function(){
						c.value=true;
						form.dom.editor_access.value=true;
						form.dom.edacs.disabled=true;
					});
				}else{
					form.dom.editor_access.value=false;
					form.dom.edacs.disabled=false;
				}
			}
		},
		oncancel:function(){
			pult.needSave=false;
			pult.reloadWidget();
		},

		onsubmit:function (data){		

			if(newUser){
				pult.request(self,'user_create',data,function(req,res,err){
					if(err){
						pult.showError(self,err);
						form.reset();
					}else{
						form.complete();
						pult.needSave=false;

						let f=pult.showInfo(self,{
							caption:$user_created,
							submitFocus:false,
							cancel:$done,
							width:300,
							submit:$copy,
							hideOnSubmit:false,
							onsubmit:function (e){
								let text=e.target.dom._text.innerText;
								Util.copyText(text);
								f.reset();
							},
							oncancel:function (e){
								pult.navigate('#interface/users');
							},
							html:Util.format($user_created_text,data),
						});
					}
				});
			}else{
				pult.request(self,'user_save',data,function(req,res,err){
					if(err){
						pult.showError(self,err);
						form.reset();
					}else{
						form.complete();
						pult.needSave=false;
						self.login=data.new_login;
					}
				});
			}


		}

	});

}


function resetPassword(){

	let password=aPassword.temppass();
  
	let input=`<br/><br/>
	<a-password 
		name='password' 
		show_password=1 
		width='100%' 
		validation='["notEmpty","minLen:${config.password_min_size}"]' 
		validation_events='submit' 
		value='${password}'>
	</a-password>
	<br/>
	<br/>
	<a-label caption='${$request_changepass}'><a-checkbox name='changepass' value=1></a-checkbox></a-label>
	`;
	
	let f=pult.showForm(self,{
		caption:$reset_password,
		submit:$reset_password,
		hideOnSubmit:false,
		width:350,
		html:$reset_password_text+input,
		onsubmit:function(e){
			pult.request(self,'user_resetpass',{
				login:login,
				password:e.detail.password,
				changepass:e.detail.changepass,
			},function(req,res,err){
				if(err){
					pult.showError(self,err);
					f.reset();
				}else{
					dom.password_reseted.innerHTML=Util.format($temp_password,e.detail.password)+`
					<a-button style='vertical-align: middle' text-color='var(--app-text-color)' width=16 height=16 icon='/images/copy.svg')'></a-button>
					`;
					let b=dom.password_reseted.querySelector('a-button');
					b.onclick=function(){
						Util.copyText(e.detail.password);
						pult.showTooltip(self,$copied);
					}
					dom.password_reseted.hidden=false;
					form.dom['changepass'].value=true;
					f.complete();  
				}
			});
		}
	});

	// let f=pult.showConfirm(self,{
	// 	html:Util.format($reset_password_text,password),
	// });
}