/*--PSEUDO-CODE--*/

if(locale('ru')){
    var $title='Пользователи';
    var $system='Система';
    var $total='Всего';
    var $selected='Выбрано';
    var $cancel='Отмена';
    var $filter='Фильтр';
    var $delete='Удалить';
    var $login='Логин';
    var $admin='Админ';
    var $access='Доступ';
    var $blocking='Блокировка';
    var $status='Статус';
    var $time='Время';
    var $journal='Журнал';
    var $name='Имя';
    var $position='Должность';
    var $department='Отдел';
    var $phone='Телефон';
    var $email='Емайл';
    var $browser='Браузер';
    var $sessions='Сессии';
    var $online='Онлайн';
    var $offline='Офлайн';
    var $block='Заблокировать';
    var $unblock='Разблокировать';
    var $add='Добавить';
    var $delete_users="Удалить пользователей";
    var $delete_help="Выбранные пользователи (%s) будут удалены";
    var $delete_success='Удален';
    var $block_users="Заблокировать пользователей";
    var $block_help="Выбранные пользователи (%s) будут разлогинены и заблокированы. Доступ пользователей к системе будет закрыт до разблокировки.";
    var $block_success='Заблокирован';
    var $unblock_users="Разблокировать пользователей";
    var $unblock_help="Выбранные пользователи (%s) будут разблокированы. Доступ пользователей к системе будет восстановлен.";
    var $unblock_success='Разблокирован';
    var $projects='Проекты';
    var $readonly='R/O';
    var $editor='Редактор';
    
}else{

    var $title='Users';
    var $system='System';
    var $total='Total';
    var $selected='Selected';
    var $cancel='Cancel';
    var $filter='Filter';
    var $delete='Delete';
    var $login='Login';
    var $admin='Admin';
    var $blocking='Blocking';
    var $status='Status';
    var $time='Time';
    var $access='Access';
    var $journal='Journal';
    var $name='Name';
    var $position='Position';
    var $department='Department';
    var $phone='Phone';
    var $email='Email';
    var $browser='Browser';
    var $sessions='Sessions';
    var $online='Online';
    var $offline='Offline';
    var $block='Block';
    var $unblock='Unblock';
    var $add='Add';
    var $delete_users="Delete users";
    var $delete_help='Selected users (%s) will be deleted';
    var $delete_success='Deleted';
    var $block_users="Block users";
    var $block_help="The selected users (%s) will be unlogged and blocked. Users' access to the system will be denied until they are unblocked.";
    var $block_success='Blocked';
    var $unblock_users="Unblock users";
    var $unblock_help="The selected users (%s) will be unblocked. Users' access to the system will be restored.";
    var $unblock_success='Unblocked';
    var $projects='Projects';
    var $readonly='R/O';
    var $editor='Editor';

    
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<div id="pult_header">
  <div class="pult_split pult_sep" id="filter_bar">
    <a-button id='btn_add' caption=${$add}></a-button>
    <a-input class="pult_filter" clear_button=1 debounce=300 id='filter' placeholder=${$filter}></a-input>
  </div>

  <div class="pult_split  pult_sep"  id="buttons_bar">
    <div class="pult_buttons">
      <a-button id='btn_delete' caption=${$delete}></a-button>
      <a-button id='btn_block' caption=${$block}></a-button>
      <a-button id='btn_unblock' caption=${$unblock}></a-button>
    </div>
    <a-button id='btn_clear' class="pult_cancel"  icon='/images/clear.svg' caption=${$cancel}></a-button>
  </div>    
</div>
<div id="pult_content">
  <a-grid  class="pult_grid" id='grid'></a-grid>
</div>`,
);

PROPERTIES=['filter'];

let users=[];

let form;
let sub;
let grid;


ONCREATE=function(){
	
	pult.showHeader(self);
	pult.showName(self,$title,"/images/users.svg");
	pult.showPath(self,[[$system,'#interface/system'],[$title,'#interface/users']]);
	pult.selectMenuItem(self,'/system/users');
	
	dom.btn_clear.onclick=clear;
	dom.btn_delete.onclick=show_form_delete;
	dom.btn_block.onclick=show_form_block;
	dom.btn_unblock.onclick=show_form_unblock;
	dom.btn_add.href='/#interface/user';

	dom.filter.onchange=function(e){
		console.log('ввод',e.detail);
		self.filter=e.detail;
	}


 
	drawTable();
	refreshButtons();
	loadUsers();

	sub=pult.subscribe('user_update',null, function (s,p){
		if(p?.data){
			let u=getRow(p.data);
			let index=grid.findRow('login',u.login);
			if(index>=0){
				grid.records[index]=u;
				grid.refreshRow(index);
			}
		}
	});
	
	
}

ONDESTROY=function(){
	pult.unsubscribe(sub);
}

ONUPDATE=function(changes){

	if(changes.hasOwnProperty('sort') || changes.hasOwnProperty('order')){
		refreshSort();
	}
	
	if(changes.hasOwnProperty('filter')){
		refreshFilter();
	}
		
}


function refreshFilter(){
	let f=self.__filter;
	dom.filter.value=f;
	dom.grid.filter = [f];
	setTimeout(function(){
		refreshButtons();
	},100);
}
	
function refreshSort(){
	let sort=self.__sort ||  1; // login
	let order=self.__order ||  'asc';
	grid.sort_column=sort;
	grid.sort_order=order;
}
	


function refreshButtons(){
	
	if(grid.selection.length){
		pult.showCount(self,grid.selection.length,$selected);
		dom.buttons_bar.style.display='';
		dom.filter_bar.style.display='none';
	}else{
		if(dom.filter.value){
			pult.showCount(self,dom.grid.filter_count,$filter);
		}else{
			pult.showCount(self,dom.grid.filter_count);
		}
		dom.buttons_bar.style.display='none';
		dom.filter_bar.style.display='';
	}
	
}

function clear(){
	grid.unselect();
}

function getRow(u){
	if(!u.icon) u.icon="/images/user.svg";
	u._access=!u.blocked;
	u._admin=!!u.admin;
	u._editor_access=!!u.editor_access;
	u._readonly=!!u.readonly;
	u._status=u.active_sessions?$online:$offline;
	u._time=u.active_sessions?u.last_connected:u.last_disconnected;
	u._selected=is_selected(u.login);
	u._projects=[];

	Util.sort(u.projects);

	for(let i=0; i<u.projects.length; i++){
		let p=u.projects[i];
		let link=`<a target='_blank' href='${pult.getProjectInterfaceLink(p)}'>${p}</a>`;
		u._projects.push(link);
	}

	return u;
}

function loadUsers(){

		pult.request(self,"user_list",null,function (req,res,err) {

		if(err){
			pult.showModalError(self,err);
		}else{

			users=[];
			
			for(let i=0; i<res.length; i++){
				let u=res[i];
				let r=getRow(u);
				users.push(r);
			}
			
			grid.records=users;

			setTimeout(function(){
				refreshButtons();
			},100);

		}
		});
}

function is_selected(login) {
	for(let i=0; i<grid.selection.length; i++){
		let u=grid.records[grid.selection[i]];
		if(u.login===login) return true;
	}
}



function drawTable(){

	grid=dom.grid;
	grid.checkbox=true;

	let columns=[
		{
			key:'login',
			caption:$login,
			format:grid.getIconFormat('${icon}','${login}','#interface/user?login=${login}'),
			onrender:function (value,record,column,index,row,cell,refresh) {
				row.classList.toggle("online",!!record.active_sessions);
				row.classList.toggle("offline",!record.active_sessions);
				row.classList.toggle("error",!!record.error);
				row.classList.toggle("blocked",!!record.blocked);
			},
		},
		{
			key:'_access',
			caption:$access,
		},
		{
			key:'_admin',
			caption:$admin,
		},
		{
			key:'_editor_access',
			caption:$editor,
		},
		{
			key:'_readonly',
			caption:$readonly,
		},
		{
			key:'name',
			caption:$name,
		},
		{
			key:'position',
			caption:$position,
		},
		{
			key:'department',
			caption:$department,
		},
		{
			key:'phone',
			caption:$phone,
		},
		{
			key:'email',
			caption:$email,
		},

		{
			key:'_status',
			caption:$status,
		},
		{
			key:'_time',
			format:'$datetimelong',
			caption:$time,
			sort_by_format:false,
		},
		{
			key:'active_sessions',
			caption:$sessions,
		},
		{
			key:'last_ip',
			caption:'IP',
		},
		{
			key:'last_browser',
			caption:$browser,
		},
		{
			key:'_journal',
			caption:$journal,
			export:false,
			format:"<a href='#interface/journal?user=${login}'>"+$journal+"</a>"
		},
		{
			key:'_projects',
			caption:$projects,
		},
		
	];

	grid.store_key="interface_users";
	grid.export_title=$title;
	grid.sort_column=1;
	grid.row_height=32;
	grid.columns=columns;
	grid.sort_action='external';
	grid.css=`.row.online,.row.online a{color:var(--app-online-color)}.row.online a-icon{--color:var(--app-online-color)}.row.offline,.row.offline a{color:var(--app-offline-color)}.row.offline a-icon{--color:var(--app-offline-color)}.row.error,.row.error a{color:var(--app-error-color)}.row.error a-icon{--color:var(--app-error-color)}.row.blocked .c1{text-decoration:line-through}.cell a::before{content:none}`;
	grid.records=[];
	grid.drawColumns();

	grid.onselect=refreshButtons;

	grid.onsort=function(e){
		let s=e.detail;
		self.__sort=s.column;
		self.__order=s.order;
	}
			
}


function show_form_delete(){

	let f=pult.showBatchForm(self,{
		
		caption:$delete_users,
		html:Util.format($delete_help,grid.selection.length),
		submit: $delete,

		onsubmit:function(data){
			console.log('submit',data);
			
			let rr=[];
			for(let i=0; i<grid.selection.length; i++){
				let u=grid.records[grid.selection[i]]; 
				rr.push(['user_delete',{
					login:u.login
				}]);
			}

			pult.rpc.requests(rr,function(reqs,ress,errs){
				loadUsers();
				if(errs.count){
					for(let i=0; i<reqs.length; i++){
						f.result(reqs[i][1].login,errs[i],$delete_success);
					}
					f.hideSubmit();
				}else{
					grid.unselect();
					f.hide();
				}
			});

		}

	});

}

function show_form_block(){
	
	let f=pult.showBatchForm(self,{
		
		caption:$block_users,
		html:Util.format($block_help,grid.selection.length),
		submit: $block,

		onsubmit:function(data){
			
			let rr=[];
			for(let i=0; i<grid.selection.length; i++){
				let u=grid.records[grid.selection[i]];  
				rr.push(['user_block',{
					login:u.login
				}]);
			}

			pult.rpc.requests(rr,function(reqs,ress,errs){
				loadUsers();
				if(errs.count){
					for(let i=0; i<reqs.length; i++){
						f.result(reqs[i][1].login,errs[i],$block_success);
					}
					f.hideSubmit();
				}else{
					f.hide();
				}
			});


		}

	});

}

function show_form_unblock(){
	
	let f=pult.showBatchForm(self,{
		
		caption:$unblock_users,
		html:Util.format($unblock_help,grid.selection.length),
		submit: $unblock,

		onsubmit:function(data){
			console.log('submit',data);
			
			let rr=[];
			for(let i=0; i<grid.selection.length; i++){
				let u=grid.records[grid.selection[i]];  
				rr.push(['user_unblock',{
					login:u.login
				}]);
			}

			pult.rpc.requests(rr,function(reqs,ress,errs){
				loadUsers();
				if(errs.count){
					for(let i=0; i<reqs.length; i++){
						f.result(reqs[i][1].login,errs[i],$unblock_success);
					}
					f.hideSubmit();
				}else{
					f.hide();
				}
			});

		}

	});

}
	