/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $title="Переменные";
  var $var="Переменная";
  var $title_system="Служебные переменные";
  var $title_screen="Переменные экрана";
  var $title_node="Переменные узла";
  var $title_gateway="Переменные шлюза";
  var $title_project="Переменные проекта";
  // var $load_vars="Загрузка переменных";
  // var $load_nodes="Загрузка узлов";
  var $load_vars="Загрузка";
  var $load_nodes="Загрузка";
  var $menu_add="Добавить";
  var $node="Узел";
  var $project="Проект";
  var $name="Имя";
  var $description="Описание";
  var $driver="Драйвер";
  var $value="Значение";
  var $path="Путь";
  var $unit="Ед";
  var $time="Время";
  var $error="Ошибка";
  var $new_value="Новое значение";
  var $trend="Тренд";
  var $filter="Фильтр";
  var $vars="Переменные";
  var $open_trends="Тренды";
  var $open_logs="Лог";
  var $open_slice="Срез";
  var $open_report="Отчет";
  var $type="Тип";
  var $clear_select="Сбросить выбор";
  var $comment="Комментарий";
  var $cancel="Отмена";
  var $total="Всего";
  var $filter="Фильтр";
  var $selected="Выбрано";
  var $select="Выбор";
  var $type="Тип";
  var $physical="Физическая переменная";
  var $ph="Ф";
  var $tags="Теги";
  var $filter_tags="Фильтр по тегам";
  var $only_trends="Фильтр по трендам";
  var $global_name="Глобальное имя";
}else{
  var $title="Variables";
  var $var="Variable";
  var $title_system="System variables";
  var $title_screen="Screen variables";
  var $title_gateway="Gateway vars";
  var $title_node="Node variables";
  var $title_project="Project variables";
  // var $load_vars="Loading variables";
  // var $load_nodes="Load nodes";
  var $load_vars="Loading";
  var $load_nodes="Loading";
  var $menu_add="Add";
  var $node="Node";
  var $project="Project";
  var $name="Name";
  var $description="Description";
  var $driver="Driver";
  var $value="Value";
  var $path="Path";
  var $unit="Ед.";
  var $time="Time";
  var $error="Error";
  var $new_value="New value";
  var $trend="Trend";
  var $filter="Filter";
  var $vars="Variables";
  var $open_trends="Trends";
  var $open_log="Logs";
  var $open_slice="Slice";
  var $open_report="Report";
  var $notrends="Variables not selected";
  var $type="Type";
  var $clear_select="Reset select";
  var $comment="Comment";
  var $cancel="Cancel";
  var $total="Total";
  var $filter="Filter";
  var $selected="Selected";
  var $select="Select";
  var $type="Type";
  var $physical="physical var";
  var $ph="P";
  var $tags="Tags";
  var $filter_tags="Filter by tags";
  var $only_trends="Filter by trends";
  var $global_name="Global name";
}


PROTO=widgetInterfaceProtoCommon;

TEMPLATE = createTemplate(
	``,
	`<div id="pult_header">
	<div class="pult_split pult_sep"  id="buttons_bar">
		<div class="pult_buttons">
			<a-button id='btn_open_trends' caption=${$open_trends}></a-button>
			<a-button id='btn_open_logs' caption=${$open_logs}></a-button>
			<a-button id='btn_open_slice' caption=${$open_slice}></a-button>
			<a-button id='btn_open_report' caption=${$open_report}></a-button>
		</div>
		<a-button  class="pult_cancel" id='btn_clear' icon='/images/clear.svg'  caption=${$cancel} title=${$clear_select}></a-button>
	</div>
	<div class="pult_split"  id="filter_bar">
		<div>
			<a-input clear_button=1 debounce=300 placeholder=${$filter} id='filter'></a-input>
			<a-button id='btn_filter_trends' icon='/images/trends.svg' title="${$only_trends}""></a-button>
		</div>
	</div>
</div>
<a-grid id="grid"></a-grid>`,
);

PROPERTIES=[
	{
		key:'path',
		default:'/system',
		propagate:false,
	},
	{
		key:'filter_trends',
		type:'boolean'
	},
	'filter',
	'select',
	'list',
];


ONCREATE=create;
ONDESTROY=destroy;
ONUPDATE=update;

let sub;
let vars;
let nodes;
let index;
let names;
let indexes;
let grid;
let updates=0;

function create(){

	dom.buttons_bar.style.display='none';

	dom.filter.onchange=function(e){
		self.filter=e.detail;
	}

	dom.btn_clear.onclick=function (){
		grid.unselect();
	}

	dom.btn_filter_trends.onclick=function (){
		//pult.hash.only_trends=pult.hash.only_trends?0:1;
		self.filter_trends = self.filter_trends ? undefined : true;
		refreshButtons();
		update_filter();
	}
	

	drawTable();

}

function destroy(){
	pult.unsubscribeStatusVar(self);
	unsubscribe();
}

function update(changes){
	//console.log(changes);
	for(let k in changes){
		if(k==='path' || k==='list') update_path(changes[k]);
		if(k==='filter')		update_filter(changes[k]);
		if(k==='filter_trends')	update_filter(changes[k]);
		if(k==='select')		update_select(changes[k]);
	}
}

function update_filter(v){
	let f=self.filter;
    dom.filter.value=f;
    let ff=[f];
	if(self.filter_trends) ff.push({column:'_trend',filter:1,type:'number',format:false});
    dom.grid.filter = ff;
	refreshButtons();
}

function update_select(v){
	grid.___nosel=true;

	if(vars){
		grid.unselect();
		if(vars.length){
			let sel=[];
			let s=self.select;
			let ss=[];
			if(s) ss=s.split(',');
			for(let i=0; i<ss.length; i++){
				let vn=ss[i];
				let vi=names[vn];
				if(vi!==undefined){
					sel.push(vi);
				}
			}
			grid.select(sel);
		}
		refreshButtons();
	}

	grid.___nosel=false;
}

function update_path(path){
	
	updates=0;
	pult.abort(self);

	pult.unsubscribeStatusVar(self);

	if(self.path){

		pult.showObject(self,self.path,$title,function (o){
			pult.subscribeStatusVar(self,o._status_var,function (v){self.status=v});
			drawColumns();
			loadVars(o._path,self?.list?.split(','));
		});
		
	}else{

		pult.showPath(self,[
			[$system,'#interface/system'],
			[$title,'#interface/vars'],
		]);
		pult.showHeader(self,true);
		pult.showName(self,$title,"/images/var.svg");
		pult.showCaption(self,null);
		pult.selectMenuItem(self,'/system/vars');
		
		drawColumns();
		loadVars();
	}


}

function refreshButtons(){

	if(self.filter_trends){
		dom.btn_filter_trends.palette='anode-button-checked';
	}else{
		dom.btn_filter_trends.palette=undefined;
	}

	if(grid.selection.length){

		let trends=false;
		let vv=[];
		for(let i=0; i<grid.selection.length; i++){
			let v=vars[grid.selection[i]];
			if(v.trend){
				vv.push(v._global_name);
				trends=true;
			}
		}
		dom.btn_open_trends.href=`#interface/trends?${self.path ? 'path='+self.path+'&' : ''}vars=${vv.join(',')}`;
		dom.btn_open_logs.href=`#interface/trendlog?${self.path ? 'path='+self.path+'&' : ''}vars=${vv.join(',')}`;
		dom.btn_open_slice.href=`#interface/trendslice?${self.path ? 'path='+self.path+'&' : ''}vars=${vv.join(',')}`;
		dom.btn_open_report.href=`#interface/trendreport?${self.path ? 'path='+self.path+'&' : ''}vars=${vv.join(',')}`;

		dom.btn_open_trends.disabled=!trends;
		dom.btn_open_logs.disabled=!trends;
		dom.btn_open_slice.disabled=!trends;
		dom.btn_open_report.disabled=!trends;

		pult.showCount(self,grid.selection.length,$selected);
		dom.buttons_bar.style.display='';
		dom.filter_bar.style.display='none';
	}else{
		if(self.filter || self.filter_trends){
			pult.showCount(self,grid.filter_count,$filter);
		}else{
			pult.showCount(self,grid.records.length);
		}
		dom.buttons_bar.style.display='none';
		dom.filter_bar.style.display='';
	}

	
}

function drawTable(){

	grid=dom.grid;

	grid.onchange=function (e) {

		let d=e.detail;
	
		if(d.key==='_value'){
			let v=d.record;
			let name=v._global_name;
			let value=d.value;
			pult.setVar(self,name,value,null,function (err){
				if(err){
					v._value=d.oldValue;
				}
				grid.refreshRow(d.recordIndex);
			});
		}
	
	};

	grid.onselect=function (){
		if(grid.___nosel) return;
		let ss=[];
		for(let i=0; i<grid.selection.length; i++){
			let vi=grid.selection[i];
			let v=vars[vi];
			ss.push(v._global_name);
		}
		self.select=ss.join(',');
	}
	
	grid.store_key="interface_vars";
	grid.export_title=$title;
	grid.css=`.row.enabled{color:var(--app-text-color)}.row.enabled .cell.c0 span{background:0 0;border:1px solid var(--app-text-color)}.row ._name{cursor:pointer}.row ._name:hover{text-decoration:underline dashed;color:var(--app-active-text-color)}.row.error,.row.error .cell a{color:var(--app-error-color)}.row.notrend .cell.c0 a-checkbox{display:none}.row.updated{animation-name:key_updated;animation-duration:.5s;animation-iteration-count:1}.row.updated .cell,.row.updated .cell a{animation-name:key_text_updated;animation-duration:.3s;animation-iteration-count:1}@keyframes key_text_updated{0%{color:var(--app-active-text-color)}}@keyframes key_updated{0%{background:var(--app-grid-flash-color)}100%{background:0 0}}`;
	grid.records=[];
}

function drawColumns(){

	let ext=Util.getFileExt(self.path);
	let is_project=!!self.path;
	let is_node=(ext==='node' || ext==='gateway');
	let node_widget=(ext==='gateway' ? '#interface/gateway' : '#interface/node');

	let columns=[];

	columns.push(
		{
			key:'_trend',
			caption:'T',
			tooltip:$trend,
		},
		{
			key:'_physical',
			caption:$ph,
			tooltip:$physical,
		},
	);

	if(!is_project){
		columns.push({
				key:'_project',
				caption:$project,
				format:'<a href="#interface/project?path=${_project_path}">${_project}</a>',
				onrender:function (value,record,column,index,row,cell,refresh) {
					let v=record;
					let n=nodes[v.nodeindex];
					let pp=pult.getProjectPath(n.path);
					cell.innerHTML=`<a href="#interface/project?path=${pp}">${v._project}</a>`;
				},
		});
	}

	if(!is_node){
		columns.push({
			key:'_pseudo_path',
			caption:$node,
			ignore_select:true,
			onrender:function (value,record,column,index,row,cell,refresh) {
				let v=record;
				let n=nodes[v.nodeindex];
				cell.innerHTML=`<a href="${node_widget}?path=${n.path}">${v._pseudo_path}</a>`;
			},
		});
	}

	columns.push(
		{
			key:'_global_name',
			caption:$global_name,
			hidden:true,
			//onclick:showInfo,
		},
		{
			key:'name',
			caption:$name,
			hidden:true,
		},
		{
			caption:$var,
			key:'_description',
			class:'_name',
			onclick:showInfo,
		},
	);
	
	columns.push(		
		{
			key:'_value',
			caption:$value,
			edit:'number',
			align:'right',
			width:180,
			editor_save_by_exit:true,
			editor_move_down_by_enter:false,
			onrender:function (value,record,column,index,row,cell,refresh) {
				if(record._error){
					row.classList.toggle("enabled",0);
					row.classList.toggle("error",1);
				}else{
					row.classList.toggle("enabled",1);
					row.classList.toggle("error",0);
				}
				if(refresh){
					if(updates>1){
						row.classList.remove('updated');
						row.classList.add('updated');
					}
				}
			},
		},
		{
			key:'unit',
			caption:$unit,
		},
		{
			key:'_time',
			format:'$datetimelong',
			caption:$time,
			sort_order:'desc',
		},
		{
			key:'_error',
			caption:$error,
		},
		{
			key:'tags',
			caption:$tags,
		},
		{
			key:'comment',
			caption:$comment,
		},
	);

	//grid.onselect=gridOnSelect;

	grid.checkbox=true;
	grid.columns=columns;
	grid.drawColumns();
}

function loadVars(path,list){

	pult.showLoading(self);

	let params={};
	if(list){
		params={list:list};
	}else{
		params={path:path};
	}

	pult.loadVars(self,params,function (vv,nn){

		vars=[];
		index={};
		names={};
		indexes=[];

		pult.hideLoading(self);
		vars=vv;
		nodes=Util.ato(nn,'index');
		//console.log(vv,nn);
		for(let i=0; i<vars.length; i++){
			let v=vars[i];
			let n=nodes[v.nodeindex];
			v._description=v.description || v.name;
			v._global_name=n.prefix+'_'+v.name;
			v._project_name=v._global_name.substring(v._global_name.indexOf('_')+1);
			v._trend=!!v.trend ? true : undefined;
			v._physical=!!v.physical ? true : undefined;
			v._pseudo_path=pult.getPseudoPath(n.path,undefined,2);
			v._project=pult.getProjectName(n.path);

			indexes.push(v.index);
			index[v.index]=i;
			names[v._global_name]=i;
		}
		dom.grid.records=vars;
		subscribe(path,list);
		update_select();
		refreshButtons();

		window.test_index=index;
		window.test_vars=vars;

	});
	
}

function subscribe(path,list){

	unsubscribe();

	sub=pult.subscribe('var_update',{
		vars:indexes,
		only_last:true,
		as_index:true,
	},function (s,p){
		if(p?.close){
			if(p?.error?.code===DRV_ERROR_UPDATE_SUBSCRIPTION){
				loadVars(path,list);
			}
		}else{
			let time=p?.data?.time;

			updates++;
			
			for(let i=0; i<p?.data?.changes?.length; i++){
				let ch=p.data.changes[i];
				
				let idx=index[ch[0]];
				let v=vars[idx];
				
				if(v){
					time+=ch[1];
					let value=ch[2];
					let error=ch[3];

					if(v.round!==undefined) value=value.toFixed(v.round);
					error=pult.errstr(error);

					grid.setRecordValue(idx,'_time',time);
					grid.setRecordValue(idx,'_value',value*1);
					grid.setRecordValue(idx,'_error',error);
					//grid.setRecordValue(idx,'payload',payload);

					grid.refreshRow(idx);

				}
				//console.log(p.data.time,ch);
			}
		}
	});
}

function unsubscribe(){
	pult.unsubscribe(sub);
}

function recurse(obj, level=0) {
    if (typeof obj === 'object') {
        return Object.keys(obj).map((key) => `${key}: ${recurse(obj[key])}`).join(',\n');
    } else if (Array.isArray(obj)) {
        return `[${obj.map((item) => recurse(item)).join(', ')}]`;
    } else {
        return String(obj);
    }
}

function showInfo(ri){
	let v=vars[ri];
	pult.request(self,'var_info',{
		var:v._global_name,
	},function (req,res,err){
		if(err){
			pult.showModalError(self,err);
		}else{
			let x={};
			x.global_name=v._global_name;
			x.project_name=v._project_name;
			x.local_name=v.name;
			Util.merge(x,res);
			let name=x.name;
			delete(x.name);
			delete(x.active);
			delete(x.alarm);
			delete(x.nodeid);
			delete(x.varid);
			delete(x.physical);
			delete(x.trend);
			pult.showInfo(self,{
				caption:name,
				submit:false,
				width:500,
				html:`<pre>${Util.printObject(x,'    ',false,false)}</pre>`,
				css:`pre{margin:0;padding:15px}._text{padding:0!important}`,
			});
		}
	});
	
}